SystemOrganization addCategory: #KEGGeneratorBaseTest!

!KEGSequenceableCollectionTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/2/2013 20:32'!
testasStreamGeneratorOnC "asStreamGeneratorOn: aGenerator"

	"Method Version: keg2.  "
	" Copyright Kjell E God Oct  1 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today December 15 1999, Oct  1 1999"

								"MT b:#asStreamGeneratorOn: s:self.""

	aGenerator on: self .

								""MT e:#asStreamGeneratorOn: s:self.""
	^aGenerator .

	""Set self into aGenerator.   aGenerator should be of the class KEGGenerator or an
	equivalent and be on a Stream which is on a Collection.  We will replace this
	Collection with self. KEG2: Moved this method from Object to SequenceableCollection."

	( self assert:( 
		( #(  ) asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #(  )
		) description:( '( #(  ) asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #(  )' ) ).

	( self assert:( 
		( #( 1 ) asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 )
		) description:( '( #( 1 ) asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 )' ) ).

	( self assert:( 
		( #( 1 2 ) asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 2 )
		) description:( '( #( 1 2 ) asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 2 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 ) asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 2 3 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asOrderedCollection asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 ) asOrderedCollection asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 2 3 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asSortedCollection asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 ) asSortedCollection asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 2 3 )' ) ).

! !

!KEGStreamTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/2/2013 20:34'!
testasGenerator "asGenerator "

        "Method Version: keg1.  "
        "Copyright Kjell E God Date today"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today "

	"Return a KEGGenerator on self."
							"( MT b:#asGenerator s:self  ).""
	^(
		( KEGGenerator on: self )

	)""return:(					MT e:#asGenerator s:self )."

	( self assert:(
		#(  ) readStream asGenerator asArray = #(  )  "<------------------------------------------[ asArray is optimized ]"
		) description:( '#(  ) readStream asGenerator asArray = #(  )' ) ).

	( self assert:(
		#(  ) readStream asGenerator asOrderedCollection asArray = #(  ) "<-------------[ asOrderedCollection is not ]"
		) description:( '#(  ) readStream asGenerator asOrderedCollection asArray = #(  )' ) ).

	( self assert:(
		#( 1 ) readStream asGenerator asArray = #( 1 )  "<---------------------------------------[ asArray is optimized ]"
		) description:( '#( 1 ) readStream asGenerator asArray = #( 1 )' ) ).

	( self assert:(
		#( 1 ) readStream asGenerator asOrderedCollection asArray = #( 1 ) "<----------[ asOrderedCollection is not ]"
		) description:( '#( 1 ) readStream asGenerator asOrderedCollection asArray = #( 1 )' ) ).

	( self assert:(
		#( 1 2 ) readStream asGenerator asArray = #( 1 2 )  "<----------------------------------[ asArray is optimized ]"
		) description:( '#( 1 2 ) readStream asGenerator asArray = #( 1 2 )' ) ).

	( self assert:(
		#( 1 2 ) readStream asGenerator asOrderedCollection asArray = #( 1 2 ) "<-----[ asOrderedCollection is not ]"
		) description:( '#( 1 2 ) readStream asGenerator asOrderedCollection asArray = #( 1 2 )' ) ).
	
	( self assert:(
		#( 1 2 3 ) readStream asGenerator asArray = #( 1 2 3 )  "<----------------------------------[ asArray is optimized ]"
		) description:( '#( 1 2 3 ) readStream asGenerator asArray = #( 1 2 3 )' ) ).

	( self assert:(
		#( 1 2 3 ) readStream asGenerator asOrderedCollection asArray = #( 1 2 3 ) "<-----[ asOrderedCollection is not ]"
		) description:( '#( 1 2 3 ) readStream asGenerator asOrderedCollection asArray = #( 1 2 3 )' ) ).


! !

!KEGObjectTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/1/2013 20:10'!
testasGenerator "asGenerator "

        "Method Version: keg1.  "
        "Copyright Kjell E God June 19, 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today June 19, 1999"
				"( MT b:#asGenerator s:self ).""
	^(
		( self asSingletonGenerator )

	)""return:( 		MT e:#asGenerator s:self  )."

	"Return a KEGGenerator on self.  This method is implemented by the subClass if you
	want to do anything other than just wrap self in a Generator.  The main purpose
	of this method is to allow all Objects to participate in the KEGGenerator protocals."

	
	( self assert:(
		1 asGenerator asArray = #( 1 )
		) description:( '1 asGenerator asArray = #( 1 )' ) )
	! !

!KEGObjectTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/1/2013 20:15'!
testasReversedGenerator "asReversedGenerator"

        "Method Version: keg3.  "
        " Copyright Kjell E God Mar 7 1994"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today tradePrint 20030324, July 26 1999, Mar 7 1994"
	"<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 3 >>""
    | stream |
							""( MT b:#asReversedGenerator s:self ).""

	( ( self respondsTo: #asReadOnlyStream ) ifFalse:[ ^( nil )""return:( MT e:#asReversedGenerator s:self )"" ] ).
	( stream := self asReadOnlyStream ).
	""( ( ( stream respondsTo: #setToEnd )and:[ stream respondsTo: #previous ] ) ifFalse:[ ^( nil )""return:( MT e:#asReversedGenerator s:self )"" ] ).""
	^(
		( KEGAbstractGenerator new
			generator:( stream ) ; ""<---[ To make self This Method compatible with the headwaters protocal.  But it screws up KEGGenerator>>asArray: so use >>asOrderedCollection ]""
			resetBlock:[ stream setToEnd ] ""<---[ Remember that Generators on Streams behave just like the Streams they are on due to KEGGenerator>>doesNotUnderstand: ]""
			nextBlock:[ stream previous ] )

	)""return:( 					MT e:#asReversedGenerator s:self )"

	"Return a Generator which is self reversed.  
	KEG: This was moldering down in Collection but it has been moved up here
	so that Stream can use it too. (|KEG3-: Add the generator: call so as to make
	self-:( this method ) compatible with the headwaters protocal. )"


	( self assert:(
		#(  ) asReversedGenerator asOrderedCollection asArray = #(  )
		) description:( '#(  ) asReversedGenerator asOrderedCollection asArray = #(  )' ) ).

	( self assert:(
		#( 1 ) asReversedGenerator asOrderedCollection asArray = #( 1 )
		) description:( '#( 1 ) asReversedGenerator asOrderedCollection asArray = #( 1 )' ) ).

	( self assert:(
		#( 1 2 ) asReversedGenerator asOrderedCollection asArray = #( 2 1 )
		) description:( '#( 1 2 ) asReversedGenerator asOrderedCollection asArray = #( 2 1 )' ) ).

	( self assert:(
		#( 1 2 3 ) asReversedGenerator asOrderedCollection asArray = #( 3 2 1 )
		) description:( '#( 1 2 3 ) asReversedGenerator asOrderedCollection asArray = #( 3 2 1 )' ) ).

	( self assert:(
		#( 1 2 3 ) asSet asReversedGenerator asOrderedCollection asArray = #( 3 2 1 )
		) description:( '#( 1 2 3 ) asSet asReversedGenerator asOrderedCollection asArray = #(  )' ) ).

	( self assert:(
		#( 1 2 3 ) readStream asReversedGenerator asOrderedCollection asArray = #( 3 2 1 )
		) description:( '#( 1 2 3 ) readStream asReversedGenerator asOrderedCollection asArray = #( 3 2 1 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asReversedGenerator on: #(  ) ) asOrderedCollection asArray = #(  )
		) description:( '( #( 1 2 3 ) asReversedGenerator on: #(  ) ) asOrderedCollection asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 3 ) asReversedGenerator on: #( 4  ) ) asOrderedCollection asArray = #( 4 )
		) description:( '( #( 1 2 3 ) asReversedGenerator on: #( 4  ) ) asOrderedCollection asArray = #( 4 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asReversedGenerator on: #( 4 5 ) ) asOrderedCollection asArray = #( 5 4 )
		) description:( '( #( 1 2 3 ) asReversedGenerator on: #( 4 5 ) ) asOrderedCollection asArray = #( 5 4 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asReversedGenerator on: #( 4 5 6 ) ) asOrderedCollection asArray = #( 6 5 4 )
		) description:( '( #( 1 2 3 ) asReversedGenerator on: #( 4 5 6 ) ) asOrderedCollection asArray = #( 6 5 4 )' ) ).

	( self assert:(
		#( 1 2 3 ) asGenerator asReversedGenerator asOrderedCollection asArray = #( 3 2 1 )
		) description:( '#( 1 2 3 ) asGenerator asReversedGenerator asOrderedCollection asArray = #( 3 2 1 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator collect:[ :x | x + 1 ] ) asReversedGenerator asOrderedCollection asArray = #( 3 2 1 ) "<---[ collect: has no effect because of KEGGenerator>>doesNotUnderstand: ]"
		) description:( '( #( 1 2 3 ) asGenerator collect:[ :x | x + 1 ] ) asReversedGenerator asOrderedCollection asArray = #( 3 2 1 )' ) ).
! !

!KEGObjectTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/1/2013 20:16'!
testasSingletonGenerator "asSingletonGenerator "

        "Method Version: keg2.  "
        "Copyright Kjell E God April 13, 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today 05 May 2011, April 13, 1999"

	"Return a Generator that has self as it's only element.  KEG2: Make it so that
	the KEGAbstractGenerator>>on: message will work on SingletonGenerators."

						"( MT b:#asSingletonGenerator s:self ).""
	^(
		( ( Array with: self ) asGenerator )

	)""return:(				MT e:#asSingletonGenerator s:self )"

	"PreKEG2Code-:

	| first |
	( first := true ).
	^(
		( KEGAbstractGenerator new
			resetBlock:[ first := true ]
			nextBlock:[ first ifTrue:[ first := false . self ] ] )

	)"
	( self assert:( 
		( 1 asSingletonGenerator asArray = #( 1 ) )
		) description:( '( 1 asSingletonGenerator asArray = #( 1 ) )' ) ).! !

!KEGObjectTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/1/2013 20:17'!
testasSourceGen "asSourceGen"

		"Method Version: keg2.  "
		"Copyright Kjell E God 05-11-92"
		"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
		"Date of Last Revision: Date today September 22 1999, 05-11-92"

							"( MT b:#asSourceGen s:self ).""
	^(
		( KEGAbstractGenerator new resetBlock:[ ""self reset"" ] nextBlock:[ self ] )

	)""return:(					MT e:#asSourceGen s:self )."

		"Return a generator which just returns self forever.
		Return <self, self, self, ...> infinite sequence.
		KEG2: Moved it from Smalltalk/V 2.0 over to Dolphin 2.1 patch level 2( just some null touch
		ups )."

	( self assert:(
		( 1 asSourceGen first: 3 ) asArray = #( 1 1 1 )
		) description:( '( 1 asSourceGen first: 3 ) asArray = #( 1 1 1 )' ) )
! !

!KEGObjectTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/2/2013 18:05'!
testasStreamGeneratorOnC "asStreamGeneratorOn: aGenerator"

	"Method Version: keg2.  "
	" Copyright Kjell E God December 15 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20010726, December 15 1999"
	"<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>""
	| collection stream |
								""MT b:#asStreamGeneratorOn: s:self.""

	( (( collection := ( stream := aGenerator generator ) collection ) isKindOf: Array ) and:[ collection size = 1 ] )
		ifTrue:[ collection at: 1 put: self ]ifFalse:[ ""<-----------------------------------------[ We have a special setup so we assume speed optimizations can be done ]""
	( collection isKindOf: OrderedCollection )
		ifTrue:[ 
			collection size = 1 ""<------------------------------------------------------------------[ We check that things are specially set up ]""
				ifTrue:[ collection at: 1 put: self ] ""<--------------------------------------[ Things are specially set up ]""
				ifFalse:[ collection initialize ; add: self. stream initialize ] ]""<---[ If not we keep trying ]""
	ifFalse:[ ^( self asGenerator )""return:( MT e:#asStreamGeneratorOn: s:self )""  ] ].

								""MT e:#asStreamGeneratorOn: s:self.""
	^aGenerator .

	""Stick self into aGenerator in the most expedient way.  The most expedient way that is still
	flexible enough for us to accept.   If it looks like this is going to be a bitch to do and since we are
	probably on a tight schedule here we just degenerate into creating a new Generator with self
	as its only element.  But in most cases we assume that things have been set up to be expedient
	for us.  This method is best viewed with the word wrap toggled off and on as desired.  You can do
	this via the manual procedure: RightClick=> Manipulate...=> Toggle The =( Word Wrap )= .
	KEG2: Brought the isKindOf: and initialize and basicAt: stuff up here from
	String>>asStreamGeneratorOn: .  This kind of thing is used by the >>inlineEmbeddedSequences
	and related Methods."

	
	( self assert:( 
		( 1 asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 ) "<---[ Probably the most speed optimized version ]"
		) description:( '( 1 asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( 1 )' ) ).

	( self assert:( 
		( 1 asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asOrderedCollection asArray = #( 1 )
		) description:( '( 1 asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asOrderedCollection asArray = #( 1 )' ) ).

	( self assert:( 
		( 1 asStreamGeneratorOn:( OrderedCollection new asGenerator ) ) asOrderedCollection asArray = #( 1 )
		) description:( '( 1 asStreamGeneratorOn:( OrderedCollection new asGenerator ) ) asOrderedCollection asArray = #( 1 )' ) ).

	( self assert:( 
		( 1 asStreamGeneratorOn:( ( OrderedCollection with: 1 ) asGenerator ) ) asOrderedCollection asArray = #( 1 )
		) description:( '( 1 asStreamGeneratorOn:( ( OrderedCollection with: 1 ) asGenerator ) ) asOrderedCollection asArray = #( 1 )' ) ).

	( self assert:( 
		( 1 asStreamGeneratorOn:( ( Array with: 0 ) asGenerator collect:[ :x | x ] ) ) asOrderedCollection asArray = #( 1 )
		) description:( '( 1 asStreamGeneratorOn:( ( Array with: 0 ) asGenerator collect:[ :x | x ] ) ) asOrderedCollection asArray = #( 1 )' ) ).

	( self assert:( 
		( 1 asStreamGeneratorOn:( ( ( Array with: 0 ) asGenerator collect:[ :x | x ] ) collect: nil ) ) asOrderedCollection asArray = #( 1 ) "<---[ nil = [ :x | x ] ]"
		) description:( '( 1 asStreamGeneratorOn:( ( Array with: 0 ) asGenerator collect:[ :x | x ] ) ) asOrderedCollection asArray = #( 1 )' ) ).

	( self assert:( 
		( 1 asStreamGeneratorOn:( KEGGenerator streamGenerator ifNotNil:[ :x | x generator on:( Array with: 1 ) . x ] ) ) asOrderedCollection asArray = #( 1 ) "<---[ pathological ]"
		) description:( '( 1 asStreamGeneratorOn:( KEGGenerator streamGenerator ifNotNil:[ :x | x generator collection: 1 . x ] ) ) asOrderedCollection asArray = #( 1 )' ) ).
	
	! !

!KEGPointTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/2/2013 20:20'!
testasGenerator "asGenerator"

	"Method Version: keg1.  "
	" Copyright Kjell E God Feb  1 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Feb  1 2000""
	| next r |
						""( MT b:#asGenerator s:self ).""
	^( 
		( KEGAbstractGenerator new firstBlock:[ next:=y . x ]nextBlock:[ r:=next . next:=nil. r ]  )

	)""return:( 				MT e:#asGenerator s:self )"

	"Return a Generator that first returns x and then y and then an infinite sequence of
	nils.  In other words the sequence <x y> is returned.  See KEGGenerator Class to see
	about Generators.  To get the x and y out of the Generator you do a >>first and then
	a >>next to it.  And you can do any of the Generator methods on it.  self( this method ) is good for
	stuffing dual parameters down a variable size message parameter slot as in 
	KEGBooleanPresenter closeRequested:( helpPresenter1 @ helpPresenter2 ) which is shorter than
	sticking the two helpPresenters into an Array like: ( Array with: helpPresenter1 with: helpPresenter2 )."

	( self assert:(
		( 1 @ 2 ) asGenerator asArray = #( 1 2 )
		) description:( '( 1 @ 2 ) asGenerator asArray = #( 1 2 )' ) )
! !

!KEGHashedCollectionTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 4/21/2013 12:59'!
testDictionaryAsGenerator

	"Method Version: keg1.  "
	" Copyright Kjell E God 20000818"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20000818"
	"<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>""
	| selfBasicSize i key assoc |
									""( MT b:#asGenerator s:self ).""
	( assoc := Association new ).""<---[ Note assoc is reused!! ]""
	^(
		( KEGAbstractGenerator new 
			resetBlock:[ ( selfBasicSize := self basicSize ).( i := 0 ) ] 
			nextBlock:[ 
				( key := nil ).
				( 	[
					( ( i := i + 1 )<= selfBasicSize )and:[ 
					( key := self basicAt: i ) isNil ]
					] whileTrue:[  ] ).
				( key ifNotNil:[ assoc key:( key )value:( values at: i ) ] ) ] )

	)""return:( 							MT e:#asGenerator s:self )."

	"Return a KEGGenerator on the Associations of self.  This method is a stop gap simplified somewhat
	not as good implementation.  The good implementation is gotten by looking at the 
	Dictionary>>asGenerator and at the LookupTable>>keysAndValuesDo: type methods.  The good
	implementation is left as an exercise. ( in other words, please do it for me. )."

	"

	Please note that assoc is reused so if you are doing an >>asOrderedCollection
	then you must make copies of the assoc or you will get an OrderedCollection with
	all the same Association in it.

	( gen collect:[ :assoc | assoc copy ] ) asOrderedCollection
		

	"
	"Test case : "

	( self assert:(
		(
		(
		( #(  ) asGenerator )ifNotNil:[ :gen | 
			gen inject:( Dictionary new )into:[ :dict :n | 
				dict at: n put:( gen next ) ; yourself
			]  ]
		) asGenerator inject: 0 into:[ :sum :assoc | sum + ( assoc key ) + ( assoc value ) ]
		) = 0
	) description:( 'Dictionary asGenerator sum Associations (  )' ) ).

	( self assert:(
		(
		(
		( #( 1 2 ) asGenerator )ifNotNil:[ :gen | 
			gen inject:( Dictionary new )into:[ :dict :n | 
				dict at: n put:( gen next ) ; yourself
			]  ]
		) asGenerator inject: 0 into:[ :sum :assoc | sum + ( assoc key ) + ( assoc value ) ]
		) = 3
	) description:( 'Dictionary asGenerator sum Associations 12' ) ).

	( self assert:(
		(
		(
		( #( 1 2 3 4 5 6 ) asGenerator )ifNotNil:[ :gen | 
			gen inject:( Dictionary new )into:[ :dict :n | 
				dict at: n put:( gen next ) ; yourself
			]  ]
		) asGenerator inject: 0 into:[ :sum :assoc | sum + ( assoc key ) + ( assoc value ) ]
		) = 21
	) description:( 'Dictionary asGenerator sum Associations 123456' ) ).

	( self assert:(
		(
		(
		( #( 1 2 3 4 5 6 ) asGenerator )ifNotNil:[ :gen | 
			gen inject:( Dictionary new )into:[ :dict :n | 
				dict at: n put:( gen next ) ; yourself
			]  ]
		) asGenerator asArray collect:[ :assoc | Array with: assoc key with: assoc value ]"<---[ the copy ]"
		) = #( ( 5 6 ) ( 1 2 ) ( 3 4 ) ) "<---[ We don't need to do the copy in Pharo because Pharo Dictionarys are a set of Associations.  In Dolphin we keep returning the same Assoc over and over. ]"
	) description:( 'Dictionary asGenerator don''t copy Associations first ' ) ).

	( self assert:(
		(
		(
		(
		( #( 1 2 3 4 5 6 ) asGenerator )ifNotNil:[ :gen | 
			gen inject:( Dictionary new )into:[ :dict :n | 
				dict at: n put:( gen next ) ; yourself
			]  ]
		) asGenerator collect:[ :assoc | Array with: assoc key with: assoc value ]
		) asArray
		) = #( ( 5 6 ) ( 1 2 ) ( 3 4 ) )
	) description:( 'Dictionary asGenerator copy Associations first' ) ).

	""! !

!KEGHashedCollectionTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 4/20/2013 15:48'!
"(| defineMethod-:(" testasGenerator " asGenerator "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20121017
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20121017 19:04 )
	)-notes methodBody-:(
 (| let-:(""| element i basicSize a |"")
    letBody-:("					"( MT b:#asGenerator s:self ).""
	^(	
		
		( KEGAbstractGenerator new
			resetBlock:[ i := 0 . basicSize := ( a := self array ) size ]
			nextBlock:[ element := nil .
				[ ( ( i := i + 1 ) <= basicSize )and:[ ( element := a at: i ) isNil ] ]whileTrue:[ ] .
				element 
			] )

	)""return:( 					MT e:#asGenerator s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a KEGGenerator on self.

 )-summary
 methodDescriptionDetail-:(

	The returned KEGGenerator G is a sequence of all the nonNil
	elements in the array inside of self.  So hopefully this one
	single asGenerator method will work for Dictionarys and
	Sets etc.  When self is a Dictionary then the returned G
	is a sequence of Associations.  See the KEGGenerator>>
	Methods to see what you can do with such a sequence.
	
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "
	
	( self assert:(
		Dictionary new asGenerator asArray = #(  )
		) description:( 'Dictionary new asGenerator asArray = #(  )' ) ).

	( self assert:(
		( ( #( ( 1 2 ) ) inject:( Dictionary new )into:[ :d :x | d at:( x p1 )put:( x p2 ) . d ] )asGenerator collect:[ :a | Array p1: a key p2: a value ] ) asArray = #( ( 1 2 ) )
		) description:( '( ( #( ( 1 2 ) ) inject:( Dictionary new )into:[ :d :x | d at:( x p1 )put:( x p2 ) . d ] )asGenerator collect:[ :a | Array p1: a key p2: a value ] ) asArray = #( ( 1 2 ) )' ) ).

	( self assert:(
		( ( #( ( 1 2 )( 3 4 ) ) inject:( Dictionary new )into:[ :d :x | d at:( x p1 )put:( x p2 ) . d ] )asGenerator collect:[ :a | Array p1: a key p2: a value ] ) asArray = #( ( 1 2 ) ( 3 4 ) )
		) description:( '( ( #( ( 1 2 )( 3 4 ) ) inject:( Dictionary new )into:[ :d :x | d at:( x p1 )put:( x p2 ) . d ] )asGenerator collect:[ :a | Array p1: a key p2: a value ] ) asArray = #( ( 1 2 ) ( 3 4 ) )' ) ).

	( self assert:(
		( ( #( ( 1 2 )( 3 4 )( 5 6 ) ) inject:( Dictionary new )into:[ :d :x | d at:( x p1 )put:( x p2 ) . d ] )asGenerator collect:[ :a | Array p1: a key p2: a value ] ) asArray = #( ( 5 6 ) ( 1 2 ) ( 3 4 ) )
		) description:( '( ( #( ( 1 2 )( 3 4 )( 5 6 ) ) inject:( Dictionary new )into:[ :d :x | d at:( x p1 )put:( x p2 ) . d ] )asGenerator collect:[ :a | Array p1: a key p2: a value ] ) asArray = = #( ( 5 6 ) ( 1 2 ) ( 3 4 ) )' ) ).
	
	( self assert:(
		#(  ) asSet asGenerator asArray = #(  )
		) description:( '#(  ) asSet asGenerator asArray = #(  )' ) ).

	( self assert:(
		#( 1 ) asSet asGenerator asArray = #( 1 )
		) description:( '#( 1 ) asSet asGenerator asArray = #( 1 )' ) ).

	( self assert:(
		#( 1 2 ) asSet asGenerator asArray = #( 1 2 )
		) description:( '#( 1 2 ) asSet asGenerator asArray = #( 1 2 )' ) ).

	( self assert:(
		#( 1 2 3 ) asSet asGenerator asArray = #( 1 2 3 )
		) description:( '#( 1 2 3 ) asSet asGenerator asArray = #( 1 2 3 )' ) ).
	
" )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGDateTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 4/21/2013 09:51'!
"(| defineMethod-:(" testasGenerator ")
	notes-:(		Method Version: keg1
				 Copyright Kjell E God 20110630
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110630 5:55 )
	)-notes methodBody-:(
 (| let-:(""| date |"")
    letBody-:(""					""( MT b:#asGenerator s:self ).""
	^( 	
		( KEGAbstractGenerator new
			resetBlock:[ date := self addDays: -1 ]
			nextBlock:[ date := ( date addDays: 1 ) ] ""<------[ Count forwards ]""
		) 
	)""return:( 					MT e:#asGenerator s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return an infinite sequence of different days starting with today.

 )-summary
 methodDescriptionDetail-:(
	detail
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:(  ) madeChanges-:(  )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	self assert:(
		(
		(
		( Date readFrom:( '2012-10-16' readStream ) 
		) asGenerator first: 3
		) collect:[ :d | d yyyymmdd ]
		) asArray = #( '2012-10-16' '2012-10-17' '2012-10-18')
		)		
	
" )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"
! !

!KEGReadWriteStreamTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/2/2013 20:30'!
"(| defineMethod-:(" testasGenerator "asGenerator "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030425
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030425
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#asGenerator s:self ).""
	^(
		( KEGGenerator on:( self ) )

	)""return:( 					MT e:#asGenerator s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	
	Override the WriteStream>>asGenerator which is some kind of speed
	optimizations which keeps on pissing me off.  So overrided it down here.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:( 
		#(  ) readWriteStream asGenerator asArray = #(  )
		) description:( '#(  ) readWriteStream asGenerator asArray = #(  )' ) ).

	( self assert:( 
		( Array new readWriteStream nextPutAll:#( 1 ) ; yourself ) asGenerator asArray = #( 1 )
		) description:( '( Array new readWriteStream nextPutAll:#( 1 ) ; reset ) asGenerator asArray = #( 1 )' ) ).

	( self assert:( 
		( Array new readWriteStream nextPutAll:#( 1 ) ; yourself ) asGenerator asOrderedCollection asArray = #( 1 )
		) description:( '( Array new readWriteStream nextPutAll:#( 1 ) ; reset ) asGenerator asOrderedCollection asArray = #( 1 )' ) ).

	( self assert:( 
		( Array new readWriteStream nextPutAll:#( 1 2 ) ; yourself ) asGenerator asArray = #( 1 2 )
		) description:( '( Array new readWriteStream nextPutAll:#( 1 2 ) ; reset ) asGenerator asArray = #( 1 2 )' ) ).

	( self assert:( 
		( Array new readWriteStream nextPutAll:#( 1 2 ) ; yourself ) asGenerator asOrderedCollection asArray = #( 1 2 )
		) description:( '( Array new readWriteStream nextPutAll:#( 1 2 ) ; reset ) asGenerator asOrderedCollection asArray = #( 1 2 )' ) ).

	( self assert:( 
		( Array new readWriteStream nextPutAll:#( 1 2 3 ) ; yourself ) asGenerator asArray = #( 1 2 3 )
		) description:( '( Array new readWriteStream nextPutAll:#( 1 2 3 ) ; reset ) asGenerator asArray = #( 1 2 3 )' ) ).

	( self assert:( 
		( Array new readWriteStream nextPutAll:#( 1 2 3 ) ; yourself ) asGenerator asOrderedCollection asArray = #( 1 2 3 )
		) description:( '( Array new readWriteStream nextPutAll:#( 1 2 3 ) ; reset ) asGenerator asOrderedCollection asArray = #( 1 2 3 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"
! !

!KEGStringTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/2/2013 20:35'!
testasGenerator "asGenerator"

        "Method Version: keg1.  "
        "Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today October 28 1999"

	"Return a KEGGenerator on self.  As far as Generators are concerned Strings
	are single units therefore we return the singleton Generator."
					"( MT b:#asGenerator s:self ).""
	^( 
		( self asSingletonGenerator )

	)""return:(			MT e:#asGenerator s:self )"

	( self assert:(
		'123' asGenerator asArray = #( '123' ) "<-----------------------------------[ asArray is optimized ]"
		) description:( '''123'' asGenerator asArray = #( ''123'' )' ) ).

	( self assert:(
		'123' asGenerator asOrderedCollection asArray = #( '123' ) "<-----[ asOrderedCollection is not optimized ]"
		) description:( '''123'' asGenerator asOrderedCollection asArray = #( ''123'' )' ) ).
! !

!KEGStringTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/2/2013 20:36'!
testasSequence "asSequence"

	"Method Version: keg1.  "
	" Copyright Kjell E God Apr 16 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Apr 16 2000""
	| answer |
						""MT b:#asSequence s:self.""

	answer := ( self asReadOnlyStream asGenerator ) .

						""MT e:#asSequence s:self.""
	^answer .
	""Return self as a sequence of Characters.  This >>asSequence is a protocal parallel to >>asGenerator.
	But it has more of a tendency to burst Objects like Strings into their component
	parts( Characters ) where >>asGenerator more often returns Objects like Strings as single units.
	Strings are burst into their sequence of Characters."
	
	( self assert:(
		'' asSequence asArray = #(  ) "<-------------------------------------------------[ asArray is optimized ]"
		) description:( ''''' asSequence asArray = #(  )' ) ).

	( self assert:(
		'' asSequence asOrderedCollection asArray = #(  ) "<-------------------[ asOrderedCollection is not optimized ]"
		) description:( ''''' asSequence asOrderedCollection asArray = #(  )' ) ).

	( self assert:(
		'1' asSequence asArray = #( $1 )
		) description:( '''1'' asSequence asArray = #( $1 )' ) ).

	( self assert:(
		'1' asSequence asOrderedCollection asArray = #( $1 )
		) description:( '''1'' asSequence asOrderedCollection asArray = #( $1 )' ) ).

	( self assert:(
		'12' asSequence asArray = #( $1 $2 )
		) description:( '''12'' asSequence asArray = #( $1 $2 )' ) ).

	( self assert:(
		'12' asSequence asOrderedCollection asArray = #( $1 $2 )
		) description:( '''12'' asSequence asOrderedCollection asArray = #( $1 $2 )' ) ).

	( self assert:(
		'123' asSequence asArray = #( $1 $2 $3 )
		) description:( '''123'' asSequence asArray = #( $1 $2 $3 )' ) ).

	( self assert:(
		'123' asSequence asOrderedCollection asArray = #( $1 $2 $3 )
		) description:( '''123'' asSequence asOrderedCollection asArray = #( $1 $2 $3 )' ) ).

	! !

!KEGStringTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/2/2013 20:38'!
"(| defineMethod-:(" testasStreamGeneratorOnC "asStreamGeneratorOn: aStreamGenerator "")
	notes-:(		Method Version: keg4.
				 Copyright Kjell E God December 15 1999
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130113 10:49 ) 20020921 , 20010726, December 15 1999
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 3 >>
	)-notes methodBody-:(
 (| let-:(""| collection stream |"")
    letBody-:(""					""( MT b:#asStreamGeneratorOn: s:self ).""

	( 
	( ( ( collection := ( stream := aStreamGenerator generator ) collection )isKindOf:( Array ) ) and:[ collection size = 1 ] )
		ifTrue:[ collection at: 1 put: self ]ifFalse:[ ""<-----------------------------------------[ We have a special setup so we assume speed optimizations can be done ]""
	( collection isKindOf:( OrderedCollection ) )
		ifTrue:[ 
			collection size = 1 
				ifTrue:[ collection basicAt: 1 put: self ] ""<---[ KEG2: This speed optimization could blow up though if collection has been sent >>removeFirst or some similar message at some prior time. ]""
				ifFalse:[ ( collection initialize ; add: self ).( stream initialize ) ] ]ifFalse:[ 
	( collection isString )
		ifTrue:[ ^( super asStreamGeneratorOn:( aStreamGenerator ) )""return:( MT e:#asStreamGeneratorOn: s:self )"" ]
	ifFalse:[ ^( self asGenerator )""return:( MT e:#asStreamGeneratorOn: s:self )"" ] ] ]
	).

	^(
		( aStreamGenerator )

	)""return:( 					MT e:#asStreamGeneratorOn: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Try to insert self into aStreamGenerator depending on the internal structure of aStreamGenerator.
	aStreamGenerator is assumed to be a KEGGenerator on a Stream.

 )-summary
 methodDescriptionDetail-:(

	Set self into aStreamGenerator.   Since Strings are NOT Sequences but are thought of as single units as
	far as Generators are concerned( default ), we load self into aStreamGenerator as a single unit.
	This method is best viewed with the word wrap toggled off and on as desired.  You can do this via
	the manual procedure: RightClick=> Manipulate...=> Toggle The =( Word Wrap )= .
	It is IMPORTANT that self-:( this method ) does not split self up into Characters like the
	String>>asCharacter method does.  Certain methods depend on it.
	USAGE-:(
		( '123' asStreamGeneratorOn:( '1' asCharacter ) )
			will insert '123' as the new collection in the ReadStream inside the KEGGenerator returned
			by ( '1' asCharacter ) .  See KEGGenerator>>fileNames for more examples.  So the returned
			KEGGenerator will be a sequence equal to < $1 $2 $3 > .
		( '123' asStreamGeneratorOn:( KEGGenerator streamGenerator ) )
			will insert the String '123' as an element in the Array in the ReadStream in
			the KEGGenerator returned by >>streamGenerator .  ( But you shouldn't count on such
			internal structure remaining constant.  You should only count on the message interfaces.
			Not on the internal structure in the Objects.  I might change the internal structures in some
			future release of self-:( this software ).  But most probably I would not change the message
			interfaces. ) So the returned KEGGenerator will be a sequence equal to < '123' >.
	)-usage
 )-detail
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG4-: ( Changes onDate-:( 20130113 ) added-:( 'isKindOf: Array' clause ) )-chg )-keg4
	(| KEG3-: ( Changes onDate-:( 20020921 ) added-:( 'collection isString' clause ) )-chg )-keg3
	(| KEG2-: ( Changes onDate-:( 20010726 ) added-:( the basicAt: speed optimization in case the
		OrderedCollection is the right size( can blow up as mentioned below ) ) )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( '123' asStreamGeneratorOn:( '1' asReadOnlyStream asGenerator ) ) asArray = #( $1 $2 $3 )
		) description:( '( ''123'' asStreamGeneratorOn:( ''1'' asReadOnlyStream asGenerator ) ) asArray = #( $1 $2 $3 )' ) ).

	( self assert:(
		( '123' asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( '123' )
		) description:( '( ''123'' asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asArray = #( ''123'' )' ) ).

	( self assert:(
		( '123' asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asOrderedCollection asArray = #( '123' )
		) description:( '( ''123'' asStreamGeneratorOn:( KEGGenerator streamGenerator ) ) asOrderedCollection asArray = #( ''123'' )' ) ).

	( self assert:(
		( '123' asStreamGeneratorOn:( OrderedCollection new asGenerator ) ) asOrderedCollection asArray = #( '123' )
		) description:( '( ''123'' asStreamGeneratorOn:( OrderedCollection new asGenerator ) ) asOrderedCollection asArray = #( ''123'' )' ) ).

	( self assert:(
		( '123' asStreamGeneratorOn:( ( OrderedCollection with: 1 ) asGenerator ) ) asOrderedCollection asArray = #( '123' )
		) description:( '( ''123'' asStreamGeneratorOn:( ( OrderedCollection with: 1 ) asGenerator ) ) asOrderedCollection asArray = #( ''123'' )' ) ).

	( self assert:( 
		( '123' asStreamGeneratorOn:( KEGGenerator streamGenerator ifNotNil:[ :x | x generator on:( Array with: 1 ). x ] ) ) asOrderedCollection asArray = #( '123' )
		) description:( '( ''123'' asStreamGeneratorOn:( KEGGenerator streamGenerator ifNotNil:[ :x | x generator collection: 1 . x ] ) ) asOrderedCollection asArray = #( ''123'' )' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGFixedSizedQueTest methodsFor: '*keggeneratorbasetest' stamp: 'KjellGodo 10/18/2012 19:53'!
"(| defineMethod-:(" testlast ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20110703
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110703 9:11 )
	)-notes methodBody-:(
 (| let-:(""| next return count amountToCount localSize |"")
    letBody-:(""					""( MT b:#last: s:self ).""
	( amountToCount := ( localSize := self size ) - anInteger + 1 ).
	^(	
		( self theKEGAbstractGeneratorClass new
			resetBlock:[ 
				( next := firstLink ).
				( count := amountToCount ).
				( [ ( next notNil )and:[ 0 < ( count := count - 1 ) ] ] whileTrue:[ next := next nextLink ] ) ]
			nextBlock:[ ( ( return := next ) == nil ) ifFalse:[ next := next nextLink . return contents ] ] ;
			at: #last: putLocalFunction:[ :x | amountToCount := localSize - x + 1 ] ;
			yourself )

	)""return:( 					MT e:#last: s:self )

    )-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	If self = < s1 s2 s3 ... sN ... sM > where M - N = anInteger then return
	the sequence gen = < sN ... sM >
	
 )-summary
 methodDescriptionDetail-:(

	You can send gen the message ( gen call: #last: p1: W ) where W is an
	Integer and then gen will be converted into the sequence < sW ... sM >.
	This is an example of the #at:putLocalFunction: protocal of adding local
	functions to a KEGGenerator so that you can reach inside of it and change
	the way that it works from the inside.  Even though it is made out of
	BlockClosures.

 )-detail
 usage-:(
	usage
 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGLambdaLispEvalV6p1>>evalWithActivationRec:returningToContinuation:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	self assert:(
		(
		( ( KEGFixedSizedQue new size: 10 )
			addLast: 1 ;
			addLast: 2 ;
			addLast: 3 ;
			addLast: 4 ;
			addLast: 5 ;
			addLast: 6 ;
			addLast: 7 ;
			addLast: 8 ;
			addLast: 9 ;
			addLast: 10 ;
			yourself
		) last: 3
		) asArray = #( 8 9 10 )
		).

	self assert:(
		(
		( ( KEGFixedSizedQue new size: 10 )
			addLast: 1 ;
			addLast: 2 ;
			addLast: 3 ;
			addLast: 4 ;
			addLast: 5 ;
			addLast: 6 ;
			addLast: 7 ;
			addLast: 8 ;
			addLast: 9 ;
			addLast: 10 ;
			yourself
		) last: 3
		) ifNotNil:[ :fsq | 
			( fsq asArray = #( 8 9 10 ) ) and:[ 
			( fsq call: #last: p1: 4 ).
			( fsq asArray = #( 7 8 9 10 ) ) ] ]
	) description:( 'Change the last: via calling into the KEGGenerator.' ).

	self assert:( 
		(
		( ( KEGFixedSizedQue new size: 10 )
			addLast: 1 ;
			addLast: 2 ;
			addLast: 3 ;
			addLast: 4 ;
			addLast: 5 ;
			addLast: 6 ;
			addLast: 7 ;
			addLast: 8 ;
			addLast: 9 ;
			addLast: 10 ;
			yourself
		) last: 1
		) asArray = #( 10 )
	).

	self assert:( 
		(
		( ( KEGFixedSizedQue new size: 10 )
			addLast: 1 ;
			addLast: 2 ;
			addLast: 3 ;
			addLast: 4 ;
			addLast: 5 ;
			addLast: 6 ;
			addLast: 7 ;
			addLast: 8 ;
			addLast: 9 ;
			addLast: 10 ;
			yourself
		) last: 0
		) asArray = #(  )
	).

	self assert:( 
		(
		( ( KEGFixedSizedQue new size: 10 )
			addLast: 1 ;
			addLast: 2 ;
			addLast: 3 ;
			addLast: 4 ;
			addLast: 5 ;
			addLast: 6 ;
			addLast: 7 ;
			addLast: 8 ;
			addLast: 9 ;
			addLast: 10 ;
			yourself
		) last: 11
		) asArray = #( 1 2 3 4 5 6 7 8 9 10 )
		).

" )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"



! !

KEGTestCaseObject subclass: #KEGGeneratorClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KEGGeneratorBaseTest'!

!KEGGeneratorClassTest methodsFor: 'initialize-release' stamp: 'KjellGodo 4/29/2013 19:21'!
testcounter "counter"

	"Method Version: keg1.  "
	"Copyright Kjell E God Apr 21, 1995"
	"licensed as MIT Open Source: Please evaluate ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Apr 21, 1995"

		"Return the infinite counter Generator <1, 2, 3, 4, ... >.""

	| answer |

						""MT b:#counter s:self.""

	answer := self counter: #Number .

						""MT e:#counter s:self.""
	^answer .

	"
	( self assert:( 
		( KEGGenerator counter first: 0 ) asArray = #(  )
		) description:( '( KEGGenerator counter first: 0 ) asArray = #(  )' ) ).

	( self assert:( 
		( KEGGenerator counter first: 1 ) asArray = #( 1 )
		) description:( '( KEGGenerator counter first: 1 ) asArray = #( 1 )' ) ).

	( self assert:( 
		( KEGGenerator counter first: 3 ) asArray = #( 1 2 3 )
		) description:( '( KEGGenerator counter first: 3 ) asArray = #( 1 2 3 )' ) ).
! !

!KEGGeneratorClassTest methodsFor: 'initialize-release' stamp: 'KjellGodo 4/29/2013 19:23'!
testonC "on: aSequence"

        "Method Version: keg1.  "
        "Copyright Kjell E God Date today"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today "
					"( MT b:#on: s:self ).""
	^(

		( ( self new ) 
			generator:( aSequence asReadOnlyStream ) ;
			yourself )

	)""return:( 			MT e:#on: s:self )."

	"Return an instance of self on aSequence.  Where aSequence will be converted 
	into a read only Stream.  asReadStream may not actually return a ReadStream."
	
	( self assert:( 
		( KEGGenerator on: #(  ) ) asArray = #(  )
		) description:( '( KEGGenerator on: #(  ) ) asArray = #(  )' ) ).

	( self assert:( 
		( KEGGenerator on: #( 1 2 3 ) ) asArray = #( 1 2 3 )
		) description:( '( KEGGenerator on: #( 1 2 3 ) ) asArray = #( 1 2 3 )' ) ).

	( self assert:( 
		( KEGGenerator on: #( 1 2 3 ) asOrderedCollection ) asArray = #( 1 2 3 )
		) description:( '( KEGGenerator on: #( 1 2 3 ) asOrderedCollection ) asArray = #( 1 2 3 )' ) ).

	( self assert:( 
		( KEGGenerator on: #( 1 2 3 ) readStream ) asArray = #( 1 2 3 )
		) description:( '( KEGGenerator on: #( 1 2 3 ) readStream ) asArray = #( 1 2 3 )' ) ).

	( self assert:( 
		( KEGGenerator on: #( 1 2 3 ) asGenerator ) asArray = #( 1 2 3 )
		) description:( '( KEGGenerator on: #( 1 2 3 ) asGenerator ) asArray = #( 1 2 3 )' ) ).

	"See KEGLinkedListGeneratorTest>>testAll for more tests of >>on: using linked lists.

	"! !

!KEGGeneratorClassTest methodsFor: 'initialize-release' stamp: 'KjellGodo 4/29/2013 19:25'!
"(| defineMethod-:(" testrandomNumberGeneratorC "randomNumberGenerator: seed "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130101
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130101 18:34 )
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#randomNumberGenerator s:self ).""
	^(
		( ( Random seed: seed ) asGenerator )

	)""return:( 					MT e:#randomNumberGenerator s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a psuedo infinite sequence of psuedo random Float floating point numbers between 0 and 1.
	seed must be some Integer other than zero.  See Random class>>seed: for details about what seed
	can be.  This random number generator uses LargeInteger arithmatic so it is slower than the quick
	and dirty generators.  So if you need speed then perhaps you should try a different Random.

 )-summary
 methodDescriptionDetail-:(

	This method shows you how to create other random number KEGGenerators on other Random
	number Generators.  Just send it the >>asGenerator message to new instances of a Random
	subClass or any other random number generating Object that responds to the >>reset and >>next
	messages and the >>asGenerator message.

	If you want greater speed just use a ( Random new ) without the KEGGenerator wrapper.  But it
	won't do all the things that a KEGGenerator can do.  But it will do the most important things.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	( change:onDate:madeChanges: keg2 yyyymmdd ( ... ) )---[chg] )---[keg2]
 )-changes
 testCases-:( "

	( self assert:(
		( ( ( KEGGenerator randomNumberGenerator: 1 ) first: 3 ) asArray collect:[ :x | ( x * 100 ) truncated ] ) = #( 0 13 75 )
		) description:( '( ( ( KEGGenerator randomNumberGenerator: 1 ) first: 3 ) asArray collect:[ :x | ( x * 100 ) truncated ] ) = #( 0 13 75 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

KEGTestCaseObject subclass: #KEGGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KEGGeneratorBaseTest'!

KEGGeneratorTest subclass: #KEGAbstractGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KEGGeneratorBaseTest'!

!KEGAbstractGeneratorTest commentStamp: 'KjellGodo 10/18/2012 18:00' prior: 0!
KEGAbstractGeneratorTest

	KEGAbstractGeneratorTest Class is the test Class for the KEGAbstractGenerator Class
	for the keg Smalltalk software & software codes.
	Copyright  2011  Kjell E God

	This Class is licensed as MIT Open Source.  Please evaluate ( Object licenseMIT ) for more info
	or see KEGLicense class>>licenseMIT.

( comment:-- 20110728

	

 )---[comment]!

!KEGGeneratorTest methodsFor: 'generatorConcatenating' stamp: 'KjellGodo 4/21/2013 12:05'!
testComma " , aGenerator"

		"Method Version: keg1.  "
		"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
		"Date of Last Revision: Date today 04-21-92"

		"Return a generator which is the
		concatenation of self with the elements of aGenerator.  aGenerator can be
		a Sequence as defined by the >>isSequence method.""

	| answer first secondGen |

					""MT b: #,  s: self .""

	secondGen := aGenerator asGenerator .
	answer := self abstractGenerator new
		resetBlock:[ ( first := true ).( self reset ) ]
		nextBlock:[
			first	ifTrue:[ ( self next ) ifNil:[ ( first := false ).( secondGen first ) ] ]
				ifFalse:[ secondGen next ]
		] .
					""MT e: #,  s: self .""
	 ^answer .

	""Above is the AbstractGenerator version of Generator>>, method:.

	 The following is the shuffle version of the Generator>>, method:
	 answer := self shuffle: [ :x :y | true ] with: secondGen .

	 The following is the atEachGenerate: version of the Generator>>, method:
	  answer := secondGen isNil
		ifTrue:[ self ]
		ifFalse:[ ( Array with: self with: secondGen )asGenerator atEachGenerate:[ :x | x ] ] .

	In time trials:
		for generator creation: AbstractGenerator & shuffle methods are tied.
											 atEachGenerate: is 2 times slower than the others.
		for generator iteration: AbstractGenerator is 50% faster than shuffle 18% of
											 the time, 20% faster 24% of the time, and the rest of
											 the time they were equal.
											 atEachGenerate: method was equal with
											 AbstractGenerator method most of the time but
											 was 30% faster 14% of the time.
	  "
	" For tests please see the KEGGeneratorTest>>testComma method."

	( self assert:(
		( ( #(  ) asGenerator ),( #(  ) asGenerator ) ) asArray = #(  )
		) description:( '( ( #(  ) asGenerator ),( #(  ) asGenerator ) ) asArray = #(  )' ) ).

	( self assert:(
		( ( #( 1 ) asGenerator ),( #(  ) asGenerator ) ) asArray = #( 1 )
		) description:( '( ( #( 1 ) asGenerator ),( #(  ) asGenerator ) ) asArray = #( 1 )' ) ).

	( self assert:(
		( ( #(  ) asGenerator ),( #( 1 ) asGenerator ) ) asArray = #( 1 )
		) description:( '( ( #(  ) asGenerator ),( #( 1 ) asGenerator ) ) asArray = #( 1 )' ) ).

	( self assert:(
		( ( #( 1 ) asGenerator ),( #( 2 ) asGenerator ) ) asArray = #( 1 2 )
		) description:( '( ( #( 1 ) asGenerator ),( #( 2 ) asGenerator ) ) asArray = #( 1 2 )' ) ).

	( self assert:(
		( ( #( 1 2 ) asGenerator ),( #( 3 ) asGenerator ) ) asArray = #( 1 2 3 )
		) description:( '( ( #( 1 2 ) asGenerator ),( #( 3 ) asGenerator ) ) asArray = #( 1 2 3 )' ) ).

	( self assert:(
		( ( #( 1 2 3 ) asGenerator ),( #( 4 5 6 ) asGenerator ) ) asArray = #( 1 2 3 4 5 6 )
		) description:( '( ( #( 1 2 3 ) asGenerator ),( #( 4 5 6 ) asGenerator ) ) asArray = #( 1 2 3 4 5 6 )' ) ).

! !

!KEGGeneratorTest methodsFor: 'generatorAdding' stamp: 'KjellGodo 10/20/2012 20:53'!
"(| defineMethod-:(" testaddAll ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20110703
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110703 9:11 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#addAll: s:self ).""
	^(	
		( self addAllLast: aSequence )

	)""return:( 					MT e:#addAll: s:self )

    )-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a new Generator that has aSequence as its last elements and
	all the elements of self preceeding those new last elements.
	
 )-summary
 methodDescriptionDetail-:(

	aSequence = <a1 a2 a3 ... >
	self=< s1 s2 s3 s4 ... sN > then return=< s1 s2 s3 s4 ... sN a1 a2 a3 ... >

 )-detail
 usage-:(
	usage
 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGLambdaLispEvalV6p1>>evalWithActivationRec:returningToContinuation:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	self assert:( ( #( 2 3 4 ) asGenerator addAll: #( 5 6 7 ) ) asArray = #( 2 3 4 5 6 7 ) )

" )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"



! !

!KEGGeneratorTest methodsFor: 'generatorAdding' stamp: 'KjellGodo 10/20/2012 20:53'!
"(| defineMethod-:(" testaddAllFirst ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20110703
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110703 9:06 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#addAllFirst: s:self ).""
	
	^(	( aSequence asGenerator ) ,
		( self )

	)""return:( 					MT e:#addAllFirst: s:self )

    )-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a new Generator that has aSequence as its first elements and
	all the elements of self following those new first elements.
	
 )-summary
 methodDescriptionDetail-:(

	aSequence = <a1 a2 a3 ... aN>
	self=< s1 s2 s3 s4 ... > then return=< a1 a2 a3 ... aN s1 s2 s3 s4 ... >

 )-detail
 usage-:(
	usage
 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGLambdaLispEvalV6p1>>evalWithActivationRec:returningToContinuation:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:("

	self assert:( ( #( 2 3 4 ) asGenerator addAllFirst: #( 5 6 7 ) ) asArray = #( 5 6 7 2 3 4 ) )

" )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"



! !

!KEGGeneratorTest methodsFor: 'generatorAdding' stamp: 'KjellGodo 10/20/2012 08:58'!
"(| defineMethod-:(" testaddFirst ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20080331
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint 20080331
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#addFirst: s:self ).""
	
	^(	( anObject asSingletonGenerator ) ,
		( self )

	)""return:( 					MT e:#addFirst: s:self )

    )-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a new Generator that has anObject as its first element and
	all the elements of self following that new first element.
	
 )-summary
 methodDescriptionDetail-:(

	self=< s1 s2 s3 s4 ... > then return=< anObject s1 s2 s3 s4 ... >

 )-detail
 usage-:(
	usage
 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGLambdaLispEvalV6p1>>evalWithActivationRec:returningToContinuation:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	self assert:(
		( #(  ) asGenerator addFirst: 1 ) asArray = #( 1 ) ).

	self assert:(
		( #( 2 3 4 ) asGenerator addFirst: 1 ) asArray = #( 1 2 3 4 ) )

" )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"



! !

!KEGGeneratorTest methodsFor: 'generatorAdding' stamp: 'KjellGodo 10/20/2012 09:04'!
"(| defineMethod-:(" testaddLast ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20110806
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110806 14:45 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#addLast: s:self ).""
	
	^(	( self ) ,
		( anObject asSingletonGenerator )

	)""return:( 					MT e:#addLast: s:self )

    )-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a new Generator that has anObject as its last element and
	all the elements of self proceeding that new last element.
	
 )-summary
 methodDescriptionDetail-:(

	self=< s1 s2 s3 s4 ... > then return=< s1 s2 s3 s4 ... anObject >

	If self is psuedo infinite then anObject will never be returned by
	the returned Generator herein designated return.

 )-detail
 usage-:(
	usage
 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGLambdaLispEvalV6p1>>evalWithActivationRec:returningToContinuation:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	self assert:(
		( #(  ) asGenerator addLast: 4 ) asArray = #( 4 ) ).

	self assert:(
		( #( 1 2 3 ) asGenerator addLast: 4 ) asArray = #( 1 2 3 4 ) )

" )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"



! !

!KEGGeneratorTest methodsFor: 'generatorAdding' stamp: 'KjellGodo 10/20/2012 20:54'!
"(| defineMethod-:(" testaddLookingAtLast ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20040204
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint 20040204
	)-notes methodBody-:(
 (| let-:("| previous |")
    letBody-:("					"( MT b:#addLookingAtLast: s:self ).""

	^( self abstractGenerator new
		resetBlock:[ self reset ]
		nextBlock:[
			( stop )ifFalse:[
				( self next
				) ifNil:[ ( self stop ).( newLastElementAddBlk value:( previous ) ) ]
				  ifNotNil:[ :n | previous := n ]
			]
		]
	)""return:( 					MT e:#addLookingAtLast: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	( PLEASE-NOTE-: As of <D:20040204> self-:( this method ) has not been
	tested or debugged. )
	Return a new sequence that is the same as self except that
	after the last element of self has been returned
	newLastElementAddBlk is evaluated on the last element of
	self and the results are returned as the new last element of self.

 )-summary
 methodDescriptionDetail-:(

	Suppose self = < s1 s2 s3 ... sN >
	Return r =      < s1 s2 s3 ... sN sM >

	where sM = ( newLastElementAddBlk value:( sN ) )

	So self-:( this method ) is like the Collection>>add: methods
	BUT it is not a very efficient way to do the >>add: functionality
	and probably you should use a Stream on an Array or ByteArray
	or String if you want to do a lot of >>add: operations.
	Or of course the OrderedCollection>>add: .

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	self assert:( ( #(  ) asGenerator addLookingAtLast:[ :last | last ] ) asArray = #(  ) ).

	self assert:( ( #( 1 2 3 ) asGenerator addLookingAtLast:[ :last | last + 1 ] ) asArray = #( 1 2 3 4 ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/23/2013 18:32'!
testafterC "after: anObject"

	"Method Version: keg3.  "
	"Copyright Kjell E God Jan 18, 1995"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today March 03 2000, September 22 1999, Jan 18, 1995"

	"For the main comment see << See HelpString AT-: 33>>. Or if that is corrupted then
	see the comment below the body of self( this method ).""

	| answer next matchGen n m matching count |
										""MT b:#after: s:self.""
 answer :=
	( ( anObject isParam )and:[ anObject p1 = #subSequence ] )
		ifTrue:[ ""=======(1)========"" 
			( 1 halt ).""<--------[ debug this and then delete the halt.  And make up some test cases. ]""
			( matchGen := anObject p2 asGenerator ).
			( m:=matchGen first ).
			( matching:=false ).
			self after:[ :x | 
				matching 
					ifTrue:[ 
						( x = m )
							ifTrue:[ ( m := matchGen next ) isNil ] ""<----[ Check if pattern finished ]""
							ifFalse:[ ""<------------------------------------[ Check if the pattern is restarting ]""
								( m := matchGen first ).
								( ( x = m ) ifFalse:[ matching:=false ] ).
								( m isNil ) ] ]""<---------------------------------[ Check if pattern finished ]""
					ifFalse:[ ( x = m ) and:[ ( matching := true ).( ( m:=matchGen next ) isNil ) ] ]
			] ] ifFalse:[
	( ( anObject isParam )and:[ anObject p1 = #subSequenceN ] )
		ifTrue:[ ""=======(2)========"" 
			( 1 halt ).""<--------[ debug this and then delete the halt.  And make up some test cases. ]""
			( matchGen := anObject p2 asGenerator ).
			( count := anObject p3 ).
			( m:=matchGen first ).
			( matching:=false ).
			(
			( self 
			) reset:[ :na | ( self reset ).( n := count ) ]
			) after:[ :x | 
				matching 
					ifTrue:[ 
						( x = m )
							ifTrue:[ ( ( m := matchGen next ) isNil )and:[ 0 = ( n := n - 1 ) ] ] ""<----[ Check if pattern finished ]""
							ifFalse:[ ""<------------------------------------------------------------------------[ Check if the pattern is restarting ]""
								( m := matchGen first ).
								( ( x = m ) ifFalse:[ matching:=false ] ).
								( m isNil )and:[ 0 = ( n := n - 1 ) ] ] ]""<-------------------------------------[ Check if pattern finished ]""
					ifFalse:[ 
						( x = m ) and:[ 
						( matching := true ).( ( m:=matchGen next ) isNil )and:[ 0 = ( n := n - 1 ) ] ] ]
			] ] ifFalse:[
	( ( anObject respondsTo: #value: )and:[ anObject notNil ] )
		ifTrue:[
			self abstractGenerator new
				resetBlock:[ next := self first.
					[ ( next == nil )or:[ anObject value: next ] ]whileFalse:[ next := self next ] ]
				nextBlock:[ self next ] ]ifFalse:[
	( ( anObject isSequence )and:[ anObject notNil ] )
		ifTrue:[ 
			self abstractGenerator new
				resetBlock:[ next := self first.
					[ ( next == nil )or:[ anObject includes: next ] ]whileFalse:[ next := self next ] ]
				nextBlock:[ self next ] ]
	ifFalse:[
		self abstractGenerator new
			resetBlock:[ next := self first.
				[ ( next == nil )or:[ anObject = next ] ]whileFalse:[ next := self next ] ]
			nextBlock:[ self next ]
	] ] ] ] .
										""MT e:#after: s:self.""
	^answer .

        ""anObject can be either an arbitrary Object
        or it can be a sequence object that responds to both >>isSequence and >>includes:
        or it can be a monadic valuable( responds to >>value: ).

        Let self = <s1 s2 s3 s4 ...>
        Then return <si+1 si+2 si+3 ... > where

            [ si = anObject ] == true                        if anObject was NOT a monadic valuable or a sequence.
            or
            [ anObject value: si ] == true               if anObject was a monadic valuable
            or
            [ anObject includes: si ] == true .        if anObject was a sequence.
	    or
	    anObject is a KEGParam with ( anObject p1 ) = #subSequence and with
		( anObject p2 ) is a sequence S.  S is a sequence if it makes ( S isSequence )
		return true.  Then if S is a sub sequence of self then the returned Generator G is all the elements of
		self after the last element of S's first occurance in self.
	    or
	    anObject is a KEGParam with ( anObject p1 ) = #subSequenceN and with
		( anObject p2 ) is a sequence S.  S is a sequence if it makes ( S isSequence )
		return true.  And ( anObject p3 ) is an Integer N
		Then if S is a sub sequence of self at least N times then the returned Generator G is all the elements of
		self after the last element of the sub sequence S's Nth occurance in self.

        Let anObject be a Sequence.   Then return <si+1 si+2 si+3 ... > where si is included in
        anObject.  In other words return a Generator of all elements of self AFTER anObject."

	( self assert:(
		( #(  ) asGenerator after: 1 ) asArray = #(  )
		) description:( '( #(  ) asGenerator after: 1 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator after: 1 ) asArray = #(  )
		) description:( '( #( 1 ) asGenerator after: 1 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator after: 2 ) asArray = #( 3 )
		) description:( '( #( 1 2 3 ) asGenerator after: 2 ) asArray = #( 3 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator after: 1 ) asArray = #( 2 3 )
		) description:( '( #( 1 2 3 ) asGenerator after: 1 ) asArray = #( 2 3 )' ) ).

	( self assert:(
		( #( '1' '2' '3' ) asGenerator after: '1' ) asArray = #( '2' '3' )
		) description:( '( #( ''1'' ''2'' ''3'' ) asGenerator after: ''1'' ) asArray = #( ''2'' ''3'' )' ) ).
		
	( self assert:(
		( #( 1 2 3 ) asGenerator after: 4 ) asArray = #(  )
		) description:( '( #( 1 2 3 ) asGenerator after: 4 ) asArray = #(  )' ) ).

	( self assert:(
		( #(  ) asGenerator after: #( 1 ) ) asArray = #(  )
		) description:( '( #(  ) asGenerator after: #( 1 ) ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator after: #( 1 ) ) asArray = #(  )
		) description:( '( #( 1 ) asGenerator after: #( 1 ) ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator after: #( 2 ) ) asArray = #( 3 )
		) description:( '( #( 1 2 3 ) asGenerator after: #( 2 ) ) asArray = #( 3 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator after: #( 1 ) ) asArray = #( 2 3 )
		) description:( '( #( 1 2 3 ) asGenerator after: #( 1 ) ) asArray = #( 2 3 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator after: #( 4 ) ) asArray = #(  )
		) description:( '( #( 1 2 3 ) asGenerator after: #( 4 ) ) asArray = #(  )' ) ).

	( self assert:(
		( #(  ) asGenerator after: [ :x | x = 1 ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator after: [ :x | x = 1 ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator after: [ :x | x = 1 ] ) asArray = #(  )
		) description:( '( #( 1 ) asGenerator after: [ :x | x = 1 ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator after: [ :x | x = 2 ] ) asArray = #( 3 )
		) description:( '( #( 1 2 3 ) asGenerator after: [ :x | x = 2 ] ) asArray = #( 3 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator after: [ :x | x = 1 ] ) asArray = #( 2 3 )
		) description:( '( #( 1 2 3 ) asGenerator after: [ :x | x = 1 ] ) asArray = #( 2 3 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator after: [ :x | x = 4 ] ) asArray = #(  )
		) description:( '( #( 1 2 3 ) asGenerator after: [ :x | x = 4 ] ) asArray = #(  )' ) ).
! !

!KEGGeneratorTest methodsFor: 'generatorAll' stamp: 'KjellGodo 10/20/2012 20:54'!
"(| defineMethod-:(" testallAreEqual ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20031210
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint 20031210
	)-notes methodBody-:(
 (| let-:(""| first |"")
    letBody-:("					"( MT b:#allAreEqual s:self ).""
	( first := self first ).
	^(
		( self exists:[ :x | x ~= first ] ) not

	)""return:( 					MT e:#allAreEqual s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return true if and only if all the elements of self are equal.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "
	
	self assert:( #(  ) asGenerator allAreEqual = true ).

	self assert:( #( 1 ) asGenerator allAreEqual = true ).

	self assert:( #( 1 1 1 ) asGenerator allAreEqual = true ).

	self assert:( #( 1 2 3 4 ) asGenerator allAreEqual = false ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"
! !

!KEGGeneratorTest methodsFor: 'generatorAll' stamp: 'KjellGodo 10/20/2012 10:01'!
testallOrderedPairs

	"Method Version: keg1.  "
	" Copyright Kjell E God Nov  9 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Nov  9 1999"

	"Return a Generator that consists of all the ordered pairs in self."

	self assert:(
		(
		( #( 1 2 ) asGenerator allOrderedPairs
		) collect:[ :p | Array with: p x with: p y ]
		) asArray = #( ( 1 1 ) ( 1 2 ) ( 2 1 ) ( 2 2 ) ) )! !

!KEGGeneratorTest methodsFor: 'generatorAll' stamp: 'KjellGodo 10/20/2012 10:10'!
testallSatisfy

	"Method Version: keg2.  "
	"Copyright Kjell E God Apr 28, 1993"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today 30 June 2011 , Apr 28, 1993"
	
	self assert:( #( 1 1 1 ) asGenerator allSatisfy:[ :x | x = 1 ] )! !

!KEGGeneratorTest methodsFor: 'generatorAll' stamp: 'KjellGodo 10/20/2012 10:17'!
testallUnEqualOrderedPairs

	"Method Version: keg1.  "
	" Copyright Kjell E God Nov  9 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Nov  9 1999"

	"Return a Generator that consists of all the unequal ordered pairs in self." 
	
	self assert:( 
		(
		( #( 1 2 ) asGenerator allUnEqualOrderedPairs 
		) collect:[ :p | Array with: p x with: p y ]
		) asArray = #( ( 1 2 ) ( 2 1 ) ) )! !

!KEGGeneratorTest methodsFor: 'combining' stamp: 'KjellGodo 10/20/2012 10:28'!
testalternateWith

	"Method Version: keg3.  "
	" Copyright Kjell E God Feb  6 1998"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today February 02 2000, September 22 1999, Feb  6 1998"

	self assert:( ( #(  ) asGenerator alternateWith: #( 2 4 6 ) ) asArray = #(  ) ).

	self assert:( ( #( 1 3 ) asGenerator alternateWith: #(  ) ) asArray = #( ) ).

	self assert:( ( #( 1 3 ) asGenerator alternateWith: #( 2 4 6 ) ) asArray = #( 1 2 3 4 ) ).

	self assert:( ( #( 1 3 5 ) asGenerator alternateWith: #( 2 4 ) ) asArray = #( 1 2 3 4 ) ).

	self assert:( ( #( 1 3 5 ) asGenerator alternateWith: #( 2 4 6 ) ) asArray = #( 1 2 3 4 5 6 ) )! !

!KEGGeneratorTest methodsFor: 'testing' stamp: 'KjellGodo 4/20/2013 14:23'!
testand

	"Method Version: keg1.  "
	"Copyright Kjell E God Mar 30 1995"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Mar 30 1995"

	self assert:( #( true ) asGenerator and first ).
		
	self assert:( #( true true true ) asGenerator and first ).
	
	self assert:( #( true true false ) asGenerator and first not ).
	
	self assert:( #(  ) asGenerator and first not )! !

!KEGGeneratorTest methodsFor: 'converting' stamp: 'KjellGodo 10/20/2012 20:53'!
"(| defineMethod-:(" testasAddAllableCollection ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20110813
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110813 19:47 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:(						( MT b:#asAddAllableCollection: s:self ).""
	^(
		( aCollection addAll:( self ) ; yourself ) 

	)""return:( 						MT e:#asAddAllableCollection: s:self )

    )-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a aCollection with the elements of self addAll:ed into it.

 )-summary
 methodDescriptionDetail-:(

	Self this Method could be used to do concatenations.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... ) )-chg )-keg2
 )-changes
 testCases-:( "
	
	self assert:( ( #(  ) asGenerator asAddAllableCollection:( OrderedCollection new ) ) asArray = #(  ) ).

	self assert:( ( #( 1 2 3 ) asGenerator asAddAllableCollection:( OrderedCollection new ) ) asArray = #( 1 2 3 ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'converting' stamp: 'KjellGodo 10/20/2012 20:52'!
"(| defineMethod-:(" testasArray ")
	notes-:(		Method Version: keg1
				 Copyright Kjell E God 20110629
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110629 20:40 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#asArray s:self ).""
	^( 	
		( self asArray: 128 )

	)""return:( 					MT e:#asArray s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return an Array with the present contents of self in it.

 )-summary
 methodDescriptionDetail-:(

	Initialize the WriteStream to an initial size of 128 elements.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:(  ) madeChanges-:(  )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	self assert:( ( #(  ) asGenerator asArray ) = #(  ) ).

	self assert:( ( #( 1 ) asGenerator asArray ) = #( 1 ) ).

	self assert:( ( #( 1 2 3 ) asGenerator asArray ) = #( 1 2 3 ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'converting' stamp: 'KjellGodo 10/21/2012 07:38'!
testasOrderedCollection

        "Method Version: keg1.  "
        "Copyright Kjell E God 04-21-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today July 24 1999, 04-21-92"

        "Return an OrderedCollection of the elements of self.""
	| answer |
							""( MT b:#asOrderedCollection s:self ).""
	( answer := OrderedCollection new ).
	( self do:[ :x | answer addLast: x ] ).
	^(
		( answer )

	)""return:(					MT e:#asOrderedCollection s:self )"

	self assert:( ( ( #(  ) asGenerator asOrderedCollection ) add: 1 ; asArray ) = #( 1 ) )
		description:( '( ( #(  ) asGenerator asOrderedCollection ) add: 1 ; asArray ) = #( 1 )' ).

	self assert:( ( ( #( 1 ) asGenerator asOrderedCollection ) add: 2 ; asArray ) = #( 1 2 ) )
		description:( '( ( #( 1 ) asGenerator asOrderedCollection ) add: 2 ; asArray ) = #( 1 2 )' ).

	self assert:( ( ( #( 1 2 3 ) asGenerator asOrderedCollection ) add: 4 ; asArray ) = #( 1 2 3 4 ) )
		description:( '( ( #( 1 2 3 ) asGenerator asOrderedCollection ) add: 4 ; asArray ) = #( 1 2 3 4 )' ).

	""
! !

!KEGGeneratorTest methodsFor: 'converting' stamp: 'KjellGodo 10/21/2012 07:57'!
testasOrderedCollectionColon

        "Method Version: keg1.  "
        "Copyright Kjell E God 27 July 2011"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today 27 July 2011""
	| answer |
							""( MT b:#asOrderedCollection: s:self ).""
	( answer := anOrderedCollection ).
	( self do:[ :x | answer addLast: x ] ).
	^(
		( answer )

	)""return:(					MT e:#asOrderedCollection: s:self )"

        "Return anOrderedCollection of the elements of self.  This could also be used
	to concatenate several Generators into one single OrderedCollection or something
	else that responds to >>addLast: "

	self assert:( ( ( #(  ) asGenerator asOrderedCollection:( OrderedCollection new add: 1 ; yourself ) ) add: 2 ; asArray ) = #( 1 2 ) )
		description:( '( ( #(  ) asGenerator asOrderedCollection:( OrderedCollection new add: 1 ; yourself ) ) add: 2 ; asArray' ) .

	self assert:( ( ( #( 2 ) asGenerator asOrderedCollection:( OrderedCollection new add: 1 ; yourself ) ) add: 3 ; asArray ) = #( 1 2 3 ) )
		description:( '( ( #( 2 ) asGenerator asOrderedCollection:( OrderedCollection new add: 1 ; yourself ) ) add: 3 ; asArray' ) .

	self assert:( ( ( #( 2 3 ) asGenerator asOrderedCollection:( OrderedCollection new add: 1 ; yourself ) ) add: 4 ; asArray ) = #( 1 2 3 4 ) )
		description:( '( ( #( 2 3 ) asGenerator asOrderedCollection:( OrderedCollection new add: 1 ; yourself ) ) add: 4 ; asArray' ) .

	""
! !

!KEGGeneratorTest methodsFor: 'converting' stamp: 'KjellGodo 10/21/2012 08:23'!
testasSet

	"Method Version: keg2.  "
	"Copyright Kjell E God 04-21-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today 04-21-92""
	| answer |
							""MT b:#asSet s:self.""

	answer := Set new addAll: self ; yourself .

							""MT e:#asSet s:self.""
	^answer .

	""Return an Set of the elements of self. KEG2: Cleaned it up for Dolphin Smalltalk adding the 
	MT and answer stuff."

	self assert:( ( #(  ) asGenerator asSet ) equals:( #(  ) asSet ) )
		description:( '( #(  ) asGenerator asSet ) equals:( #(  ) asSet )' ).

	self assert:( ( #( 1 ) asGenerator asSet ) equals:( #( 1 ) asSet ) )
		description:( '( #( 1 ) asGenerator asSet ) equals:( #( 1 ) asSet )' ).

	self assert:( ( #( 1 2 3 ) asGenerator asSet add: 4 ; yourself ) equals:( #( 1 2 3 4 ) asSet ) )
		description:( '( #( 1 2 3 ) asGenerator asSet add: 4 ; yourself ) equals:( #( 1 2 3 4 ) asSet )' ).

	""! !

!KEGGeneratorTest methodsFor: 'converting' stamp: 'KjellGodo 4/21/2013 08:25'!
testasSortedCollection

	"Method Version: keg1.  "
	" Copyright Kjell E God 04-21-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today 04-21-92"
	"| answer |"
						"MT b: #asSortedCollection s: self ."

	"( answer := SortedCollection new ) addAll: self ."

						"MT e: #asSortedCollection s: self ."
	"^answer ."

	"Return a SortedCollection of the elements of self."

	( self assert:( 
		#(  ) asGenerator asSortedCollection asArray = #(  ) 
		)description:( '#(  ) asGenerator asSortedCollection asArray = #(  )' ) ).

	( self assert:( 
		#( 1 ) asGenerator asSortedCollection asArray = #( 1 ) 
		)description:( '#( 1 ) asGenerator asSortedCollection asArray = #( 1 )' ) ).

	( self assert:( 
		#( 3 2 5 4 1 ) asGenerator asSortedCollection asArray = #( 1 2 3 4 5 ) 
		)description:( '#( 3 2 5 4 1 ) asGenerator asSortedCollection asArray = #( 1 2 3 4 5 )' ) ).
! !

!KEGGeneratorTest methodsFor: 'converting' stamp: 'KjellGodo 4/25/2013 17:42'!
testasSortedCollectionCaSortBlock"asSortedCollection: aSortBlock"

	"Method Version: keg1.  "
	" Copyright Kjell E God 20001209"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20001209"
	"| answer |"
							"MT b:#asSortedCollection: s:self."

	"( answer := SortedCollection sortBlock: aSortBlock ) addAll: self ."

							"MT e:#asSortedCollection: s:self."
	"^answer ."
	"Return a SortedCollection which sorts the elements of self according to the diadicValuable aSortBlock.
	( It would be convenient if self were finite in length. )"

	( self assert:( 
		( #(  ) asGenerator asSortedCollection:[ :a :b | a < b ] ) asArray = #(  )
		)description:( '( #(  ) asGenerator asSortedCollection:[ :a :b | a < b ] ) asArray = #(  )' ) ).

	( self assert:(  
		( #( 1 ) asGenerator asSortedCollection:[ :a :b | a < b ] ) asArray = #( 1 )
		)description:( '( #( 1 ) asGenerator asSortedCollection:[ :a :b | a < b ] ) asArray = #( 1 )' ) ).

	( self assert:(  
		( #( 3 2 5 4 1 ) asGenerator asSortedCollection:[ :a :b | a < b ] ) asArray = #( 1 2 3 4 5 )
		)description:( '( #( 3 2 5 4 1 ) asGenerator asSortedCollection:[ :a :b | a < b ] ) asArray = #( 1 2 3 4 5 )' ) ).
! !

!KEGGeneratorTest methodsFor: 'printing' stamp: 'KjellGodo 4/21/2013 08:29'!
testasString

        "Method Version: keg3.  "
        "Copyright Kjell E God Jun 27 1995"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today March 03 2000, Feb  6 1998, Jun 27 1995"
	"| first stream |"				"( MT b:#asString s:self ).""
	^(
		( self isOnAStream ""<---[ First we try for a common(?) short cut. ]""
			ifTrue:[ 
				( ( stream := self generator ) size = 1 ) 
					ifTrue:[ 
						( ( first := stream reset ; next ) isString )
							ifTrue:[ ^( first )""return:( MT e:#asString s:self ).""  ]
							ifFalse:[ first displayString ] ]
					ifFalse:[ self displayString ] ]
			ifFalse:[ self displayString ] ) ""<---[ KEG3 ]""

	)""return:(							MT e:#asString s:self )"

	( self assert:( 
		'12345' asGenerator asString = '12345'
		) description:( '''12345'' asGenerator asString = ''12345''' ) ).

	( self assert:( 
		#( $3 ) asGenerator asString = '3'
		) description:( '#( $3 ) asGenerator asString = ''3''' ) ).

	( self assert:( 
		#( '12' $3 '45' ) asGenerator asString = '12345'
		) description:( '#( ''12'' $3 ''45'' ) asGenerator asString = ''12345''' ) ).

	"inject: String writeStream into:[ :strm :chr | chr displayOn: strm . strm ] . ""<---( chr may be a Character, a String, or a Generator etc. )""
	answer := answer contents  ."

	"Return a String which is the concatenation of the String representations of all the Objects in self. This
	is useful mostly if self is a sequence of Strings and/or Characters. But if there are any nonStrings in self
	then it will not cause an error, the displayStrings of the nonStrings will be used.
	DEPENDENCIES: the FiledObject senders of >>pathName depend on this method not causing any
	( actually: ''more than three'' ) Param class>>new executions.  KEG3: changed to using the 
	more general displayString way which uses displayOn: which also handles individual Characters
	well."

	"The following comment was moved here from the now defunct KEGStringGenerator>>asString
	method."

        "Method Version: keg4.  "
        "Copyright Kjell E God Mar  7, 1994"
        "Date of Last Revision: Date today October 02 1999, April 14 1999, Feb 6 1997, Mar  7 1994"

	"Return all the Strings of self concatonated together into one String.
	KEG2: added x asString in case x is not a String.  KEG3: moved code to Dolphin version 2.1 patch
	level 2. Also I will try standardizing on StringGenerators of Strings that are not followed by a blank.
	This is more in line with the Ansii >>subString: method.  Thus I will add a blank after each String in
	self.  If this behavior is to be stopped then perhaps a property can be set in self.
	KEG4: Decided against the trailing blank bit when I apparently ran into the same problems that made
	me create the >>upToIncluding: stuff in the previous times in Smalltalk/V 2.0.  This time in Dolphin
	2.1 patch level 2 the	>>upToIncluding: stuff seems to be coming off a lot more cleanly.  I guess that's
	what happens when you rewrite something that you wrote that is a half decade old.  And a bit crabbed.
	But If I try to rewrite a third time, according to the Mythical Man Month, I would probably just screw
	it up. And I think I agree.  Maybe the way it is now, is as good as it gets.  This time around I'm really
	avoiding excess complexity.  And screwball ness."

	"The original code for that method follows-:

    answer := self 
		inject:( String new: 256 ) writeStream 
		into:[ :strm :str | strm nextPutAll: str asString . strm ] . 
    answer := answer contents .

	"! !

!KEGGeneratorTest methodsFor: 'accessing' stamp: 'KjellGodo 4/25/2013 17:42'!
"(| defineMethod-:(" testat "at: anInteger "")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God 20020716 yyyymmdd
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110814 15:33 ) 20020716
	)-notes methodBody-:(
 (| let-:(""| count answer |"")
    letBody-:(""					""( MT b:#at: s:self ).""
	( ( self respondsTo: #position: )
		ifTrue:[ ( self position: anInteger ).( answer := self next ) ]
		ifFalse:[ 
			( count := -1 ).( self reset ).
			[ ( count := count + 1 ) < anInteger ]whileTrue:[ answer := self next ] ] ).
	^(
		( answer )

	)""return:( 					MT e:#at: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return the element in self  at: anInteger index .  Just like for Collections.
	Also if self >>respondsTo: #position: then we do it that way also.

 )-summary
 methodDescriptionDetail-:(

	If self respondsTo: #position: then self This Method is much more efficient
	potentially.  Also in that case 0 is the index of the first element of self.
	Otherwise 1 is the index of the first element of self.

	Please note that self-:( this method ) is a very
	inefficient >>at: based access compared to the >>at: of Collections.  So if you
	are planning on doing a lot of >>at: calls into self you are probably better off doing
	( oc := self asOrderedCollection ) and then doing the >>at: calls into the oc .
	See File class>>splitPathKEG: for a reasonable usage.

 )-detail
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-: ( Changes onDate-:( 20110814 ) theOldCode-:( ... ) wasReplacedBy-:( new >>position: stuff ) )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:( 
		( #( 1 2 3 4 5 ) asGenerator at: -1 ) = nil
	)description:( '( #( 1 2 3 4 5 ) asGenerator at: -1 ) = nil ' ) ).

	( self assert:( 
		( #( 1 2 3 4 5 ) asGenerator at:0 ) = nil
	)description:( '( #( 1 2 3 4 5 ) asGenerator at:0 ) = nil ' ) ).

	( self assert:( 
		( #( 1 2 3 4 5 ) asGenerator at:1 ) = 1 
	)description:( '( #( 1 2 3 4 5 ) asGenerator at:1 ) = 1 ' ) ).

	( self assert:( 
		( #( 1 2 3 4 5 ) asGenerator at:2 ) = 2 
	)description:( '( #( 1 2 3 4 5 ) asGenerator at:2 ) = 2 ' ) ).

	( self assert:( 
		( #( 1 2 3 4 5 ) asGenerator at:5 ) = 5 
	)description:( '( #( 1 2 3 4 5 ) asGenerator at:5 ) = 5 ' ) ).

	( self assert:( 
		( #( 1 2 3 4 5 ) asGenerator at:6 ) = nil 
	)description:( '( #( 1 2 3 4 5 ) asGenerator at:6 ) = nil ' ) ).

" )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorTransposing' stamp: 'KjellGodo 4/25/2013 17:42'!
"(| defineMethod-:(" testatAllGenerateinto "atAllGenerate: newGenBlock into: aHolder "")
	notes-:(		Method Version: keg3.
				 Copyright Kjell E God Sep 25 1996
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20020915 , Mar 19 1997<---( keg2 ), Sep 25 1996<---( keg1 )
	)-notes methodBody-:(
 (| let-:(""| answer resetBlock nextBlock allGenerators findNils fooSlot noNils allNils
	flagAdder next aholder aholderGen addBlock loopGen loopBlock selector
	firstBlock1 nextBlock1 lastBlock1 isNil nextGen |"")
    letBody-:(""					""( MT b:#atAllGenerate:into: s:self ).""

	( aholder := ( aHolder isParam )
		ifTrue:[
			( ( selector := aHolder p1 ) == #Collection )
				ifTrue:[ allGenerators := aHolder p2 . aHolder p3 ]ifFalse:[
			( selector  == #first:next:last: )
				ifTrue:[ allGenerators := aHolder p2 .
					firstBlock1 := aHolder p3 .
					nextBlock1 := aHolder p4 .
					lastBlock1 := aHolder p5 . 
					aHolder p6 ]
			ifFalse:[ self error: #atAllGenerate:into: ""<---( Wrong param selector. )"" ] ] ]
		ifFalse:[ 
			( ( aHolder == nil )
				ifTrue:[ aholder := OrderedCollection new:( 100 ) ]
				ifFalse:[ aholder := aHolder ] ).
			( allGenerators :=	
				( self collect:[ :g | newGenBlock value:( g asGenerator ) ] ) asOrderedCollection asGenerator ).
			aholder
		] ).  ""<----( LINE:1 This asOrderedCollection asGenerator is done so that we will not be allocating new Generators every time we access the allGenerators Generator.  This is not optional because otherwise the  gen resets will go to the wrong Generators. )""

	( fooSlot := KEGFooArray with: allGenerators ). ""<---------------------------------------------------------------------------( LINE:1 This is so you can get ahold of the allGenerators Via the AbstractGenerator>>config method as shown below. )""

""
    answer when: #releaseAllDeep perform:[ :nl :nl |        """"<--------------------------( LINE: 2 )""""
        ( Array with: loopGen with: findNils ) do:[ :x | x releaseAllDeep ] ] .
""

	^(
		( ( aholder == #Generator )
		ifTrue:[
			self abstractGenerator new
				resetBlock:[
					( ( aholderGen == nil ) ifTrue:[						""<---------------------------------------------( LINE:1.1 )""
						( aholderGen := KEGGenerator streamGenerator ).
						( aholder := aholderGen generator collection ). ""<---------( with: 1 is needed otherwise asGenerator will return nil as the empty Generator if the new OrderedCollection is empty.  The 1 is just a dummy value and will be removed by the removeAll below. )""
						( loopGen := self 
							atAllGenerate:( newGenBlock )
							into:( KEGParam p1:#Collection p2: allGenerators p3: aholder ) ).
					] ).
					( loopGen reset )
				]
				nextBlock:[ ( loopGen next isNil )ifFalse:[ aholder asStreamGeneratorOn:( aholderGen ) ] ] ]ifFalse:[  ""<---------( Returns aholderGen )""

		( 	( ( aholder isKindOf:( Collection ) ) not ) and:[ 
			( #( add: addFirst: addLast: ) allSatisfy:[ :xx | aholder respondsTo: xx ] ) ]
		)
		ifTrue:[ ( 1 halt ).
			( self abstractGenerator new )
				resetBlock:[
					allGenerators do:[ :gen | gen reset ] .""<-----------------------------( LINE:1.1 )""

					( ( loopGen isNil )ifTrue:[
						( findNils := ( KEGAbstractGenerator new )
							resetBlock:[ allGenerators reset . allNils := true ]nextBlock:[ allGenerators next ] ).
						( findNils := findNils collect:[ :gen |
							( ( next := gen next ) isNil )ifTrue:[ KEGFooArray ] ifFalse:[ allNils := false. next ]
						] ).
						( loopGen := findNils
							first:	[ :nxt | aholder addFirst: nxt ]
							next:	[ :nxt | aholder add: nxt ]
							last:	[ :nxt | aholder addLast: nxt ] )
					] ).
					( loopGen reset )
				]
				nextBlock:[ ( aholder removeAll ). ( loopGen iterate ).  ( allNils ifFalse:[ aholder ] ) ] ]ifFalse:[

	( selector == #first:next:last: )
		ifTrue:[
			( self abstractGenerator new )
				resetBlock:[
					( allGenerators do:[ :gen | gen reset ] ).""<-----------------------------( LINE:1.1 )""

					( ( loopGen isNil )ifTrue:[
						( findNils := KEGAbstractGenerator new
							resetBlock:[ allGenerators reset . allNils := true ]nextBlock:[ allGenerators next ] ).
						( findNils := findNils collect:[ :gen |
							( ( next := gen next ) isNil )ifTrue:[ KEGFooArray ]ifFalse:[( allNils := false ). next]
						] ).
						( loopGen := findNils
							first:(	firstBlock1 )
							next:(	nextBlock1 )
							last:(	lastBlock1 ) )
					] ).
					( loopGen reset )
				]
				nextBlock:[ aholder removeAll .  loopGen iterate .  allNils ifFalse:[ aholder ] ] ]ifFalse:[

	( ( selector == #Collection )and:[ aholder respondsTo:( #add: ) ] )
		ifTrue:[
			( self abstractGenerator new )
				resetBlock:[
					( ( loopGen isNil )ifTrue:[							   ""<-----------------------------( LINE:1.1 )""
						( findNils := ( KEGAbstractGenerator new )
							resetBlock:[ ( allGenerators reset ). ( allNils := true ) ]
							nextBlock:[ 
								( ( nextGen := allGenerators next ) isNil )
									ifFalse:[
										( ( next := nextGen next ) isNil )
											ifTrue:[ KEGFooArray ]ifFalse:[ allNils := false. next ] ]
									] ).
						( loopGen := ( self abstractGenerator new )
							resetBlock:[ allGenerators do:[ :gen | gen reset ] ]""<-----( There are no nils returned by any of the gens and so far at least one of the gens has returned a non nil ).""
							nextBlock:[ ( aholder removeAll ; addAll:( findNils ) ). ( allNils ifFalse:[ aholder ] ) ] )
					] ).
					( loopGen reset )
				]
				nextBlock:[ loopGen next ]
		]ifFalse:[ 

	( aHolder == nil )
		ifTrue:[ 
			( loopGen := allGenerators collect:[ :gen | ( isNil := ( next := gen next ) isNil ). next ] ).
			( ( self abstractGenerator new )
				resetBlock:[ ( allGenerators do:[ :gen | gen reset ] ). ( aholder removeAll ) ]
				nextBlock:[ ( aholder removeAll ; addAll:( loopGen ) ). ( isNil ifFalse:[ aholder ] ) ] )
		]
	ifFalse:[ self error: #atAllGenerate:into: ] ] ] ] ] )

	)""return:( 					MT e:#atAllGenerate:into: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Suppose self = < g1 g2 g3 ... gM >
	where each gi is a sequence where a sequence is anything that causes
	( gi isSequence = true ) to return true.
	Let	g1 = < a1 a2 a3 ... >
		g2 = < b1 b2 b3 ... >
		g3 = < c1 c2 c3 ... >
		. . .
		gM = < z1 z2 z3 ... > <---( PleaseNote-: You cannot assume that M=26.
								M is a positive Integer. That is
								the only assumption you can make. )
	Then return r =	< 	h<a1 b1 c1 ... z1>
					h<a2 b2 c2 ... z2>
					h<a3 b3 c3 ... z3>
					...
					>
	where h< ... > is a reused sequence Object like a KEGGenerator or
	OrderedCollection which is returned over and over again via the ( r next )
	expression but with different contents each time( Potentially different I should
	say. ).  PS-:( This is a simplified summary description.  For the full blast see the
	details below. )

	So suppose each gi above is a sequence of values of a stock option on a stock
	in the stock market.  Then r  is a sequence of groups of option values where each
	group is for a certain day.  Each group might be in the same global sequence Object
	which is returned over and over via the ( r next ) message but with different contents
	each time.

 )-summary
 methodDescriptionDetail-:(

	( KEG-:( the following blather is for the Smalltalk/V implementation and may
	not be the case for any other implementation in any other version of Smalltalk. ) )
	( PLEASE-NOTE: YOU MUST >>releaseAllDeep THE answer GENERATOR
	BECAUSE IT CONTAINS BLOCKS THAT POINT TO GENERATORS THAT
	POINT TO THE BLOCKS AGAIN AND SO THEY WONT BE GARBAGE
	COLLECTED.  YOU MUST ALWAYS REMEMBER TO
	>>releaseAllDeep ALL BLOCKS WHICH HAVE BEEN ASSIGNED TO A
	LOCAL VARIABLE.
	)---( This is no longer the case in Dolphin Smalltalk because the garbage
		collector is smarter.  If not then you can always go back to using the
		releaseAllDeep protocal in the KEGRelease Protocal Package. )

	Let self = s = <s1 s2 s3 ... sM> .
	Let r = the generator returned by self-:( this method ).
	Let ( newGenBlock value: si ) = gen( si ) = a generator on si.
		gen( si ) = < gsi1 gsi2 gsi3 ... > .

	If aHolder == #Generator then
		r = <		aGenerator<GS11 GS21 GS31 ... GSM1>
				aGenerator<GS12 GS22 GS32 ... GSM2>
				aGenerator<GS13 GS23 GS33 ... GSM3>
							  ...
				aGenerator<GS1N GS2N GS3N ... GSMN>
		> .
		Where N is the size of the longest gen( si ) .
		And any GSij which are nil in gen( si ) are replaced by KEGFooArray.
		( when all the gen( si ) return nil then r returns nil from then on until
		it receives the >>reset message. )


	If aHolder ( respondsTo: #add: ) and ( is a Collection
	or ( doesn't respondsTo: #addFirst: and #addLast: ) )
	then
		r =	<	aHolder<gs11 gs21 gs31 ... gsM1>
				aHolder<gs12 gs22 gs32 ... gsM2>
				aHolder<gs13 gs23 gs33 ... gsM3>
							  ...
				aHolder<gs1N gs2N gs3N ... gsMN>
			> .
		Where N is the size of the longest gen( si ) .
		And any GSij which are nil in gen( si ) are replaced by KEGFooArray.
		( when all the gen( si ) return nil then r returns nil from then on until
		it receives the >>reset message. )


	If aHolder respondsTo: #add: #addFirst: #addLast: and is not a Collection then
		r = < 	aHolder<f(gs11) n(gs21) n(gs31) ... L(gsM1)>
				aHolder<f(gs12) n(gs22) n(gs32) ... L(gsM2)>
				aHolder<f(gs13) n(gs23) n(gs33) ... L(gsM3)>
							  ...
				aHolder<f(gs1N) n(gs2N) n(gs3N) ... L(gsMN)>
			   > .
		Where N is the size of the longest gen( si )
		And any GSij which are nil in gen( si ) are replaced by KEGFooArray.
		and f( x ) = ( aHolder addFirst: x ),   n( x ) = ( aHolder add: x ),
			 L( x ) = ( aHolder addLast: x ).  And L( x ) is only done on the gsMi
		above.
		( when all the gen( si ) return nil then r returns nil from then on until
		it receives the >>reset message. )


	If aHolder is a KEGParam of form: 
		KEGParam-:( p1:( #first:next:last: )p2:( fBlk )p3:( nBlk )p4:( LBlk )p5:( aHolder ) )

		r =	<	[ fBlk(gs11). nBlk(gs21). nBlk(gs31). ... LBlk(gsM1). aHolder ] value
				[ fBlk(gs12). nBlk(gs22). nBlk(gs32). ... LBlk(gsM2). aHolder ] value
				[ fBlk(gs13). nBlk(gs23). nBlk(gs33). ... LBlk(gsM3). aHolder ] value
							  ...
				[ fBlk(gs1N). nBlk(gs2N). nBlk(gs3N). ... LBlk(gsMN). aHolder ] value
			> .
		Where N is the size of the longest gen( si )
		And any GSij which are nil in gen( si ) are replaced by KEGFooArray.
		and fBlk and nBlk and lBlk are single parameter Blocks
		and fBlk( x ) = 	( fBlk value: x )
		and nBlk( x ) =	( nBlk value: x )
		and LBlk( x ) =	( LBlk value: x ).  And LBlk is only done on the gsMi above.
		( when all the gen( si ) return nil then r returns nil from then on until
		it receives the >>reset message. )


    If aHolder is a KEGParam of form-:
		KEGParam-:(
			p1: #Collection
			p2: ( aGenerator collect:[ :x | x asGenerator ] 
				) asOrderedCollection asGenerator
			p3:( aHolder := OrderedCollection new )
		)

		r =	<	aHolder<gs11 gs21 gs31 ... gsM1>
				aHolder<gs12 gs22 gs32 ... gsM2>
				aHolder<gs13 gs23 gs33 ... gsM3>
							  ...
				aHolder<gs1N gs2N gs3N ... gsMN>
			> .
		Where N is the size of the longest gen( si ) .
		And any GSij which are nil in gen( si ) are replaced by KEGFooArray.
		( when all the gen( si ) return nil then r returns nil from then on until
		it receives the >>reset message. )


    If aHolder == nil

		r =	<	OC<gs11 gs21 gs31 ... gsM1>
				OC<gs12 gs22 gs32 ... gsM2>
				OC<gs13 gs23 gs33 ... gsM3>
							  ...
				OC<gs1N gs2N gs3N ... gsMN>
			> .
		Where N is the size of the SHORTEST gen( si ) .<---( It's opposite of all the
		ones above seen so far.  So take note.  KEGFooArrays are not added here. )
		And OC< ... > is a new OrderedCollection created by self-:( this method ) and
		returned over and over with different contents( potentially different contents I
		should say. ).
		If you want r to be a sequence of Generators and not a sequence of
		OrderedCollections you can do-:(
			( gen := KEGGenerator streamGenerator ).
			( ( aGenerator atAllGenerate: newGenBlock into: #notNil )
				collect:[ :oc | oc asStreamGeneratorOn: gen ] ).
		)
		or more simply-:(
			( aGenerator atAllGenerate: newGenBlock into: #notNil )
				sortIntoChangeOCsToGenerators
		)
		which does exactly the same thing.
		or if you want to return r a sequence of StringGenerators you can do-:(
			( aGenerator atAllGenerate: newGenBlock into: #notNil )
				sortIntoChangeOCsToStringGenerators
		)



    PLEASE-NOTE: self( this method ) assumes that self does not change from
    the time self( this method ) is executed and for all time thereafter.  If self does change
    too much then because of the positioning of the lines marked ( LINE:1 ) above
    such changes will not show up in successive runs of returned Gen G of self( this
    method ).  If this is not acceptable and such changes are to be registered in succesive
    iterations of the returned Gen G then lines marked ( LINE:1 ) above are to be cut out
    and inserted just above the lines marked ( LINE:1.1 ) above.

    ( As of <D:20020915> the following note is no longer being used as it is
    commented out above-:(
    ALSO-PLEASE-NOTE: the answer Generator G returned by self( this method ) has
    >>releaseAllDeep properties added to it.  This is because there are Blocks in
    self( this method ) that are part of Generators that are assigned to local variables.
    So it was thought that since that constitutes a circular reference and should not
    be garbage collectable then we would have to have a special releaseAllDeep
    properties to release the locally assigned Generators.  But when we test to see
    if there are Blocks left over from self( this method ) after G has been cut loose to
    the garbage collector but before the special releaseAllDeep is done then no
    arrant noncollected blocks are found.  This indicates that the special
    >>releaseAllDeep properties are not needed.   Therefore you might delete
    LINE: 2 above.  But before you do test more to see if the statements of
    self( this ALSO-PLEASE-NOTE: ) are true. )-outabove )

 )-detail
 todos-:(
	todos
 )-todos
 changes-:(

	(| KEG3-: ( Changes onDate-:( 20020915 ) were-:( I ported self-:( this method )
		over here to Dolphin Smalltalk version 2.1 patch level 2 from its point of
		origination in Smalltalk/V 2.0 . ) )-chg )-keg3
	(| KEG2-: ( Changes onDate-:( Mar 19 1997 ) were-:( I changed it so now N below
		is the longest instead of the shortest and any gen in allGenerators that returns
		nil before the others will have that nil replaced by KEGFooArray. ) )-chg
	)-keg2

 )-changes
 testCases-:( ""

	( self assert:(
	(	( 
			#( ( 11 12 13 14 15 ) ( 21 22 23  ) ( 31 32 33 34 ) 
			  ) asGenerator atAllGenerate:( nil )into:( nil )
		) collect:[ :oc | oc asArray copyReplacing:( KEGFooArray )withObject:( $f ) ]
	) asArray =
	#(
		( 11 21 31 )
		( 12 22 32 )
		( 13 23 33 )
	) ) ).



	( self assert:(
	(	( 
			#( ( 11 12 13 14 15 ) ( 21 22 23  ) ( 31 32 33 34 ) ) asGenerator
				atAllGenerate:[ :array | array collect:[ :i | i + 1 ] ]into:( nil )
		) collect:[ :oc | oc asArray copyReplacing:( KEGFooArray )withObject:( $f ) ]
	) asArray =
	#(
		( 12 22 32 )
		( 13 23 33 )
		( 14 24 34 )
	) ) ).



	( self assert:(
	(	( #( ( 1 2 3 4 5 ) ( 1 2 3  ) ( 1 2 3 4 ) ) asGenerator
			atAllGenerate:( nil )into:( #Generator )
		) collect:[ :gen | 
			gen asArray copyReplacing:( KEGFooArray )withObject:( $f ) ]
	) asArray =
	#(
		( 1 1 1 )
		( 2 2 2 )
		( 3 3 3 )
		( 4 $f 4 )
		( 5 $f $f )
	) ) ).



	( self assert:(
	(	( #( ( 1 2 3 4 5 ) ( 1 2 3  ) ( 1 2 3 4 ) ) asGenerator
			atAllGenerate:[ :x | x asGenerator ]into:( #Generator )
		) collect:[ :gen | 
			gen asArray copyReplacing:( KEGFooArray )withObject:( $f ) ]
	) asArray =
	#(
		( 1 1 1 )
		( 2 2 2 )
		( 3 3 3 )
		( 4 $f 4 )
		( 5 $f $f )
	) ) ).



	( self assert:(
	(	( #( ( 1 2 3 4 5 ) ( 1 2 3  ) ( 1 2 3 4 ) ) asGenerator
			atAllGenerate:[ :x | x asGenerator ] into:( OrderedCollection new )
		) collect:[ :gen | 
			( gen asArray )
				copyReplacing:( KEGFooArray )
				withObject:( $f ) ]
	) asArray =
	#(
		( 1 1 1 )
		( 2 2 2 )
		( 3 3 3 )
		( 4 $f 4 )
		( 5 $f $f )
	) ) ).



	( self assert:(
	(	( nil atAllGenerate:( nil )into:( KEGParam
			p1: #Collection
			p2:( #( ( 1 2 3 4 5 ) ( 1 2 3  ) ( 1 2 3 4 ) ) asGenerator
				collect:[ :x | x asGenerator ] ) asOrderedCollection asGenerator
			p3: OrderedCollection new )
		) collect:[ :gen | 
			gen asArray
			copyReplacing:( KEGFooArray )withObject:( $f ) ]
	) asArray =
	#(
		( 1 1 1 )
		( 2 2 2 )
		( 3 3 3 )
		( 4 $f 4 )
		( 5 $f $f )
	) ) ).



	[ | aholder |
	(	( #( ( 1 2 3 4 5 ) ( 1 2 3  ) ( 1 2 3 4 ) ) asGenerator
			atAllGenerate:[ :x | x asGenerator ] into:( ""KEGAtAllGenerateTest"" nil new )
		) collect:[ :gen | 
			gen asArray
			copyReplacing:( KEGFooArray )withObject:( $f ) ]
	) asOrderedCollection asArray =
	#(
		( 1 1 1 )
		( 2 2 2 )
		( 3 3 3 )
		( 4 $f 4 )
		( 5 $f $f )
	) ].
	""You have to create the AtAllGenerateTest Class
	by evaluating-:( ( SessionManager current imageBase , 'Atallgnr.cls' ) edit )
	and then doing-:(
	<PopUpMenu>=> <S>( Select All )=> <PopUpMenu>=>
	<M>( Manipulate... )=> <O>( Open Workspace On )
	)-thendoing .""



	[ | aholder |
	aholder := ""KEGAtAllGenerateTest"" nil new .
	(	( 
			#( ( 1 2 3 4 5 ) ( 1 2 3  ) ( 1 2 3 4 ) )
				atAllGenerate:[ :x | x asGenerator ]
				into:( KEGParam p1: #first:next:last:
					p2:[ :x | aholder addFirst: x ]
					p3:[ :x | aholder add: x ]
					p4:[ :x | aholder addLast: x ]
					p5: aholder )
		) collect:[ :gen | 
			gen asArray 
			copyReplacing:( KEGFooArray )withObject:( $f ) ]
	) asOrderedCollection asArray =
	#(
		( 1 1 1 )
		( 2 2 2 )
		( 3 3 3 )
		( 4 $f 4 )
		( 5 $f $f )
	) ].
	""You have to create the AtAllGenerateTest Class
	by evaluating-:( ( SessionManager current imageBase , 'Atallgnr.cls' ) edit )
	and then doing-:(
	<PopUpMenu>=> <S>( Select All )=> <PopUpMenu>=>
	<M>( Manipulate... )=> <O>( Open Workspace On )
	)-thendoing .""

 "" )-testCases
 oldCode-:(
	-----------------------------------------------------------OLD CODE:---------------------------------------------------------->
    aholder := aHolder isParam
        ifTrue:[
            ( ( selector := allGenerators removeFirst ) == #Collection )
                ifTrue:[ allGenerators := aHolder removeFirst . aHolder removeFirst ]ifFalse:[
            ( selector  == #first:next:last: )
                ifTrue:[ allGenerators := aHolder removeFirst .
                    firstBlock1 := aHolder removeFirst .
                    nextBlock1 := aHolder removeFirst .
                    lastBlock1 := aHolder removeFirst . aHolder removeFirst ]
            ifFalse:[ self error: #atAllGenerate:into: ''<---( Wrong param selector. )'' ] ] ]
        ifFalse:[ allGenerators := ( self collect: newGenBlock )
                    asOrderedCollection asGenerator .  aHolder ] .  ''<----( LINE:1 This asOrderedCollection asGenerator is done so that we will not be allocating new Generators every time we access the allGenerators Generator.  This is not optional because otherwise the  gen resets will go to the wrong Generators. )''
    fooSlot := FooArray with: allGenerators . ''<---------------------------------------------------------------------------( LINE:1 This is so you can get ahold of the allGenerators Via the AbstractGenerator>>config method as shown below. )''

    answer := aholder == #Generator
        ifTrue:[
            self abstractGenerator new
                resetBlock:[
                    aholderGen == nil ifTrue:[                        ''<---------------------------------------------( LINE:1.1 )''
                        aholderGen := ( aholder := OrderedCollection with: 1 ) asGenerator . ''<---------( with: 1 is needed otherwise asGenerator will return nil as the empty Generator if the new OrderedCollection is empty.  The 1 is just a dummy value and will be removed by the removeAll below. )''
                        loopGen := self atAllGenerate: newGenBlock
                            into:( P p1:#Collection p2: allGenerators p3: aholder ) .
                    ] .
                    loopGen reset
                ]
                nextBlock:[ loopGen next == nil ifFalse:[ aholder asArrayGenerator: aholderGen ] ] ]ifFalse:[  ''<---------( Returns aholderGen )''

    ( aholder isCollection not
    and:[ #( add: addFirst: addLast: ) allSatisfy:[ :xx | aholder respondsTo: xx ] ] )
        ifTrue:[ 1 halt.
            self abstractGenerator new
                resetBlock:[
                    allGenerators do:[ :gen | gen reset ] .''<-----------------------------( LINE:1.1 )''

                    loopGen == nil ifTrue:[
                        findNils := allGenerators collect:[ :gen |
                            ( next := gen next ) == nil ifTrue:[ noNils := false .  nil ] ifFalse:[ next ]
                        ] .
                        loopGen := findNils
                            first:  [ :nxt | aholder addFirst: nxt ]
                            next: [ :nxt | aholder add: nxt ]
                            last:  [ :nxt | aholder addLast: nxt ]
                    ] .
                    loopGen reset
                ]
                nextBlock:[ aholder removeAll .  loopGen iterate .  noNils ifTrue:[ aholder ] ] ]ifFalse:[

    ( selector == #first:next:last: )
        ifTrue:[
            self abstractGenerator new
                resetBlock:[
                    allGenerators do:[ :gen | gen reset ] .''<-----------------------------( LINE:1.1 )''

                    loopGen == nil ifTrue:[
                        findNils := allGenerators collect:[ :gen |
                            ( next := gen next ) == nil ifTrue:[ noNils := false .  nil ] ifFalse:[ next ]
                        ] .
                        loopGen := findNils
                            first:  firstBlock1
                            next: nextBlock1
                            last:  lastBlock1
                    ] .
                    loopGen reset
                ]
                nextBlock:[ aholder removeAll .  loopGen iterate .  noNils ifTrue:[ aholder ] ] ]ifFalse:[

    ( selector == #Collection or:[ aholder respondsTo: #add: ] )
        ifTrue:[
            self abstractGenerator new
                resetBlock:[
                    loopGen == nil ifTrue:[                               ''<-----------------------------( LINE:1.1 )''
                        findNils := allGenerators collect:[ :gen |
                            ( next := gen next ) == nil ifTrue:[ noNils := false .  nil ] ifFalse:[ next ]
                        ] .
                        loopGen := self abstractGenerator new
                            resetBlock:[ allGenerators do:[ :gen | gen reset ] . noNils := true . findNils reset ]''<-----( There are no nils returned by any of the gens and so far at least one of the gens has returned a non nil ).''
                            nextBlock:[ aholder removeAll ; addAll: findNils .  noNils ifTrue:[ aholder ] ]
                    ] .
                    loopGen reset
                ]
                nextBlock:[ loopGen next ]
        ]
    ifFalse:[ self error: #atAllGenerate:into: ] ] ] ] .

    answer when: #releaseAllDeep perform:[ :nl :nl |        ''<--------------------------( LINE: 2 )''
        ( Array with: loopGen with: findNils ) do:[ :x | x releaseAllDeep ] ] .
<-----------------------------------------------------------OLD CODE:-----------------------------------------------------------
 )-oldCode
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorConcatenating' stamp: 'KjellGodo 5/11/2013 12:09'!
testatEachGenerate "atEachGenerate: makeGenBlock"

        "Method Version: keg1.  "
        "Copyright Kjell E God April 13, 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today April 13, 1999 ""
	| gen newGenBlk nextBlk |
					""( MT b:#atEachGenerate: s:self ).""
	( newGenBlk := [ :item | 
		( item )ifNotNil:[
			( gen := ( makeGenBlock value: item ) asGenerator ). 
			( gen reset )
		] 
	] ).
	^(
		( self abstractGenerator new )
			resetBlock:[ newGenBlk value:( self first ) ]
			nextBlock:( nextBlk := [ 
				( gen next ) 
					ifNil:[ ( gen := newGenBlk value:( self next )
						) ifNotNil:[ nextBlk value ] ]
					ifNotNil:[ :next | next ] ] )

	)""returning:(		MT e:#atEachGenerate: s:self )"

	"Wrap a Generator around each element of self via the makeGenBlock and inline all the thus created
	subGenerators ( gen below ) into a single Sequence.  self This Method has been used a lot and is
	well tested."

	( self assert:( 
		( #( (  )(  )(  ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #(  )
		)description:( '( #( (  )(  )(  ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #(  )' ) ).

	( self assert:( 
		( #( ( 1 )(  )(  ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 )
		)description:( '( #( ( 1 )(  )(  ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 )' ) ).

	( self assert:( 
		( #( (  )( 1 )(  ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 )
		)description:( '( #( (  )( 1 )(  ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 )' ) ).

	( self assert:( 
		( #( (  )(  )( 1 ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 )
		)description:( '( #( (  )(  )( 1 ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 )' ) ).

	( self assert:( 
		( #( ( 1 )( 2 )( 3 ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 2 3 )
		)description:( '( #( ( 1 )( 2 )( 3 ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 2 3 )' ) ).

	( self assert:( 
		( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 2 3 4 5 6 7 8 9 )
		)description:( '( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 2 3 4 5 6 7 8 9 )' ) ).

	( self assert:( 
		( #( 1 2 3 ( 4 5 6 )( 7 8 9 ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 2 3 4 5 6 7 8 9 )
		)description:( '( #( 1 2 3 ( 4 5 6 )( 7 8 9 ) ) asGenerator atEachGenerate:[ :a | a ] ) asArray = #( 1 2 3 4 5 6 7 8 9 )' ) ).
	
	( self assert:( 
		( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator atEachGenerate:[ :a | a asGenerator collect:[ :x | x + 1 ] ] ) asArray = #( 2 3 4 5 6 7 8 9 10 )
		)description:( '( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator atEachGenerate:[ :a | a asGenerator collect:[ :x | x + 1 ] ] ) asArray = #( 2 3 4 5 6 7 8 9 10 )' ) ).! !

!KEGGeneratorTest methodsFor: 'testing' stamp: 'KjellGodo 4/25/2013 17:42'!
testatEnd

	"Method Version: keg1.  "
	" Copyright Kjell E God 20001126"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20001126"

	"Allow instances of self( this Class ) to participate in the KEGGenerator class>>on: protocal and take
	up residence as the .generator inside a KEGGenerator.  Previously only Streams could do this.
	We just return the stop flag as it is equivalent to >>atEnd.  We are only at the end if it is true."

							"MT b:#atEnd s:self."
							"MT e:#atEnd s:self."
	"^stop ."
	#( 1 2 3 ) asGenerator ifNotNil:[ :gen |
		( gen reset ).
		( self assert:( gen atEnd not ) ).
		( gen next ). "<-----------------------------[ 1 ]"
		( self assert:( gen atEnd not ) ).
		( gen next ). "<-----------------------------[ 2 ]"
		( self assert:( gen atEnd not ) ).
		( gen next ). "<-----------------------------[ 3 ]"
		( self assert:( gen atEnd not ) ).
		( gen next ). "<-----------------------------[ nil ]"
		( self assert:( gen atEnd ) ).
	]! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:43'!
"(| defineMethod-:(" testbagSimilarsinit "bagSimilars: areSimilarBlk init: initBlk "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20021003
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20021003
	)-notes methodBody-:(
 (| let-:(""| bag aFooArray startNewBag first lastItem |"")
    letBody-:(""					""( MT b:#bagSimilars:init: s:self ).""

	( bag := OrderedCollection new ).
	( aFooArray := KEGFooArray new ).
	^(
		( 	( self reset:[ :na | ( self reset ).
				( first := startNewBag := true ).( bag removeAll ) ]""<---( add some operations to the reset operations of self. )""
			) lookAhead1:[ :x :next |
				( next isNil )
					ifTrue:[ bag ]""<---( self has run out of elements.  Here we have to use >>lookAhead1: instead of >>lastDo: because lookAhead1: is better than doing a combination of >>collect: and >>lastDo: . )""
					ifFalse:[ 
						( first ifTrue:[ ( lastItem := x ).( initBlk value: x ).( first := false ) ] ).
						( ( startNewBag )
							ifTrue:[
								( bag removeAll ; addLast:( lastItem ) ).
								( startNewBag := false ) ] ).
						( ( areSimilarBlk value:( x ) ) 
							ifTrue:[ ( bag addLast: x ).( aFooArray ) ]
							ifFalse:[ 
								( lastItem := x ).
								( startNewBag := true ).
								bag ] )
				]""-nextisNil""
			]""-lookAhead1:""
		 )reject:[ :x | x == aFooArray ]""<---( here we don't use >>collect:ignoring: because we also have to look for the end of self so we have to do a combination of >>lookAhead1: and >>reject: instead of the combination of >>collect: and >>reject: that is used in >>collect:ignoring: )""

	)""return:( 					MT e:#bagSimilars:init: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a sequence r which
	Bags up the contiguous similar elements in self according to areSimilarBlk
	and return them bagged together in an OrderedCollection which is global
	to sequence r ( ( r next ) keeps returning the same OrderedCollection over
	and over again but with different contents each time. ).

 )-summary
 methodDescriptionDetail-:(

	Let self = < a1 a2 a3 ... b1 b2 b3 ... c1 c2 c3 ... >
	where the a(i) are all similar in that-:(
		( areSimilarBlk value:( a(i) ) )=true
	) for all-:( a(i ) ) <---( notation: a(i)=ai , a1=a(1) ) and
	where
		( areSimilarBlk value:( b(1) ) )=false
	where the b(i) are all similar in that-:(
		( areSimilarBlk value:( b(i) ) )=true
	) for all-:( b(i ) ) where-:( 1 < i ) and
	where
		( areSimilarBlk value:( c(1) ) )=false
	where the c(i) are all similar in that-:(
		( areSimilarBlk value:( c(i) ) )=true
	) for all-:( c(i ) ) where-:( 1 < i ) and
	etc . . .
	THEN-:
	Return sequence r = < oc( a1 a2 a3 ... ) oc( b1 b2 b3 ... ) oc( c1 c2 c3 ... ) ... >
	where oc is a single OrderedCollection which is placed into the sequence over
	and over with different elements each time.  Thus if you want to turn r into an
	OrderedCollection you have to do it via-:(
		( r collect:[ :oc | oc copy ] ) asOrderedCollection
	)

 )-detail
 usage-:(

	See the method-:( KEGGenerator>>atAllShuffle: ) comments for an example
	of the usage.

 )-usage
 todos-:(

	( [_]:[]:WK SMALLTALK-: Dolphin Smalltalk-: 
		You can use a call to self-:( this method ) in the
		KEGGenerator>>sortInto: method instead of what is there-:( and
		if the contents of the >>sortInto: method are moved into a new helper
		Object then self-:( this method ) can be used in there.  To simplify it. ).
		( comment:-- 20110814 yyyymmdd I would suggest that a new second
		version >>sortIntoV1: be made because the lookAhead1: requires that
		two elements of self be in RAM at the same time I think and this can
		screw thing up if self has global OrderedCollections in it.  The one will
		step on the other in the >>lookAhead1: returned Generator. ) )
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... ) )-chg )-keg2
 )-changes
 testCases-:(

	( self assert:( 
		(
		( #( 2 2 1 4 4 1 6 6 ) asGenerator bagSimilars:[ :x | x even ] init:[ :x |  ]
		) collect:[ :oc | oc asArray ]
		) asArray
		= #( ( 2 2 ) ( 1 4 4 ) ( 1 6 6 ) )
		)description:( '' ) ).

  )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/21/2013 11:33'!
testbetweenand "between: anObject1 and: anObject2"

	"Method Version: keg1.  "
	"Copyright Kjell E God Mar 30 1996"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Mar 30 1996"

	"For the main comment see below the body of self( this method )."

	"| answer |"
						"MT b:#between:and: s:self."

	"answer := ( self after: anObject1 ) upTo: anObject2 ."

						"MT e:#between:and: s:self."
	"^answer ."

		"Let self = s = < ... anObject1 s1 s2 s3 ... sn anObject2 ... > where ... represents 0 or more
		elements of the sequence.  Then >>between:and: returns a Generator
		g = < s1 s2 s3 ... sn >. "  

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between: nil and: nil ) asArray = #(  )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: nil and: nil ) asArray = #(  )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between: 1 and: nil ) asArray = #( 2 3 4 5 )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: 1 and: nil ) asArray = #( 2 3 4 5 )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between: nil and: 5 ) asArray = #(  )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: nil and: 5 ) asArray = #(  )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between: 2 and: 3 ) asArray = #(  )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: 2 and: 3 ) asArray = #(  )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between: 2 and: 4 ) asArray = #( 3 )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: 2 and: 4 ) asArray = #( 3 )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between: 1 and: 5 ) asArray = #( 2 3 4 )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: 1 and: 5 ) asArray = #( 2 3 4 )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between: 1 and: #( 5 6 ) ) asArray = #( 2 3 4 )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: 1 and: #( 5 6 ) ) asArray = #( 2 3 4 )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between: 1 and:[ :x | x = 5 ] ) asArray = #( 2 3 4 )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: 1 and: [ :x | x = 5 ] ) asArray = #( 2 3 4 )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between: #( 0 1 ) and: 5 ) asArray = #( 2 3 4 )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: #( 0 1 ) and: 5 ) asArray = #( 2 3 4 )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between:[ :x | x = 1 ] and: 5 ) asArray = #( 2 3 4 )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: [ :x | x = 1 ] and: 5 ) asArray = #( 2 3 4 )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between: #( 0 1 ) and: #( 5 6 ) ) asArray = #( 2 3 4 )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: #( 0 1 ) and: #( 5 6 ) ) asArray = #( 2 3 4 )' ) ).

		( self assert:( 
			( #( 1 2 3 4 5 ) asGenerator between:[ :x | x = 1 ] and:[ :x | x = 5 ] ) asArray = #( 2 3 4 )
			)description:( '( #( 1 2 3 4 5 ) asGenerator between: [ :x | x = 1 ] and: [ :x | x = 5 ] ) asArray = #( 2 3 4 )' ) ).

		"anObject1 and anObject2 can be either an arbitrary Object
		or they can be a sequence object that responds to both >>isSequence and >>includes:
		or they can be a single parameter Context.
		or they can be Param( seq ) where seq responds to >>asGenerator.  For the full capabilities of
		self( this method ) see self>>after: and self>>upTo: "! !

!KEGGeneratorTest methodsFor: 'generatorLocalFunctions' stamp: 'KjellGodo 4/25/2013 17:43'!
"(| defineMethod-:(" testcallp1 "call: selector p1: anObject "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20110719
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110719 10:58 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#call:p1: s:self ).""
	^(	( 
		( self localInstanceVariables 
		) at: selector ifAbsent:[  ]
		) ifNil:[ 
			generator 
				ifNil:[ self error: ' call:p1: ', selector ,' function not found' ]
				ifNotNil:[ :g | g call: selector p1: anObject ] ]
		  ifNotNil:[ :func | func value: anObject ]

	)""return:( 					MT e:#call:p1: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Call a local function that was created by the
	self>>at:putLocalFunction: Method.

 )-summary
 methodDescriptionDetail-:(

	If the local function is not found in self then we look up the generator
	chain to try and find it.  If the function is not found at all then signal an error.

	We use the KEGParam p1:p2:p3 parameter passing protocal instead
	of >>with:with:with: because it's shorter and what the hell.  either.

 )-detail
 usage-:(

	| k gen |
	gen := KEGAbstractGenerator new
		resetBlock:[ ... ]
		nextBlock:[ ... k ... ] ;
		at: #k putLocalFunction:[ k ] ;
		at: #k: putLocalFunction:[ :input | k := input ] ;
		yourself
	...
	gen call: #k: p1:#( 1 )

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	( change:onDate:madeChanges: keg2 yyyymmdd ( ... ) )---[chg] )---[keg2]
 )-changes
 testCases-:("
	
	( self assert:( 
		(
		( ( KEGFixedSizedQue new size: 10 )
			addLast: 1 ;
			addLast: 2 ;
			addLast: 3 ;
			addLast: 4 ;
			addLast: 5 ;
			addLast: 6 ;
			addLast: 7 ;
			addLast: 8 ;
			addLast: 9 ;
			addLast: 10 ;
			yourself
		) last: 3
		) ifNotNil:[ :fsq | 
			( fsq asArray = #( 8 9 10 ) ) and:[ 
			( fsq call: #last: p1: 4 ).
			( fsq asArray = #( 7 8 9 10 ) ) ] ]
		)description:( 'Test >>at:putLocalFunction: and >>call:p1: using KEGFixedSizedQue>>last:' ) )

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/21/2013 12:01'!
testcollect "collect: aBlock"

        "Method Version: keg2.  "
        "Copyright Kjell E God 04-21-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today July 24 1999, 04-21-92"
                                                  "( MT b:#collect: s:self ).""
	^(
		self abstractGenerator new
			resetBlock:[ self reset ]
			nextBlock:[ ( self next )ifNotNil:[ :next | aBlock value: next ] ]

	)""return:(					MT e:#collect: s:self )."

        "Return a generator r which has the following structure:
               Let self = s.   s = <s1,s2,s3,...> (a sequence of elements)
               Let v(si) be the value result of executing aBlock on si.
               Then r = < v(s1), v(s2), v(s3), ...>
	KEG2: I cleaned it up for Dolphin by adding the right copyright notice and the MT debugging."

	( self assert:( 
		( #(  ) asGenerator collect:[ :x | x + 1 ] ) asArray = #(  )
		)description:( '( #(  ) asGenerator collect:[ :x | x + 1 ] ) asArray = #(  )' ) ).

	( self assert:( 
		( #( 1 ) asGenerator collect:[ :x | x + 1 ] ) asArray = #( 2 )
		)description:( '( #( 1 ) asGenerator collect:[ :x | x + 1 ] ) asArray = #( 2 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator collect:[ :x | x + 1 ] ) asArray = #( 2 3 4 )
		)description:( '( #( 1 2 3 ) asGenerator collect:[ :x | x + 1 ] ) asArray = #( 2 3 4 )' ) )! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/21/2013 12:02'!
testcollectignoring "collect: aBlock ignoring: anObject"

	"Method Version: keg3.  "
	"Copyright Kjell E God May 14 1993"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today February 28 2000, September 23 1999, May 14, 1993"

	"^self collect: aBlock ignoringAll:[ :x | x == anObject ] ."

	"collect:ignoring: Returns a generator r which has the following structure:
		Let self = s.   s = <s1,s2,s3,...> (a sequence of objects)
			Equivalently s = < s(1),s(2),s(3),...>

	Let i be a function which satisfies the following two statements:
		1. i is a function from N to N where N is the set of all Natural numbers
			(all positive Integers excluding Zero).  For a definition of what a
			mathematical function is please see the WorkSet comment in
			'MathTutorial' WorkSet.
		2.  i can be viewed as a sequence of Natural numbers:
			i = < i(1),i(2),i(3),...>		  eg. i = < 6, 345, 7, 86, 3, ...>
			Let i be strictly increasing:	i( j ) < i( k )   if and only if j < k .
			(where j and k are Natural numbers)
			eg.  i = < 6, 7, 34, 56, 237, ...>

			Let v( s( j ) ) be the value result of executing aBlock on sj.  (sj = s( j ))
			( j is a member of N ).	 v( s( j ) ) = ( aBlock value: s( j ) ) .

			Let r be the Generator which is returned by collect:ingnoring:
			Then r = < r1, r2, r3, r4, ...> (a sequence of objects)
			Then r = < v( s( i( 1 ) ) ), v( s( i( 2) ) ), v( s( i( 3 ) ) ), ...>
				for some function i which is defined as above.   In other words
				for some i which satisfies statements 1. and 2. above.
			*And all of the r1, r2, r3, r4, of Generator r are not equal to anObject.
			ie. r( j ) ~= anObject for all j in N. ( ~= means not equal to ).
			ie. all the r( j ) are not equal to anObject.

			In other words r takes the elements of self and puts them through aBlock.
			If anObject is returned by aBlock then r ignores it and takes the next element
			of self and puts it through aBlock.   It keeps this up until aBlock finally
			returns something other than anObject.	When this happens then r returns
			the object that was not equal to anObject."

	"KEG2: Moved it from Smalltalk/V 2.0 over to Dolphin 2.1 patch level 2( just some null touch
	ups ) KEG3: switched from = to == since mostly we are compairing with singleton KEGFooArray."

	( self assert:( 
		( #(  ) asGenerator collect:[ :x | ( x even ) ifTrue:[ 2 ]ifFalse:[ x ] ]ignoring:( 2 ) ) asArray = #(  )
		)description:( '( #(  ) asGenerator collect:[ :x | ( x even ) ifTrue:[ 2 ]ifFalse:[ x ] ]ignoring:( 2 ) ) asArray = #(  )' ) ).

	( self assert:( 
		( #( 1 2 3 4 5 6 7 ) asGenerator collect:[ :x | ( x even ) ifTrue:[ 2 ]ifFalse:[ x ] ]ignoring:( 2 ) ) asArray = #( 1 3 5 7 )
		)description:( '( #( 1 2 3 4 5 6 7 ) asGenerator collect:[ :x | ( x even ) ifTrue:[ 2 ]ifFalse:[ x ] ]ignoring:( 2 ) ) asArray = #( 1 3 5 7 )' ) )! !

!KEGGeneratorTest methodsFor: 'generatorCopying' stamp: 'KjellGodo 4/21/2013 12:08'!
testcopy

	"Method Version: keg1.  "
	"Copyright Kjell E God May  9, 1994"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today May  9, 1994"
	"| answer |"
				"MT b:#copy s:self ."   

	"answer := self copyWith: 2 ."

				"MT e:#copy s:self ."
	"^answer ."

	"Return a generator r which has the following structure:
	Let self = s.   s = <s1,s2,s3,...> (a sequence of elements)
	Let v(si) be the value result of executing aBlock on si.
	Then r = <s1, s1, s2, s2, s3, s3, s4, s4, s5, s5,  ...>"

	( self assert:(
		#(  )asGenerator copy asArray = #(  )
		)description:( '#(  )asGenerator copy asArray = #(  )' ) ).

	( self assert:(
		#( 1 )asGenerator copy asArray = #( 1 1 )
		)description:( '#( 1 )asGenerator copy asArray = #( 1 1 )' ) ).

	( self assert:(
		#( 1 2 )asGenerator copy asArray = #( 1 1 2 2 )
		)description:( '#( 1 2 )asGenerator copy asArray = #( 1 1 2 2 )' ) ).

	( self assert:(
		#( 1 2 3 )asGenerator copy asArray = #( 1 1 2 2 3 3 )
		)description:( '#( 1 2 3 )asGenerator copy asArray = #( 1 1 2 2 3 3 )' ) ).
! !

!KEGGeneratorTest methodsFor: 'generatorCopying' stamp: 'KjellGodo 4/21/2013 12:09'!
testcopyWith "copyWith: anInteger"

	"Method Version: keg1.  "
	"Copyright Kjell E God May  9, 1994"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today May  9, 1994"
	"| answer array |"
				"MT b:#copyWith: s:self "

	"array := Array new: anInteger .
	answer := ( self collect:[ :x | array atAllPut: x . array ] ) atEachGenerate:[ :g | g ] ."

				"MT e:#copyWith: s:self ."
	"^answer ."

	"Return a generator r which has the following structure:
	Let self = s.   s = <s1,s2,s3,...> (a sequence of elements)
	Let v(si) be the value result of executing aBlock on si.
	Then r = <s1, s1, s2, s2, s3, s3, s4, s4, s5, s5,  ...> if anInteger = 2 .
	Then r = <s1, s1, s1, s2, s2, s2, s3, s3, s3, s4, s4, s4, s5, s5,  ...> if anInteger = 3 .
	Then r = <s1, s1, s1, s1, s2, s2, s2, s2, s3, s3, s3, s3, s4, s4, s4, s4, s5, s5,  ...> if anInteger = 4 ."

	( self assert:(
		( #(  )asGenerator copyWith: 3 ) asArray = #(  )
		)description:( '( #(  )asGenerator copyWith: 3 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 )asGenerator copyWith: 3 ) asArray = #( 1 1 1 )
		)description:( '( #( 1 )asGenerator copyWith: 3 ) asArray = #( 1 1 1 )' ) ).

	( self assert:(
		( #( 1 2 )asGenerator copyWith: 3 ) asArray = #( 1 1 1 2 2 2 )
		)description:( '( #( 1 2 )asGenerator copyWith: 3 ) asArray = #( 1 1 1 2 2 2 )' ) ).

	( self assert:(
		( #( 1 2 3 )asGenerator copyWith: 3 ) asArray = #( 1 1 1 2 2 2 3 3 3 )
		)description:( '( #( 1 2 3 )asGenerator copyWith: 3 ) asArray = #( 1 1 1 2 2 2 3 3 3 )' ) ).

	( self assert:(
		( #( 1 )asGenerator copyWith: 4 ) asArray = #( 1 1 1 1 )
		)description:( '( #( 1 )asGenerator copyWith: 4 ) asArray = #( 1 1 1 1 )' ) ).! !

!KEGGeneratorTest methodsFor: 'generatorCrossProducts' stamp: 'KjellGodo 5/11/2013 12:01'!
"(| defineMethod-:(" testcrossAllC "crossAll: twoParameterBlock "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030201
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030201
	)-notes methodBody-:(
 (| let-:(""| firstSeq nextSeq |"")
    letBody-:(""					""( MT b:#crossAll: s:self ).""
	( firstSeq := ( ( firstSeq := self first ) isEmpty )
		ifTrue:[ ^( nil )""return:( MT e:#crossAll: s:self )"" ]ifFalse:[ firstSeq asGenerator ] ).
	( ( ( nextSeq := self next ) isEmpty )ifTrue:[ ^( nil )""return:( MT e:#crossAll: s:self )"" ] ).
	^(
		( self next isNil
		) ifTrue:[ ( firstSeq )cross:( twoParameterBlock )with:( nextSeq ) ]
		  ifFalse:[
			( firstSeq  
			) cross: twoParameterBlock 
			  with:( ( self removeFirst )crossAll:( twoParameterBlock ) )
		]

	)""return:( 					MT e:#crossAll: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a recursively cross:with:ed version of the sequences in self.

 )-summary
 methodDescriptionDetail-:(

	self is assumed to be a seqence of sequences S .  Where any Object can
	be considered to be a sequence since all Objects respond to asGenerator.
	self-:( this method ) is perhaps a pathological version of the
	>>crossAll:into: and >>crossAllVectors: methods.  
	It seems like it would make a linked list of cross:with: 
	Blocks where the return of each Block goes into the second parameter
	of the preceeding Block in the list.  No receptacleObject is provided for
	by self-:( this method ).

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "
	
	( self assert:(
	(
	(
	#(	( 1 2 3 )
		( 7 8 9 )
	) asGenerator crossAll:[ :x :previousCrossReturn | 
		Array with:( x )with:( previousCrossReturn )
	  ]
	) asArray = #( ( 1 7 ) ( 1 8 ) ( 1 9 ) ( 2 7 ) ( 2 8 ) ( 2 9 ) ( 3 7 ) ( 3 8 ) ( 3 9 ) )
	)
	)description:( 'crossAll: devolves to >>cross:with:' ) ).


	( self assert:(
	(
	(
	#(	( 1 2 3 )
		(  )
		( 7 8 9 )
	) asGenerator crossAll:[ :x :previousCrossReturn | 
		Array with:( x )with:( previousCrossReturn )
	  ]
	) asArray = nil
	)
	)description:( 'crossAll: devolves to nil' ) ).


	( self assert:(
	(
	(
	#(	( 1 2 3 )
		( 4 )
		( 7 8 9 )
	) asGenerator crossAll:[ :x :previousCrossReturn | 
		Array with:( x )with:( previousCrossReturn )
	  ]
	) asArray
	=
	#(
		( 1 ( 4 7 ) )
		( 1 ( 4 8 ) )
		( 1 ( 4 9 ) )
		( 2 ( 4 7 ) )
		( 2 ( 4 8 ) )
		( 2 ( 4 9 ) )
		( 3 ( 4 7 ) )
		( 3 ( 4 8 ) )
		( 3 ( 4 9 ) )
	)
	)
	)description:( 'crossAll: 1 embedded Array deep' ) ).

	( self assert:(
	(
	(
	(
	#(	( 1 2 3 )
		( 4 )
		( 7 8 9 )
	) asGenerator crossAll:[ :x :previousCrossReturn | 
		Array with:( x )with:( previousCrossReturn )
	  ]
	) collect:[ :a | ( a asGenerator atEachGenerate:[ :x | x ] ) asArray ]
	) asArray
	=
	#(
		( 1 4 7 )
		( 1 4 8 )
		( 1 4 9 )
		( 2 4 7 )
		( 2 4 8 )
		( 2 4 9 )
		( 3 4 7 )
		( 3 4 8 )
		( 3 4 9 )
	)
	)
	)description:( 'crossAll: allocates atEachGenerate: each time' ) ).


	( self assert:(
	( ( KEGGenerator streamGenerator ) respondsTo: #inlineEmbeddedSequences )ifTrue:
	[ | gen |
	( gen := ( KEGGenerator streamGenerator ) inlineEmbeddedSequences ).
	(
	(
	#(	( 1 2 3 )
		( 4 )
		( 7 8 9 )
	) asGenerator crossAll:[ :x :previousCrossReturn | 
		Array with:( x )with:( previousCrossReturn )
	  ]
	) collect:[ :a | ( gen on: a ; yourself ) asArray ]
	) asArray
	=
	#(
		( 1 4 7 )
		( 1 4 8 )
		( 1 4 9 )
		( 2 4 7 )
		( 2 4 8 )
		( 2 4 9 )
		( 3 4 7 )
		( 3 4 8 )
		( 3 4 9 )
	)
	]ifFalse:[ true ]
	)description:( 'crossAll: inlineEmbeddedSequences ( gen on: a ; yourself ) avoids allocations' ) ).


	( self assert:(
	(
	(
	#(	( 1 2 3 )
		( 4 )
		( 7 8 )
		( 9 )
	) asGenerator crossAll:[ :x :previousCrossReturn | 
		Array with:( x )with:( previousCrossReturn )
	  ]
	) asArray
	=
	#( 
		( 1 ( 4 ( 7 9 ) ) ) 
		( 1 ( 4 ( 8 9 ) ) ) 
		( 2 ( 4 ( 7 9 ) ) ) 
		( 2 ( 4 ( 8 9 ) ) ) 
		( 3 ( 4 ( 7 9 ) ) ) 
		( 3 ( 4 ( 8 9 ) ) ) 
	)
	)
	)description:( 'crossAll: nested two embedded Arrays deep' ) ).


	( self assert:(
	( ( KEGGenerator streamGenerator ) respondsTo: #inlineEmbeddedSequencesDeep )ifTrue:
	[
	(
	(
	(
	#(	( 1 2 3 )
		( 4 )
		( 7 8 )
		( 9 )
	) asGenerator crossAll:[ :x :previousCrossReturn | 
		Array with:( x )with:( previousCrossReturn )
	  ]
	) collect:[ :a | a asGenerator inlineEmbeddedSequencesDeep asArray ]
	) asArray
	=
	#( 	( 1 4 7 9 ) 
		( 1 4 8 9 ) 
		( 2 4 7 9 ) 
		( 2 4 8 9 ) 
		( 3 4 7 9 ) 
		( 3 4 8 9 ) 
	)
	) ]ifFalse:[ true ]
	)description:( 'crossAll: allocates inlineEmbeddedSequencesDeep each time' ) ).


	( self assert:(
	( ( KEGGenerator streamGenerator ) respondsTo: #inlineEmbeddedSequencesDeep )ifTrue:
	[ | gen |
	( gen := ( KEGGenerator streamGenerator ) inlineEmbeddedSequencesDeep ).
	(
	(
	#(	( 1 2 3 )
		( 4 )
		( 7 8 )
		( 9 )
	) asGenerator crossAll:[ :x :previousCrossReturn | 
		Array with:( x )with:( previousCrossReturn )
	  ]
	) collect:[ :a | ( gen on: a ; yourself ) asArray ]
	) asArray
	=
	#( 	( 1 4 7 9 ) 
		( 1 4 8 9 ) 
		( 2 4 7 9 ) 
		( 2 4 8 9 ) 
		( 3 4 7 9 ) 
		( 3 4 8 9 ) 
	)
	]ifFalse:[ true ]
	)description:( 'crossAll: inlineEmbeddedSequencesDeep ( gen on: a ; yourself ) avoids allocations' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCrossProducts' stamp: 'KjellGodo 4/25/2013 17:43'!
"(| defineMethod-:(" testcrossAllV1C "crossAllV1: twoParameterBlock "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20110814
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110814 17:58 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#crossAllV1: s:self ).""
	^(
		( ( self removeFirst )inject:( self first )into:[ :list :seq | list asGenerator cross:( twoParameterBlock )with:( seq ) ] )

	)""return:( 					MT e:#crossAllV1: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a recursively cross:with:ed version of the sequences in self.

 )-summary
 methodDescriptionDetail-:(

	This is a more simply coded version of >>crossAll: . I don't know if it is equivalent.
	Maybe not.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(

	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2

 )-changes
 testCases-:( See self>>testcrossAll for more and more ideas and about how to reduce allocations"
	
	( self assert:(
	(
	#(	( 1 2 3 )
		( 4 )
		( 7 8 9 )
	) asGenerator crossAllV1:[ :previousCrossReturn :x | 
		Array with:( previousCrossReturn )with:( x )
	  ]
	) asArray
	=
	#( ((1 4) 7) ((1 4) 8) ((1 4) 9) ((2 4) 7) ((2 4) 8) ((2 4) 9) ((3 4) 7) ((3 4) 8) ((3 4) 9) )
	) description:( 'crossAllV1:' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCrossProducts' stamp: 'KjellGodo 4/25/2013 17:43'!
"(| defineMethod-:(" testcrossAllVectors "crossAllVectors "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030201
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030201
	)-notes methodBody-:(
 (| let-:(""| linkedList writeStream ""d"" |"")
    letBody-:(""					""( MT b:#crossAllVectors s:self ).""
	""( d := KEGGenDebugger current ).""
	( writeStream := ( Array new:( self size ) ) writeStream ).""<---( size here is quick if self is on an Array or OrderedCollection or Stream. )""
	^(	(
		( self 
			crossAll:[ :listNode :x :nextLink | ""(d d:62)."" listNode value:( x )nextLink:( nextLink ) ]
			into:[ :na :na1 :na2 | ""(d d:63)."" KEGLinkCell new ] ""<---( na = not applicable = not used . )""
		) first:[ :list | ""(d d:64)."" linkedList := ( KEGLinkedListGenerator on:( list ) ) ]""<---( there is some thought that a quicker way to do this although perhaps not a more elegant way would be to just put an ( linkedList isNil )ifTrue:[ -init-linkedList- ] kind of thing in the collect: block which would wind up getting executed each time through the collect: block but might actually wind up being a little faster than using >>first:next: although also a little uglier.( which is why I'm not doing it( as of <D:20030202> ) ). )""
		  next:( nil )""<----------------------------------------------------------( remember that nil is the empty Block [ :x | x ] . )""
		) collect:[ :na | ""(d d:65).""""<---------------------------------------( na = not applicable = not used. )""
			( writeStream reset ;
				nextPutAll:( linkedList ) ;
				contentsKEG ""<--------------------------------------( this will keep returning the same Array from inside of the writeStream over and over with different contents if all goes well. )""
			)
	  	  ]

	)""return:( 					MT e:#crossAllVectors s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return the Set Cross Product of all the ''Sets'' in self.  As a sequence of
	Arrays.  ( Please Note that the same Array is returned over and over with
	different contents so if you want to make a Collection out of the Arrays
	produced you will have to do it via something like-:(
		( c := ( aGen crossAllVectors collect:[ :v | v copy ] ) asArray )
	)because otherwise you will get a lot of gibberish which may be pretty
	bewildering when c turns out having all the same Array in it everywhere
	in it everywhere, and all showing the contents of the very last vector that
	the crossAllVectors Generator should produce. )

 )-summary
 methodDescriptionDetail-:(
	
	self is supposed to be a sequence of sequences < s1 s2 s3 ... sN > where each
	of the si or s( i ) is a sequence( where i = 1, 2 ,3 ,..., N ).  ie: s1 is a sequence
	and s2 is a sequence and sN = s(N) is a sequence.  Each sequence in self is
	considered to be a ''Set'' or at least to be a representation of a Set.  Although
	if this is to be made more rigorous then perhaps each sequence in self should
	have come from a Set like via-:(
		aSequence asGenerator asSet asGenerator
	)or just-:(
		aSequence asSet
	)depending on what you can get away with.
	Then we do the Set Cross Product of all the sequences
	and the result is a sequence of vectors.  Each vector is just an Array.
	So self-:( this method ) returns a sequence of Arrays( ie: vectors ) of every
	combination of all the Objects in all the sequences in self.  It's like the cross
	product for Sets.  Where every sequence in self is one of the ''Sets''.   Like
	R X R ( called R cross R ) is the Euclidean plane if R is the set of
	all the Real numbers.  And if A and B are two Sets then A X B is every
	combination of ordered pairs where the first element is from A and the
	second element is from B.
	So if self = < A  B  C  D  E > where A = < a1 a2 a3 ... aN > ,
		B = < b1 b2 b3 ... bM > C = < c1 c2 c3 ... cK > , D = < d1 d2 d3 ... dL >
		, E = < e1 e2 e3 ... eP >
	where 1 <= N , 1 <= M , 1 <= K , 1 <= L , 1 <= P , then the return value
	r = < <a1 b1 c1 d1 e1> <a1 b1 c1 d1 e2> <a1 b1 c1 d1 e3> ... 
		<a1 b1 c1 d2 e1>...  ...
		<a1 b1 c1 d3 e1> ....................... <aN bM cK dL eP> >
	In other words r is a sequence of every possible Vector ( ie: Array ) that you
	can make where the first element comes from A and the second element comes
	from B and the third element comes from C and the forth element comes from
	D and the fifth element comes from E.

	Now, one thing that should be said is that when you start making these vectors
	like this the number of vectors that are to be produced can explode very
	quickly.  So like if you have 5 sequences in self and each of those have 5
	elements then the number of vectors produced is 5 * 5 * 5 * 5 * 5 = 3125 .  
	So you can very quickly bite off way more than you might want to chew
	doing this.

	So I'm not saying don't do it.  But perhaps you will want to be prepaired
	to wait on it.  Maybe you will want to use the
	KEGGenerator>>progressSize:displayInterval:caption:
	method to show the progress of whatever it is that you are doing so the
	human user's head won't explode from waiting seemingly endlessly.  The
	human user can be pacified if he/she knows that their wait is not infinite.
	Although the >>progressSize:displayInterval:caption: method is not
	commonly used as of yet, and although it has been debugged a couple
	times, perhaps you shouldn't think of it as being rock solid.  Don't be
	surprised if there are one or two flakies in it.  Although mostly it aught
	to work.  And those are my thoughts on it as of <D:20030202> .

 )-detail
 usage-:(
	usage
 )-usage
 toDebugEvaluate-:(
	To see the debugging help for self-:( this method )evaluate-:(
		KEGGenDebugger editDebugPresent:( 'KEGGenerator>>crossAllVectors' )
	)
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2keg2
 )-changes
 testCases-:( "
	
	( self assert:( 
	(
	#(
		( 1 2 3 )
		( 4 5 6 )
		( 7 8 9 )
	) asGenerator crossAllVectors collect:[ :v | v copy ]
	) asArray = #((1 4 7) (1 4 8) (1 4 9) (1 5 7) (1 5 8) (1 5 9) (1 6 7) (1 6 8) (1 6 9) (2 4 7) (2 4 8) (2 4 9) (2 5 7) (2 5 8) (2 5 9) (2 6 7) (2 6 8) (2 6 9) (3 4 7) (3 4 8) (3 4 9) (3 5 7) (3 5 8) (3 5 9) (3 6 7) (3 6 8) (3 6 9))
	) description:( 'crossAllVectors 3 by 3' ) ).


	( self assert:( 
	(
	#(
		( 1 2 )
		( 3 4 )
		( 5 6 )
	) asGenerator crossAllVectors collect:[ :v | v copy ]
	) asArray = #((1 3 5) (1 3 6) (1 4 5) (1 4 6) (2 3 5) (2 3 6) (2 4 5) (2 4 6))
	) description:( '' ) ).


	( self assert:( 
	(
	#(
		( 1 2 3 )
		( 4 )
		( 7 8 9 10 )
	) asGenerator crossAllVectors collect:[ :v | v copy ]
	) asArray = #((1 4 7) (1 4 8) (1 4 9) (1 4 10) (2 4 7) (2 4 8) (2 4 9) (2 4 10) (3 4 7) (3 4 8) (3 4 9) (3 4 10))
	) description:( '' ) ).

 " )-testCases
 rants-:(
	
	Also self-:( this method ) allows certain mathematical ideas in the
	KEGPrincipiaMathematica
	project to be stated more easily.  In there we are calculating theoretically
	all the time and we can deal easily with infinite things because the whole
	thing is just imaginary anyway.  And is just a sentence building system
	really.  But by using things like >>crossAllVectors we can redefine
	Mathematical language in a way that is perhaps more rock bottom
	solid and unambiguous than the 16th century notations that are
	( sub ) standard
	now.  Where every concept has to be modeled by a single letter of some
	alphabet.  And since there are only a few of those they wind up redefining
	the meaning of these letters over and over and over again until the
	meanings are so overloaded and piled on to each and every letter of the
	alphabet that it just isn't even funny.  And a lot of the time the notations
	themselves are pretty ambiguous.  Which is probably what makes Math
	hard.  So by taking a tip from programming languages I hope to clear
	things up.  Or make an even bigger mess of things.  One or the other.

	But don't you think that a mathematical language that is based on a
	computer language of some sort can be a lot more understandable than
	the ( sub ) standard mathematical language that we are hobbled with
	now?  Wouldn't a math lang where the theoretical sentences produced
	have actual example implementations that can be looked at and that can
	inform on the theoretical languages be good?  So like if I use
	>>crossAllVectors now in some math sentences to do with Probability
	won't that be good because you can come here and look up 
	>>crossAllVectors and run the test cases or make some of your own and
	thereby get some idea about what the theoretical talk is talking about?

	And if that theoretical talk could have both a sentence building mode and
	a real calculation mode where actual implementations of the theory can
	be tried on small test cases or to do actual work perhaps, wouldn't that
	be good?

	Well, that's the idea anyway.

	And my honest opinion is that perhaps self-:( this method ) may be of more
	use to the theoretical PrincipiaMathematica end of things than it is to the
	real data processing production end of things.

 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCrossProducts' stamp: 'KjellGodo 4/25/2013 17:44'!
"(| defineMethod-:(" testcrossAllVectorsC "crossAllVectors: oneParameterBlock "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030201
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030201
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#crossAllVectors: s:self ).""
	^(
		( self crossAllVectors collect: oneParameterBlock )

	)""return:( 					MT e:#crossAllVectors: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	
	self-:( this method ) is like the KEGGenerator>>collect: method except that self
	is supposed to be a sequence of sequences < s1 s2 s3 ... sN > where each of the
	s( i ) is a sequence( where i = 1, 2 ,3 ,..., N ).  ie: s1 is a sequence and s2 is a sequence
	and s(N) is a sequence.  Then we do the Generator Cross Product of all the sequences
	and the result is a sequence of vectors.  Each vector is just an Array.  See the testCases
	below for examples of how this works.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	See the testCases below and the KEGGenerator>>crossAllVectors method.
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( 1 asGenerator respondsTo: #asStringGenerator )ifTrue:[
	( self assert:( 
	(
	#(
		( 1 2 3 )
		( 4 5 )
		( 6 7 8 )
	) asGenerator crossAllVectors:[ :v | v displayString ] "<---[ v is global. see below ]"
	) asStringGenerator withCrLfs asString = 
'#(1 4 6)
#(1 4 7)
#(1 4 8)
#(1 5 6)
#(1 5 7)
#(1 5 8)
#(2 4 6)
#(2 4 7)
#(2 4 8)
#(2 5 6)
#(2 5 7)
#(2 5 8)
#(3 4 6)
#(3 4 7)
#(3 4 8)
#(3 5 6)
#(3 5 7)
#(3 5 8)'
	) description:( 'crossAllVectors:[ :v | v displayString ]' ) ) ].

	( self assert:( 
	(
	#(
		( 1 2 3 )
		( 4 )
		( 6 7 8 )
	) asGenerator crossAllVectors:[ :v | v copy ] "<---[ v is global, just one Array reused over and over so it must be copied ]"
	) asArray = #( (1 4 6) (1 4 7) (1 4 8) (2 4 6) (2 4 7) (2 4 8) (3 4 6) (3 4 7) (3 4 8) )
	) description:( 'crossAllVectors:[ :v | v copy ]' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCrossProducts' stamp: 'KjellGodo 5/11/2013 11:59'!
testcrossCwithC "cross: aBlock with: secondSequence"

	"Method Version: keg1.  "
       "Copyright Kjell E God 04-21-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today 04-21-92"
	"| secondGenerator |"

					"( MT b:#cross:with: s:self )."
	"( secondGenerator := secondSequence asGenerator ).
	^(
		self atEachGenerate:[ :x | 
			secondGenerator collect:[ :y | aBlock value: x value: y ] ]

	)""return:( 			MT b:#cross:with: s:self )."

	"Return a generator r with the following structure:
		   Let self = s.	s = <s1,s2,s3,...>   (a sequence of elements)
		   Let secondGenerator = g.	g = <g1,g2,g3,...>
		   Let v(x,y) be the value result of executing aBlock on x and y.

		   Then r = 	< v(s1,g1),v(s1,g2),v(s1,g3),v(s1,g4),...
					    v(s2,g1),v(s2,g2),v(s2,g3),v(s2,g4),...
					    v(s3,g1),v(s3,g2),v(s3,g3),v(s3,g4),...
					    v(s4,g1),v(s4,g2),v(s4,g3),v(s4,g4),...
												  ...>

		   In other words r is a linearizeation
		   of a somewhat squarish matrixy looking thing.
		   The result is a single list that can be organized
		   in the mind as a matrix of rows and columns."

	( self assert:(
		( #(  ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#(  ) ) asArray = #(  )
		)description:( '( #(  ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#(  ) ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#(  ) ) asArray = #(  )
		)description:( '( #( 1 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#(  ) ) asArray = #(  )' ) ).

	( self assert:(
		( #(  ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 ) ) asArray = #(  )
		)description:( '( #(  ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 ) ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 ) ) asArray = #( ( 1 2 ) )
		)description:( '( #( 1 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 ) ) asArray = #( ( 1 2 ) )' ) ).

	( self assert:(
		( #( 1 3 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 ) ) asArray = #( ( 1 2 ) ( 3 2 ) )
		)description:( '( #( 1 3 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 ) ) asArray = #( ( 1 2 ) ( 3 2 ) )' ) ).

	( self assert:(
		( #( 1 3 4 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 ) ) asArray = #( ( 1 2 ) ( 3 2 ) ( 4 2 ) )
		)description:( '( #( 1 3 4 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 ) ) asArray = #( ( 1 2 ) ( 3 2 ) ( 4 2 ) )' ) ).

	( self assert:(
		( #( 1 3 4 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 5 ) ) asArray = #( ( 1 2 ) ( 1 5 ) ( 3 2 ) ( 3 5 ) ( 4 2 ) ( 4 5 ) )
		)description:( '( #( 1 3 4 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 5 ) ) asArray = #( ( 1 2 ) ( 1 5 ) ( 3 2 ) ( 3 5 ) ( 4 2 ) ( 4 5 ) )' ) ).

	( self assert:(
		( ( #( 1 3 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 ) ) ,
		( #( 2 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 1 3 ) ) )asArray = #( ( 1 2 ) ( 3 2 ) ( 2 1 ) ( 2 3 ) )
		)description:( '( ( #( 1 3 ) asGenerator cross:[ :x :y | Array p1:x p2:y ]with:#( 2 ) ) ,' ) ).
! !

!KEGGeneratorTest methodsFor: 'generatorCrossProducts' stamp: 'KjellGodo 4/25/2013 17:44'!
testcrossWithCatC "crossWith: aSequence at: index"

	"Method Version: keg1.  "
	" Copyright Kjell E God Mar 30 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Mar 30 2000"
							"( MT b:#crossWith:at: s:self ).""
	^(
		self 
			cross:[ :oc :x | oc at:index put:x . oc ]
			with: aSequence asGenerator

	)""return:(					MT e:#crossWith:at: s:self )."

	"This method was originally intended to be used with the
	OrderedCollection>>asVectorGenerator method in order to enumerate all the cases in a
	set of test vectors.  Search the code for examples by searching for senders or
	references.  It was to be used in the KEGDebugging.pac package."

	"Here is the main usage template-:

	(	(	(	( ( Array new:4 ) asSingletonGenerator crossWith: aSequence1 at: 1
				)crossWith: aSequence2 at: 2
			)crossWith: aSequence3 at: 3
		)crossWith: aSequence4 at: 4
	)collect:[ :testVector |
		anObject testMethodXOnTestVector: testVector
	] .

	(	(	(	( ( OrderedCollection new:4 ) asSingletonGenerator crossWith: aSequence1 at: 1
				)crossWith: aSequence2 at: 2
			)crossWith: aSequence3 at: 3
		)crossWith: aSequence4 at: 4
	)collect:[ :testVector |
		anObject testMethodXOnTestVector: testVector
	] .

	(	(	(	( ( OrderedCollection new:4 ) asVectorGenerator crossWith: aSequence at: 1
				)crossWith: aSequence1 at: 2
			)crossWith: aSequence2 at: 3
		)crossWith: aSequence3 at: 4
	)collect:[ :testVector |
		anObject testMethodXOnTestVector: testVector
	] .

	Or perhaps another way to do it would be to make one of the aSequence<i> sequences
	be a sequence of BlockClosures or TestCases or something automated for testing like
	that and then do-:

	(	(	(	( ( KEGTestVector new: 4 ) asVectorGenerator crossWith: aSequence at: 1
				)crossWith: aSequence1 at: 2
			)crossWith: aSequence2 at: 3
		)crossWith: aSequence3 at: 4
	)collect:[ :testVector | testVector test: i ] .

	where i = <i> which is 1 or 2 or 3 above and designates aSequence<i> as being the
	sequence of objects into which all the other element of the testVector are dumped
	via some >>test: method defined on BlockClosures or TestCases or something
	automated for testing.
	Or we could just do-:
	
	(	(	(	( ( OrderedCollection new: 4 ) asVectorGenerator crossWith: aSequence at: 1
				)crossWith: aSequence1 at: 2
			)crossWith: aSequence2 at: 3
		)crossWith: aSequence3 at: 4
	)cross:[ :testVector :testCase |
		testCase on: testVector ; test
	]with: aSequenceOfTestCases .

	Which may well be the way to do it. 

	Perhaps we could even do-:

	( OrderedCollection new asVectorGenerator 
		crossWithAll:( P p1: aSequence1 p2: aSequence2 p3: aSequence3 )
	)cross:[ :testVector :testCase |
		testCase on: testVector ; test
	]with: aSequenceOfTestCases ."

	( self assert:(
	(
	(	(	(	( ( Array new:4 ) asSingletonGenerator crossWith: #( 1 2 ) at: 1
				) crossWith: #( 3 4 ) at: 2
			) crossWith: #( 5 6 ) at: 3
		) crossWith: #( 7 8 ) at: 4
	) collect:[ :testVector | testVector copy ]
	) asArray = #((1 3 5 7) (1 3 5 8) (1 3 6 7) (1 3 6 8) (1 4 5 7) (1 4 5 8) (1 4 6 7) (1 4 6 8) (2 3 5 7) (2 3 5 8) (2 3 6 7) (2 3 6 8) (2 4 5 7) (2 4 5 8) (2 4 6 7) (2 4 6 8))
	) description:( 'crossWith:at: 4 deep testVector creation without loop allocations' ) )


! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/21/2013 12:42'!
testdetectC "detect: aBlock"

        "Method Version: keg1.  "
        "Copyright Kjell E God 05-20-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today 05-20-92"
							  "( MT b:#detect: s:self ).""
	^(
		( self detect: aBlock ifNone:[ ] )

	)""return:(					MT e:#detect: s:self )."
        "Answer answer a Generator whose
         only element is the first element of the receiver that
         causes aBlock to evaluate to true (with that
         element as the argument).  If no such element
         is found, return nil.  aBlock is a <monadicValuable>."

	( self assert:(
		( #(  ) asGenerator detect:[ :x | x = 4 ] ) first = nil
		)description:( '' ) ).

	( self assert:(
		( #( 1 ) asGenerator detect:[ :x | x = 4 ] ) first = nil
		)description:( '' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator detect:[ :x | x = 1 ] ) first = 1
		)description:( '' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator detect:[ :x | x = 4 ] ) first = 4
		)description:( '' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator detect:[ :x | x = 5 ] ) first = 5
		)description:( '' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/21/2013 12:43'!
testdetectCifNoneC "detect: aDetectBlock ifNone: aQuitBlock"

        "Method Version: keg3."
        "Copyright Kjell E God June 19 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today ( 06 May 2011 15:47 ), June 19 1999, 05-20-92"
    "| answer next stopIt |"
						"MT b:#detect:ifNone: s:self .""
	answer := self abstractGenerator new
		resetBlock:[ ( stopIt := false ).( self reset ) ]
		nextBlock:[ 
			stopIt 
				ifTrue:[ reuse ifTrue:[ ( self class reuse: self ).( nil ) ] ]
				ifFalse:[
					( next := self next ).
					( [ ( next notNil ) and:[ ( aDetectBlock value: next ) not ] ]
						whileTrue:[ next := self next ] ).
					next 	ifNil:[ 	( stopIt := true ).( aQuitBlock value ) ]
						ifNotNil:[	( stopIt := true ).( next ) ]
			]
		] .
						""MT e:#detect:ifNone: s:self .""
	^answer .
	""See the Method comment for self>>detect: and return a sequence with just
	one element which is the first notNil element x of self to make ( aDetectBlock value: x )
	return true.  ( KEGGenerators cannot have nil elements except at the very end of the
	notNil elements and then they are all nil from then on.  All KEGGenerators are infinite
	length but most of them have nil tails an infinite sequence of nil )

	See self>>detect: for more test cases"

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator detect:[ :x | x = 6 ]ifNone:[ 6 ] ) first = 6
		) description:( '( #( 1 2 3 4 5 ) asGenerator detect:[ :x | x = 6 ]ifNone:[ 6 ] ) first = 6' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator detect:[ :x | x = 6 ]ifNone:[ 6 ] ) asArray = #( 6 )
		) description:( '( #( 1 2 3 4 5 ) asGenerator detect:[ :x | x = 6 ]ifNone:[ 6 ] ) asArray = #( 6 )' ) ).

! !

!KEGGeneratorTest methodsFor: 'printing' stamp: 'KjellGodo 4/21/2013 16:37'!
testdisplayOnC "displayOn: aStream"

        "Method Version: keg3.  "
        "Copyright Kjell E God Jun 27 1995"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today March 03 2000, Feb  6 1998, Jun 27 1995"
                                                  "( MT b:#displayOn: s:self )."

	"( self do:[ :x | x displayOn: aStream ] )."

	"aStream nextPutAll: self asString ."

	"^( self )return:(				MT e:#displayOn: s:self )"

       "write self onto aStream as the user would want to see it.  This stuff is also used for debugging
	actually.  We can't use >>printOn: for debugging display because the debugger uses it and it
	can get messy if you are trying to redisplay a Generator all the time at the same time as you
	are trying to single step through it.  This makes the part you are stingle stepping act like it is
	trying to work on a Generator that has already finished.  But the code was expecting that it 
	wouldn't have finished yet.  finished ~ atEnd for Streams.  The upchuck of it is that we can't
	use anything the debugger insists on using incessantly, to display the elements of self.
	KEG3: I switched to the more direct self do:[ :x | x displayOn: aStream ] aproach which is better
	if self has individual Characters in it."

	( self assert:(
		( String new writeStream ) ifNotNil:[ :s |
			( #( 1 2 3 ' = 123' $  'so' ) asGenerator displayOn:( s ) ).
			( s contents ) = '123 = 123 so'
		]
		) description:( '( #( 1 2 3 '' = 123'' $  ''so'' ) asGenerator displayOn:( s ) ).' ) )

! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/21/2013 16:44'!
testdoCseparatedByC "do: operation separatedBy: separator"

        "Method Version: keg1.  "
        "Copyright Kjell E God June 19 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today June 19 1999""
	| sep |
											""MT b:#do:separatedBy: s:self .""
	( sep := [ sep := separator ] ).	""<---( Dolphin: Switch to the real separator after first eval. KEG: very sneaky. )""
	( self do:[ :e | ""<-------------------------------( KEG: Switch do: to collect: )""
		( sep value ).
		( operation value:( e ) )
	] ).
											""MT e:#do:separatedBy: s:self ."
	"PUBLIC-: ANSII-: Return a Generator with the following structure-:
	Let self = s = <s1 s2 s3... sN-1 sN>.
	operation is a <monadicValuable>.
	seperator is a <monadicValuable>.	
	Let o(x) = operation value: x .
	Let s(x) = seperator value: x .
	Then the execution sequence is o(s1) s(s1) o(s2) s(s2) o(s3) o(s3)... o(sN-1) s(sN-1) o(sN) .
	Thus if s = < s1 > =then=> r = < o(s1) >.
	Thus if s = < s1 s2 > =then=> r = < o(s1) s(s1) o(s2) >."

	( self assert:( 
		[ :oc | ( #(  ) do:[ :x | oc add: x ]separatedBy:[ oc add: 4 ] ).( oc asArray ) = #(  ) ] value:( OrderedCollection new )
		) description:( '[ :oc | ( #(  ) do:[ :x | oc add: x ]separatedBy:[ oc add: 4 ] ).( oc asArray ) = #(  ) ] value:( OrderedCollection new )' ) ).

	( self assert:( 
		[ :oc | ( #( 1 ) do:[ :x | oc add: x ]separatedBy:[ oc add: 4 ] ).( oc asArray ) = #( 1 ) ] value:( OrderedCollection new )
		) description:( '[ :oc | ( #( 1 ) do:[ :x | oc add: x ]separatedBy:[ oc add: 4 ] ).( oc asArray ) = #( 1 ) ] value:( OrderedCollection new )' ) ).

	( self assert:( 
		[ :oc | ( #( 1 2 ) do:[ :x | oc add: x ]separatedBy:[ oc add: 4 ] ).( oc asArray ) = #( 1 4 2 ) ] value:( OrderedCollection new )
		) description:( '[ :oc | ( #( 1 2 ) do:[ :x | oc add: x ]separatedBy:[ oc add: 4 ] ).( oc asArray ) = #( 1 4 2 ) ] value:( OrderedCollection new )' ) ).

	( self assert:( 
		[ :oc | ( #( 1 2 3 ) do:[ :x | oc add: x ]separatedBy:[ oc add: 4 ] ).( oc asArray ) = #( 1 4 2 4 3 ) ] value:( OrderedCollection new )
		) description:( '[ :oc | ( #( 1 2 3 ) do:[ :x | oc add: x ]separatedBy:[ oc add: 4 ] ).( oc asArray ) = #( 1 4 2 4 3 ) ] value:( OrderedCollection new )' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorEvaluation' stamp: 'KjellGodo 4/21/2013 16:56'!
"(| defineMethod-:(" testdoYourselfExpC "doYourselfExp: anObject "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030227
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030227
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#doYourselfExp: s:self ).

	^(
		( self )

	)return:( 					MT e:#doYourselfExp: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return self after the expression that produced anObject has finished.

 )-summary
 methodDescriptionDetail-:(

	See Object>>doYourselfExp: for details.
	self-:( this method ) is reImplemented here as a speed up so the superClass
	will not have to be consulted.  self This Method should be faster than
	Object>>doYourself: .

 usage-:(

	Usually anObject is an expression that closes a file just prior to a Method returning
	a value.

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		[ | g |
			( ( g := #( 1 2 3 ) asGenerator )doYourselfExp:( g position: 1 ) ) next
		] value = 2
		) description:( '( ( g := #( 1 2 3 ) asGenerator )doYourselfExp:( g position: 1 ) ) next' ) ).

	"-----------------------Begin Comment Out Dolphin Specific--------------------------
	( self assert:(
		[ | g fName | ""<---[ Shows how you might avoid using a temporary variable for the file contents which are to be returned ]""
			( fName := ( SessionManager current imageBase ) , 'kccmlnhccfwclqTestFile.txt' ).
			( g := FileStream write: fName ).
			( g nextPutAll: '1 2 3' ).( g close ).
			( g := FileStream read: fName ).
			( ( g asGenerator contents )doYourselfExp:( ( g close )doYourselfExp:( File delete: fName ) ) )""<---[ Return contents then close then delete ]""
		] value = '1 2 3'
		) description:( '( g asGenerator contents )doYourselfExp:( ( g close )doYourselfExp:' ) ).
	================End Comment Out==================="

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(

	self-:( this method ) is just like the self>>return: method.
	See Object>>doYourselfExp: for design ideas.

	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"
! !

!KEGGeneratorTest methodsFor: 'generatorMixins' stamp: 'KjellGodo 4/21/2013 16:46'!
"(| defineMethod-:(" testdoesNotUnderstandC "doesNotUnderstand: aMessage "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030105
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030105
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#doesNotUnderstand: s:self ).""
	^(
		( aMessage forwardTo: generator )""<---[ not self generator for speed ]""

	)""return:( 					MT e:#doesNotUnderstand: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Private - It is hoped that self-:( this method ) will allow Generators that are
	on Streams to have all the functionality of Streams, In a pinch.  But only in
	a pinch!!

 )-summary
 methodDescriptionDetail-:(

	It is hoped that this new Stream functionality of Generators will not be used
	very much.  Use a Stream of you want Stream functionality.  But sometimes
	you can get into a pinch situation where there is no good or easy way out.
	And you just want a tiny little bit of Stream functionality to get you out of there.
	So you would like the Generator to momentarily act like a Stream for a second.
	And then go back to being a Generator again.
	BUGWATCH-: PLEASE-NOTE-:( It has been noted that sometimes if you
	implement the doesNotUnderstand: method then it stops real
	>>doesNotUnderstand: errors from being flagged and handled all the way out
	so as to open a Debugger walkback window.  So it may happen that there should
	be a >>doesNotUnderstand: walkback opened on screen but because of
	self-:( this method ) none is ever opened and so the Debugging process becomes
	that much harder.  So watch out for that kind of thing now. )-please-note

	The original idea for this comes from KEGPositionableGenerator such that
	the >>position: and >>position messages will propagate up the generator
	list until it finds a positionable Generator or signals an error because one
	was not found up there.  If generator is nil it may be that no error will be signaled
	but nil will be returned.  You could stick some non nil thing into generator
	if you wanted to signal an error.

	KEGPositionableGeneratorV1 is the newer better version of
	KEGPositionableGenerator.

 )-detail
 usage-:(

	So you can do stuff like-:(
		( aGenerator peek ) ''<---( to look at the next item in the headwaters
								Stream that aGenerator is on. )''
		( aGenerator pop ) ''<---( make the headwaters stream that aGenerator
								is on go backwards one item.  ie: back it up 1.
								This might backup the whole aGenerator 1 item.
								But maybe not so you have to be careful and check
								out how aGenerator has been set up during its
								creation.
								If you want aGenerator to be doing this kind of
								thing on a regular basis then try to use one of
								the KEGCanBackup related Generators. )''
		( aGenerator position )
		( aGenerator position: 5 )<---[ and aGenerator might contain a KEGPositionableGeneratorV1
								in it.  Or the generator might be a Stream ]
		
	)
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

	Please Note that the following test Generators are on Streams which makes the stream messages work via 
	the >>doesNotUnderstand: message."

	( self assert:( 
		( ( #( 1 2 3 4 ) asGenerator ) reset ; position: 3 ; next ) = 4
		) description:( '( ( #( 1 2 3 4 ) asGenerator ) reset ; position: 3 ; next ) = 4' ) ).

	( self assert:( 
		( ( #( 1 2 3 4 ) asGenerator ) reset ; position: 3 ; pop ; next ) = 3
		) description:( '( ( #( 1 2 3 4 ) asGenerator ) reset ; position: 3 ; pop ; next ) = 3' ) ).

	( self assert:( 
		( ( #( 1 2 3 4 ) asGenerator ) reset ; position: 3 ; peek ; peek ) = 4
		) description:( '( ( #( 1 2 3 4 ) asGenerator ) reset ; position: 3 ; peek ; peek ) = 4' ) ).

 ")-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCombining' stamp: 'KjellGodo 4/21/2013 16:50'!
testdotCwithC "dot: aBlock with: secondSequence"

        "Method Version: keg3.  "
        "Copyright Kjell E God 04-21-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today May 24 1997, 04-21-92"
	"| secondGenerator |

	( secondGenerator := secondSequence asGenerator ).
						""( MT b:#dot:with: s:self ).""
	^( 
		( self abstractGenerator new
			resetBlock:[ 
				( self reset ). 
				( secondGenerator reset ) ]
			nextBlock:[ 
				( self next ) ifNotNil:[ :selfNext |
				( secondGenerator next ) ifNotNil:[ :secondNext |
					aBlock 
						value: selfNext 
						value: secondNext ] ] ] )

	)""return:( 				MT e:#dot:with: s:self )"

    "Return a generator r with the following structure:
	Let self = s.    s = <s1,s2,s3,...>   (a sequence of elements)
		Let secondGenerator = g.   g = <g1,g2,g3,...>
		Let v(x,y) be the value result of executing aBlock on x and y.

		Then r = <v(s1,g1),v(s2,g2),v(s3,g3),...>

		A Sequence is any Object o such that ( o isSequence ) = true.
		If ( o isSequence ) = true  =Then=> o asGenerator size >= 0
		If ( o isSequence ) = false =Then=> o asGenerator size  = 0 or 1.

        KEG2: changed secondGenerator to secondSequence so asGenerator 
			doesn't have to be sent by user. In other words I do the 
			>>asGenerator in here.
		KEG3: Cleaned it up for Dolphin."

	( self assert:(
		( #(  ) asGenerator dot:[ :x :y | x * y ]with:#(  ) ) asArray = #(  )
		) description:( '( #(  ) asGenerator dot:[ :x :y | x * y ]with:#(  ) ) asArray = #(  )' ) ).

	( self assert:(
		( #(  ) asGenerator dot:[ :x :y | x * y ]with:#( 4 5 6 ) ) asArray = #(  )
		) description:( '( #(  ) asGenerator dot:[ :x :y | x * y ]with:#( 4 5 6 ) ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator dot:[ :x :y | x * y ]with:#(  ) ) asArray = #(  )
		) description:( '( #( 1 2 ) asGenerator dot:[ :x :y | x * y ]with:#(  ) ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator dot:[ :x :y | x * y ]with:#( 4 5 6 ) ) asArray = #(4 10)
		) description:( '( #( 1 2 ) asGenerator dot:[ :x :y | x * y ]with:#( 4 5 6 ) ) asArray = #(4 10)' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator dot:[ :x :y | x * y ]with:#( 4 5 ) ) asArray = #(4 10)
		) description:( '( #( 1 2 3 ) asGenerator dot:[ :x :y | x * y ]with:#( 4 5 ) ) asArray = #(4 10)' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator dot:[ :x :y | x * y ]with:#( 4 5 6 ) ) asArray = #(4 10 18)
		) description:( '( #( 1 2 3 ) asGenerator dot:[ :x :y | x * y ]with:#( 4 5 6 ) ) asArray = #(4 10 18)' ) ).




! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/21/2013 16:58'!
testexistsC "exists: aBlock"

        "Method Version: keg1.  "
        "Copyright Kjell E God Apr 28, 1993"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today Apr 28, 1993""
	| answer |
                                                  ""MT b:#exists: s:self .""

	answer := ( self detect: aBlock ) first notNil .

                                                  ""MT e:#exists: s:self .""
	^answer .
        ""Return true if and only if there is an element of self which makes
        aBlock true.  aBlock is a <monadicValuable>."


	( self assert:(
		( #(  )asGenerator exists:[ :x | x = 1 ] ) not
		) description:( '( #(  )asGenerator exists:[ :x | x = 1 ] ) not' ) ).

	( self assert:(
		( #( 1 )asGenerator exists:[ :x | x = 1 ] )
		) description:( '( #( 1 )asGenerator exists:[ :x | x = 1 ] )' ) ).

	( self assert:(
		( #( 1 )asGenerator exists:[ :x | x = 2 ] ) not
		) description:( '( #( 1 )asGenerator exists:[ :x | x = 2 ] ) not' ) ).

	( self assert:(
		( #( 1 2 3 )asGenerator exists:[ :x | x = 1 ] )
		) description:( '( #( 1 2 3 )asGenerator exists:[ :x | x = 1 ] )' ) ).

	( self assert:(
		( #( 1 2 3 )asGenerator exists:[ :x | x = 2 ] )
		) description:( '( #( 1 2 3 )asGenerator exists:[ :x | x = 2 ] )' ) ).

	( self assert:(
		( #( 1 2 3 )asGenerator exists:[ :x | x = 3 ] )
		) description:( '( #( 1 2 3 )asGenerator exists:[ :x | x = 3 ] )' ) ).


! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:44'!
"(| defineMethod-:(" testfindDuplicates ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030225
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030225
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:(""					""( MT b:#findDuplicates s:self ).""
	^(
		self findDuplicates:( Bag new:( 100 ) )

	)""return:( 					MT e:#findDuplicates s:self )""

    "")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a sequence of all the elements of self that are repeated in self along
	with the number of times they are repeated.

 )-summary
 methodDescriptionDetail-:(

	Actually it is a little more complex than that.  A sequence of Associations is
	returned of the form-:( Association< n,  x > ) where n is the number of times
	x has occured in self so far.  So like each time x is seen in self via self getting
	the >>next message then the Association is returned with n being the number
	of times x has occured in self so far.  So if this is the fifth time the Generator rG
	returned by self-:( this method ) has seen x in self then an Association of the
	form-:(
		Association( key: 5 value: x )
	) is returned by the ( rG next ) expression that is now being evaluated.

	See KEGGenerator>>findDuplicates: for more details.

 )-detail
 usage-:(
	usage
 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGGenerator>>findDuplicates' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "
	
	
	( self assert:(
	(
	(
	( #( 1 2 3 ) asGenerator findDuplicates
	) collect:[ :ac | Array with:( ac key )with:( ac value ) ]
	) asArray
	) = #()
	) description:( '#( 1 2 3 ) asGenerator findDuplicates' ) ).
	
	
	( self assert:(
	(
	(
	( #( 1 2 2 ) asGenerator findDuplicates
	) collect:[ :ac | Array with:( ac key )with:( ac value ) ]
	) asArray
	) = #(#(2 2))
	) description:( '#( 1 2 2 ) asGenerator findDuplicates' ) ).

	
	( self assert:(
	(
	(
	( #( 1 2 3 2 ) asGenerator findDuplicates
	) collect:[ :ac | Array with:( ac key )with:( ac value ) ]
	) asArray
	) = #(#(2 2))
	) description:( '#( 1 2 3 2 ) asGenerator findDuplicates' ) ).

	
	( self assert:(
	(
	(
	( #( 1 1 1 ) asGenerator findDuplicates
	) collect:[ :ac | Array with:( ac key )with:( ac value ) ]
	) asArray
	) = #(#(2 1) #(3 1))
	) description:( '#( 1 1 1 ) asGenerator findDuplicates' ) ).


	( self assert:(
	(
	(
	( #( 1 1 1 1 ) asGenerator findDuplicates
	) collect:[ :ac | Array with:( ac key )with:( ac value ) ]
	) asArray
	) = #(#(2 1) #(3 1) #(4 1))
	) description:( '#( 1 1 1 1 ) asGenerator findDuplicates' ) ).


	( self assert:( "<---[ To find the total number of each repeated Object ]"
	(
	(
	(
	(
	( #( 1 1 1 1 2 2 2 3 3 4 ) asGenerator findDuplicates
	) inject:( Dictionary new )into:[ :dict :assoc | dict at: assoc value put: assoc key . dict ]
	) asGenerator
	) collect:[ :assoc | Array with: assoc key with: assoc value ]
	) asArray
	) = #(#(1 4) #(2 3) #(3  2))
	) description:( '#( 1 1 1 1 2 2 2 3 3 4 ) asGenerator findDuplicates' ) ).
	

	( self assert:(
	(
	(
	( #( 1 1 2 ) asGenerator findDuplicates
	) collect:[ :ac | Array with:( ac key )with:( ac value ) ]
	) asArray
	) = #(#(2 1))
	) description:( '#( 1 1 2 ) asGenerator findDuplicates' ) ).

	
	( self assert:(
	(
	(
	( #( 1 2 3 2 4 5 6 2 7 8 ) asGenerator findDuplicates
	) collect:[ :ac | Array with:( ac key )with:( ac value ) ]
	) asArray
	) = #(#(2 2) #(3 2))
	) description:( '#( 1 2 3 2 4 5 6 2 7 8 ) asGenerator findDuplicates' ) ).

	
	( self assert:(
	(
	(
	( #( 1 2 3 2 4 5 6 2 7 4 ) asGenerator findDuplicates
	) collect:[ :ac | Array with:( ac key )with:( ac value ) ]
	) asArray
	) = #(#(2 2) #(3 2) #(2 4))
	) description:( '#( 1 2 3 2 4 5 6 2 7 4 ) asGenerator findDuplicates' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generator' stamp: 'KjellGodo 4/21/2013 17:07'!
testfirst "first"

	"Method Version: keg3.  "
	"Copyright Kjell E God 04-21-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today April 14 1999, Jan 17 1995, 04-21-92"

	"Return v the first element of self.
               Let self = s.   s = <s1, s2, s3, ...>   (a sequence of elements)

               Then v = s1.
	KEG2: changed this line from answer := self reset ; next .
	PLEASE-NOTE: some generators may not want to do reset ; next.  They may want to do >>first instead.   >>first instead would slow down the most common case of a GeneratorStream by one method send ( a teeny amount ).   The general case could be ( Object>>first ^self reset ; next. ) which would extend flexibility.  You have to weigh flexibility against the teeny one message send which it would cost the most common case of GeneratorStream.   And that the Truth spfpfpfpfpfp.
	KEG3: KEG2: moved code to Dolphin version 2.1 patch level 2."


	"^self reset ; next .     ""<---------------=-=-=-=-=StreamCase."

	( self assert:(
		#(  )asGenerator first = nil
		) description:( '#(  )asGenerator first = nil' ) ).

	( self assert:(
		#( 1 )asGenerator first = 1
		) description:( '#(  )asGenerator first = nil' ) ).

	( self assert:(
		#( 1 2 3 ) asGenerator first = 1
		) description:( '#(  )asGenerator first = nil' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:45'!
"(| defineMethod-:(" testfirstC ": anInteger "")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God Apr 10 1993
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030424, Apr 10 1993
	)-notes methodBody-:(
 (| let-:(""		"")
    letBody-:(""					""( MT b:#first: s:self ).""
	^(
		self dot:[ :x :y | x ]with:( ( 1 to: anInteger )asGenerator )

	)""return:( 					MT e:#first: s:self )""

    "")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Suppose
		self = < s1, s2, s3, ...> and suppose anInteger = n
	THEN:
		answer = < s1, s2, ... sm > is the generator returned
		by Generator>>first:
		where m = ( (self size) min: n ).

 )-summary
 methodDescriptionDetail-:(

	Please see the alternate code below for a speed up( I'm leaving the
	dot:with: version for now because it shows a dot:with: example.  If a
	speedup is needed then the versions can be switched ).

	The KEGAbstractGenerator>>on: protocal will stick the new
	base sequence into self now instead of sticking it into
	( 1 to: anInteger )asGenerator .

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(

	(| KEG3-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg3

	(| KEG2-:( Changes onDate-:( <D:20030424> ) madeChanges-:( 
		Made the with: parameter be-: ( 1 to: anInteger )asGenerator
		instead of self so that >>dot:with: can work with the new
		KEGAbstractGenerator>>on: protocal which always selects
		the self branch to stick the new base sequence into.
	)-madechanges )-chg )-keg2

 )-changes
 testCases-:( "

	( self assert:(
		( #(  ) asGenerator first: 3 ) asArray = #(  )
	) description:( '( #(  ) asGenerator first: 3 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator first: 3 ) asArray = #( 1 )
	) description:( '( #( 1 ) asGenerator first: 3 ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator first: 3 ) asArray = #( 1 2 )
	) description:( '( #( 1 2 ) asGenerator first: 3 ) asArray = #( 1 2 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 6 7 8 9 ) asGenerator first: 3 ) asArray = #( 1 2 3 )
	) description:( '#( 1 2 3 4 5 6 7 8 9 ) asGenerator first: 3 ) asArray = #( 1 2 3 )' ) ).

 " )-testCases
 alternateCode-:(

	| count |

	^(
		( ( self abstractGenerator new )
			resetBlock:[ ( self reset ).( count := 0 ) ]
			nextBlock:[ 
				( self next )ifNotNil:[ :next | 
					( ( count := count + 1 )<= anInteger )ifTrue:[ next ] ] ] )
	)

 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"
! !

!KEGGeneratorTest methodsFor: 'generatorCollecting' stamp: 'KjellGodo 4/25/2013 17:45'!
"(| defineMethod-:(" testfirstDo ": aMonadicValuable "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20091214
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20091214 18:41 )
	)-notes methodBody-:(
 (| let-:(""| first |"")
    letBody-:(""					""( MT b:#firstDo: s:self ).""
	^(
		( self abstractGenerator new )
			resetBlock:[ ( self reset ).( first := true ) ]
			nextBlock:[ 
				( self next ) ifNotNil:[ :next |
					first	ifTrue:[ ( first := false ).( aMonadicValuable value: next ) ]
						ifFalse:[ next ] ] ]

	)""return:( 					MT e:#firstDo: s:self )""

    "")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	If self = < s1 s2 s3 ... > then return a new Generator that looks like
	< ( aMonadicValuable value: s1 ) s2 s3 s4 ... >

 )-summary
 methodDescriptionDetail-:(
	detail
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... ) )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( #(  )asGenerator firstDo:[ :na | 2 ] ) asArray = #(  )
	) description:( '( #(  )asGenerator firstDo:[ :na | 2 ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 )asGenerator firstDo:[ :na | 2 ] ) asArray = #( 2 )
	) description:( '( #( 1 )asGenerator firstDo:[ :na | 2 ] ) asArray = #( 2 )' ) ).

	( self assert:(
		( #( 1 2 )asGenerator firstDo:[ :na | 2 ] ) asArray = #( 2 2 )
	) description:( '( #( 1 2 )asGenerator firstDo:[ :na | 2 ] ) asArray = #( 2 2 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 )asGenerator firstDo:[ :na | 2 ] ) asArray = #( 2 2 3 4 5 )
	) description:( '( #( 1 2 3 4 5 )asGenerator firstDo:[ :na | 2 ] ) asArray = #( 2 2 3 4 5 )' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCollecting' stamp: 'KjellGodo 4/21/2013 17:11'!
testfirstnext "first: firstBlock next: nextBlock

	""Method Version: keg1.  ""
	""Copyright Kjell E God January 05 2000""
	""licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.""
	""Date of Last Revision: Date today January 05 2000""
												""( MT b:#first:next: s:self ).""
	^( 
		( self abstractGenerator new
			firstBlock:[ ( self first )ifNotNil:[ :x | firstBlock value: x ] ]
			nextBlock:[ ( self next )ifNotNil:[ :x | nextBlock value: x ] ] )

	)""return:(										  MT e:#first:next: s:self )""

	""Return a Generator where the first element is returned by firstBlock and the rest are all
	returned by nextBlock.  firstBlock is a monadic valuable and so is nextBlock."

	( self assert:( 
		( #(  ) asGenerator first:[ :x | x - 1 ] next:[ :x | x + 1 ] ) asArray = #(  )
	) description:( '( #(  ) first:[ :x | x - 1 ] next:[ :x | x + 1 ] ) asArray = #(  )' ) ).

	( self assert:( 
		( #( 1 ) asGenerator first:[ :x | x - 1 ] next:[ :x | x + 1 ] ) asArray = #( 0 )
	) description:( '( #( 1 ) first:[ :x | x - 1 ] next:[ :x | x + 1 ] ) asArray = #( 0 )' ) ).

	( self assert:( 
		( #( 1 2 ) asGenerator first:[ :x | x - 1 ] next:[ :x | x + 1 ] ) asArray = #( 0 3 )
	) description:( '( #( 1 2 ) first:[ :x | x - 1 ] next:[ :x | x + 1 ] ) asArray = #( 0 3 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator first:[ :x | x - 1 ] next:[ :x | x + 1 ] ) asArray = #( 0 3 4 )
	) description:( '( #( 1 2 3 ) first:[ :x | x - 1 ] next:[ :x | x + 1 ] ) asArray = #( 0 3 4 )' ) )! !

!KEGGeneratorTest methodsFor: 'generatorCollecting' stamp: 'KjellGodo 4/21/2013 17:12'!
testfirstnextlast "first: firstBlock next: nextBlock last: lastBlock

	""Method Version: keg1.  ""
	""Copyright Kjell E God Nov 17 1996""
	""licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.""
	""Date of Last Revision: Date today Nov 17 1996""
	| answer notifyLast isLast first |
												  ""MT b:#first:next:last: s:self.""

	notifyLast := self lookAhead1:[ :x :xplus1 | xplus1 ifNil:[ isLast := true ] .  x ] .

	answer := self abstractGenerator new
		firstBlock:[ isLast := false .
			( notifyLast first )ifNotNil:[ :next |
				first := firstBlock value: next .
				isLast ifTrue:[ first := lastBlock value: first ] . 
				first ] ]
		nextBlock:[
			( notifyLast next ) ifNotNil:[ :next |
				isLast
					ifTrue:[ lastBlock value: next ]
					ifFalse:[ nextBlock value: next ] ]
		] .
												  ""MT e:#first:next:last: s:self.""
	^answer .

	""
	firstBlock is evaluated on the first element of self and
	nextBlock is evaluated on the rest of the elements of self and
	lastBlock is evaluated on the last element of self.  The
	results of these Blocks are returned in order.  So self This Method
	is like self>>collect: except that it has special processing for
	the first and last elements of self.

	Let self = < s1 s2 s3 ... sN > where N is in the set { 0 1 2 3 ... }
	where N=0 means self is empty.  self is empty means self is an 
	infinite sequence of all nils like < nil nil nil ... > .
	The returned sequence r is
	r = < r1 r2 r3 ... rN >
	where r1 = ( firstBlock value: s1 )
	where r2 = ( nextBlock value: s2 )
	. . .
	where rN-1 = ( nextBlock value: sN-1 )
	where rN = ( lastBlock value: sN )

	But if self = < s1 >

	then r = < ( lastBlock value:( firstBlock value: s1 ) ) >

	"

	( self assert:( 
		( #(  ) asGenerator first:[ :x | x - 1 ]next:[ :x | x + 1 ]last:[ :x | x + 2 ] ) asArray = #(  )
	)description:( '( #(  ) asGenerator first:[ :x | x - 1 ]next:[ :x | x + 1 ]last:[ :x | x + 2 ] ) asArray = #(  )' ) ).

	( self assert:( 
		( #( 1 ) asGenerator first:[ :x | x - 1 ]next:[ :x | x + 1 ]last:[ :x | x + 2 ] ) asArray = #( 2 )
	)description:( '( #( 1 ) asGenerator first:[ :x | x - 1 ]next:[ :x | x + 1 ]last:[ :x | x + 2 ] ) asArray = #( 2 )' ) ).

	( self assert:( 
		( #( 1 2 ) asGenerator first:[ :x | x - 1 ]next:[ :x | x + 1 ]last:[ :x | x + 2 ] ) asArray = #( 0 4 )
	)description:( '( #( 1 2 ) asGenerator first:[ :x | x - 1 ]next:[ :x | x + 1 ]last:[ :x | x + 2 ] ) asArray = #( 0 4 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator first:[ :x | x - 1 ]next:[ :x | x + 1 ]last:[ :x | x + 2 ] ) asArray = #( 0 3 5 )
	)description:( '( #( 1 2 3 ) asGenerator first:[ :x | x - 1 ]next:[ :x | x + 1 ]last:[ :x | x + 2 ] ) asArray = #( 0 3 5 )' ) ).

	( self assert:( 
		( #( 1 2 3 4 ) asGenerator first:[ :x | x - 1 ]next:[ :x | x + 1 ]last:[ :x | x + 2 ] ) asArray = #( 0 3 4 6 )
	)description:( '( #( 1 2 3 4 ) asGenerator first:[ :x | x - 1 ]next:[ :x | x + 1 ]last:[ :x | x + 2 ] ) asArray = #( 0 3 4 6 )' ) ).

! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/21/2013 17:12'!
testfromto "from: startBlk to: endBlk

	""Method Version: keg1.  ""
	"" Copyright Kjell E God Jan  5 2000""
	""licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.""
	""Date of Last Revision: Date today Jan  5 2000""

	| answer atStart atEnd next param ii start end |

					""MT b:#from:to: s:self.""

	param := Array new: 2 .
	( ( startBlk isInteger )and:[ endBlk isInteger ] )
		ifTrue:[ ( start := startBlk ).( end := endBlk ).
			( KEGGenerator counter dot:[ :i :x | ii:=i. x ] with: self )
				from:[ :x | ii = start ] 
				to:[ :x | ii = end ] ]ifFalse:[ 
	( startBlk isInteger ) 
		ifTrue:[
			( KEGGenerator counter dot:[ :i :x | param p1:i p2:x ] with: self )
				from:[ :p | p p1 = startBlk ] 
				to:[ :p | endBlk value: p p2 ] ]ifFalse:[
	( endBlk isInteger )
		ifTrue:[ 
			( KEGGenerator counter dot:[ :i :x | param p1:i p2:x ] with: self )
				from:[ :p | startBlk value: p p2 ] 
				to:[ :p | p p1 = endBlk ] ]
	ifFalse:[
		atStart := false . atEnd := next := false .
		answer := self select:[ :x | atStart or:[ atStart := startBlk value: x ] ] .
		answer := answer reject:[ :x | 
			atEnd := next. ( atEnd or:[ endBlk value: x ] )ifTrue:[ next := true ] . atEnd ] 
	] ] ] .
					""MT e:#from:to: s:self.""
	^answer .

	""startBlk and endBlk are monadicValuables or Integers.
	If self is a generator s = <s1 s2 s3 ... sN ... sM ...> and sN is the first element of self such
	that ( startBlk value: sN ) is true and
	( endBlk value: sM ) is true and there are no i between N and M such that ( endBlk value: si ) 
	is true then return the generator r = <sN ... sM> where it may be that N = M.  If no such M 
	exists then r = <sN ... > is returned.  If no such N exists then r = <  > is returned.""

	"" some test cases-: "

	( self assert:(
		( ( #( 1 ) asGenerator from:( 1 ) to:( 1 ) ) asArray = #( 1 ) )
	) description:( '( ( #( 1 ) asGenerator from:( 1 ) to:( 1 ) ) asArray = #( 1 ) )' ) ).

	( self assert:(
		( ( #( 1 ) asGenerator from:( 1 ) to:[ :x | x = 1 ] ) asArray = #( 1 ) )
	) description:( '( ( #( 1 ) asGenerator from:( 1 ) to:[ :x | x = 1 ] ) asArray = #( 1 ) )' ) ).

	( self assert:(
		( ( #( 1 ) asGenerator from:[ :x | x = 1 ] to:( 1 ) ) asArray = #( 1 ) )
	) description:( '( ( #( 1 ) asGenerator from:[ :x | x = 1 ] to:( 1 ) ) asArray = #( 1 ) )' ) ).

	( self assert:(
		( ( #( 1 ) asGenerator from:[ :x | x = 1 ] to:[ :x | x = 1 ] ) asArray = #( 1 ) )
	) description:( '( ( #( 1 ) asGenerator from:[ :x | x = 1 ] to:[ :x | x = 1 ] ) asArray = #( 1 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 1 ] to:[ :x | x = 1 ] ) asArray = #( 1 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 1 ] to:[ :x | x = 1 ] ) asArray = #( 1 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 1 ] to:[ :x | x = 1 ] ) asArray = #( 1 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 1 ] to:[ :x | x = 1 ] ) asArray = #( 1 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 3 ] to:[ :x | x = 3 ] ) asArray = #( 3 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 3 ] to:[ :x | x = 3 ] ) asArray = #( 3 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 9 ] to:[ :x | x = 9 ] ) asArray = #( 9 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 9 ] to:[ :x | x = 9 ] ) asArray = #( 9 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 1 ] to:[ :x | x = 7 ] ) asArray = #( 1 2 3 4 5 6 7 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 1 ] to:[ :x | x = 7 ] ) asArray = #( 1 2 3 4 5 6 7 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 3 ] to:[ :x | x = 9 ] ) asArray = #( 3 4 5 6 7 8 9 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 3 ] to:[ :x | x = 9 ] ) asArray = #( 3 4 5 6 7 8 9 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:( 3 ) to:( 7 ) ) asArray = #( 3 4 5 6 7 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:( 3 ) to:( 7 ) ) asArray = #( 3 4 5 6 7 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3.3 4.4 5.5 6.6 7.7 8 9 ) asGenerator from:( 3 ) to:( 7 ) ) asArray = #( 3.3 4.4 5.5 6.6 7.7 ) )
	) description:( '( ( #( 1 2 3.3 4.4 5.5 6.6 7.7 8 9 ) asGenerator from:( 3 ) to:( 7 ) ) asArray = #( 3.3 4.4 5.5 6.6 7.7 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3.3 4.4 5.5 6.6 7.7 8 9 ) asGenerator from:( 3 ) to:[ :x | x = 7 ] ) asArray = #( 3.3 4.4 5.5 6.6 7.7 8 9 ) )
	) description:( '( ( #( 1 2 3.3 4.4 5.5 6.6 7.7 8 9 ) asGenerator from:( 3 ) to:[ :x | x = 7 ] ) asArray = #( 3.3 4.4 5.5 6.6 7.7 8 9 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:( 3 ) to:[ :x | x = 7 ] ) asArray = #( 3 4 5 6 7 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:( 3 ) to:[ :x | x = 7 ] ) asArray = #( 3 4 5 6 7 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 3 ] to:( 7 ) ) asArray = #( 3 4 5 6 7 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 3 ] to:( 7 ) ) asArray = #( 3 4 5 6 7 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 3 ] to:[ :x | x = 7 ] ) asArray = #( 3 4 5 6 7 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 3 ] to:[ :x | x = 7 ] ) asArray = #( 3 4 5 6 7 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 3 ] to:[ :x | x = 17 ] ) asArray = #( 3 4 5 6 7 8 9 ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 3 ] to:[ :x | x = 17 ] ) asArray = #( 3 4 5 6 7 8 9 ) )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 13 ] to:[ :x | x = 7 ] ) asArray = #(  ) )
	) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator from:[ :x | x = 13 ] to:[ :x | x = 7 ] ) asArray = #(  ) )' ) )
! !

!KEGGeneratorTest methodsFor: 'accessing' stamp: 'KjellGodo 4/21/2013 17:14'!
testgeneratorC "generator: aReadOnlyStream"

        "Method Version: keg1.  "
        "Copyright Kjell E God April 13, 1999"
        "Date of Last Revision: Date today April 13, 1999"

	"Set the generator in self.  You must do [ self reset ] still to get ready to 
	do [ self next ]."

	"| answer |"

				"MT b:#generator: s:self ."
				"MT e:#generator: s:self ."

	"^generator := aReadOnlyStream ."

	( self assert:(
		( #(  ) asGenerator generator:( #( 4 5 6 ) asGenerator ) ; asArray ) = #(4 5 6)
		) description:( '#(  ) asGenerator generator:( #( 4 5 6 ) asGenerator ) ; asArray = #(4 5 6)' ) ).

	( self assert:(
		( #( 1 ) asGenerator generator:( #( 4 5 6 ) asGenerator ) ; asArray ) = #(4 5 6)
		) description:( '#( 1 ) asGenerator generator:( #( 4 5 6 ) asGenerator ) ; asArray = #(4 5 6)' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator generator:( #( 4 5 6 ) asGenerator ) ; asArray ) = #(4 5 6)
		) description:( '#( 1 2 3 ) asGenerator generator:( #( 4 5 6 ) asGenerator ) ; asArray = #(4 5 6)' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator generator:( #( 4 5 6 ) readStream ) ; asArray ) = #(4 5 6)
		) description:( '#( 1 2 3 ) asGenerator generator:( #( 4 5 6 ) readStream ) ; asArray = #(4 5 6)' ) ).

	! !

!KEGGeneratorTest methodsFor: 'testing' stamp: 'KjellGodo 4/25/2013 17:45'!
"(| defineMethod-:(" testifEmptyC "ifEmpty: aBlock "")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God 20030227
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030306, 20030227
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#ifEmpty: s:self ).""
	^(
		( self first ifNil:[ aBlock value:( self ) ]ifNotNil:[ self ] )

	)""return:( 					MT e:#ifEmpty: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	
	Override the superClass version of self-:( this method ) so we don't wind up having
	to iterate all the way to the end of self to find the size of self to find out if self is
	empty or not.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG3-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg3
	(| KEG2-:( Changes onDate-:( <D:20030306> ) 
		theOldCode-:( '' ) wasReplacedBy-:( 'ifFalse:[ self ]' ) )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( #(  ) asGenerator ifEmpty:[ :e | e asArray ] ) = #(  )
		) description:( '( #(  ) asGenerator ifEmpty:[ :e | e asArray ] ) = #(  )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator ifEmpty:[ :e | 1 ] ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 ) asGenerator ifEmpty:[ :e | 1 ] ) asArray = #( 1 2 3 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'testing' stamp: 'KjellGodo 4/25/2013 17:46'!
"(| defineMethod-:(" testifEmptyCifNotEmptyC "ifEmpty: emptyBlock ifNotEmpty: notEmptyBlock "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030227
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030227
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#ifEmpty:ifNotEmpty: s:self ).""
	^(
		( self first isNil
		) ifTrue:[ emptyBlock		value:( self ) ]
		  ifFalse:[ notEmptyBlock	value:( self ) ]

	)""return:( 					MT e:#ifEmpty:ifNotEmpty: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Override the superClass version of self-:( this method ) so we don't wind up having
	to iterate all the way to the end of self to find the size of self to find out if self is
	empty or not.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( #(  ) asGenerator ifEmpty:[ :e | e asArray ]ifNotEmpty:[ :e | 1 ] ) = #(  )
		) description:( '( #(  ) asGenerator ifEmpty:[ :e | e asArray ]ifNotEmpty:[ :e | 1 ] ) = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator ifEmpty:[ :e | e asArray ]ifNotEmpty:[ :e | 2 ] ) = 2
		) description:( '( #( 1 ) asGenerator ifEmpty:[ :e | e asArray ]ifNotEmpty:[ :e | 2 ] ) = 2' ) )

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'testing' stamp: 'KjellGodo 4/25/2013 17:46'!
"(| defineMethod-:(" testifNotEmptyC "ifNotEmpty: aBlock "")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God 20030227
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030306, 20030227
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#ifNotEmpty: s:self ).""
	^(
		( self first notNil )ifTrue:[ aBlock value:( self ) ]ifFalse:[ self ]

	)""return:( 					MT e:#ifNotEmpty: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Override the superClass version of self-:( this method ) so we don't wind up having
	to iterate all the way to the end of self to find the size of self to find out if self is
	empty or not.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG3-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg3
	(| KEG2-:( Changes onDate-:( <D:20030306> )
		theOldCode-:( '' ) wasReplacedBy-:( 'ifFalse:[ self ]' ) )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( #(  ) asGenerator ifNotEmpty:[ :e | 1 ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator ifNotEmpty:[ :e | 1 ] ) = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator ifNotEmpty:[ :e | 2 ] ) = 2
		) description:( '( #( 1 ) asGenerator ifNotEmpty:[ :e | 2 ] ) = 2' ) )

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/25/2013 17:46'!
testincludesC "includes: anObject"

	"Method Version: keg1.  "
	" Copyright Kjell E God 20010406"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20010406"

        "Return true if and only if there is an element of self which is = to anObject.""

	| answer |
							""MT b:#includes: s:self.""

	answer := self exists:[ :x | x = anObject ] .

							""MT e:#includes: s:self.""
	^answer ."

	
	( self assert:( 
		( #(  ) asGenerator includes: 1 ) not
		) description:( '( #(  ) asGenerator includes: 1 ) not' ) ).

	( self assert:( 
		( #( 2 3 ) asGenerator includes: 1 ) not
		) description:( '( #( 2 3 ) asGenerator includes: 1 ) not' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator includes: 1 )
		) description:( '( #( 1 2 3 ) asGenerator includes: 1 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator includes: 2 )
		) description:( '( #( 1 2 3 ) asGenerator includes: 2 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator includes: 3 )
		) description:( '( #( 1 2 3 ) asGenerator includes: 3 )' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/21/2013 17:18'!
testinjectCintoC "inject: initialValue into: aBinaryBlock"

        "Method Version: keg2.  "
        "Copyright Kjell E God 04-21-1992"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today April 14 1999, 04-21-1992""
    | answer |
							""( MT b: #inject:into: s:self ).""
	( answer := initialValue ).
	( self do: [ :element |
		answer := aBinaryBlock
			value: answer
			value: element ] ).
	^( answer )""returning:(			MT e: #inject:into: s:self )"
    
       "Execute the following algorithm a:
               Let i = initialValue.
               Let e(x,y) be the execution of aBinaryBlock
                    on x and y.
               Let self = s.   s = <s1,s2,s3,...> (a sequence of elements)

               Then a = . . . e(e(e(e(e(e(i,s1),s2),s3),s4),s5),s6) . . .
                    or equivalently
                    a = ( i1 := e( i, s1) ),
                           ( i2 := e( i1, s2) ),
                           ( i3 := e( i2, s3) ),
                           ( i4 := e( i3, s4) ),
                           ( i5 := e( i4, s5) ),
                                     . . .
                           ( iM := e( iM-1, sM) ) .

                         Where each ( ij := e( ij-1, sj) ) is a step in the algorithm.

               The value v returned is iM, the last value generated by the
               last step in the algorithm.

	KEG2: moved code to Dolphin version 2.1 patch level 2."

	( self assert:(
		( #(  ) asGenerator inject: 1 into:[ :sum :x | sum ] ) = 1
		) description:( '( #(  ) asGenerator inject: 1 into:[ :sum :x | sum ] ) = 1' ) ).

	( self assert:(
		( #( 2 3 4 ) asGenerator inject: 1 into:[ :sum :x | sum + x ] ) = 10
		) description:( '( #( 2 3 4 ) asGenerator inject: 1 into:[ :sum :x | sum + x ] ) = 10' ) ).

	! !

!KEGGeneratorTest methodsFor: 'testing' stamp: 'KjellGodo 4/21/2013 17:19'!
testisEmpty "isEmpty"

	"Method Version: keg1.  "
	" Copyright Kjell E God 04-21-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today 04-21-92"

		"Return true iff self has no elements.""

	| answer |
					""MT b: #isEmpty s: self .""

	 answer := self first isNil .

					""MT e: #isEmpty s: self .""
	 ^answer .

	"
	( self assert:(
		#(  ) asGenerator isEmpty
		) description:( '#(  ) asGenerator isEmpty' ) ).

	( self assert:(
		#( 1 ) asGenerator isEmpty not
		) description:( '#( 1 ) asGenerator isEmpty not' ) ).

	( self assert:(
		#( 1 2 3 ) asGenerator isEmpty not
		) description:( '#( 1 2 3 ) asGenerator isEmpty not' ) ).

	! !

!KEGGeneratorTest methodsFor: 'testing' stamp: 'KjellGodo 4/25/2013 17:46'!
testisOnAStream "isOnAStream"

	"Method Version: keg2.  "
	" Copyright Kjell E God Nov 11 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision:Date today tradePrint 20000814, Nov 11 1999"

	"Self is assumed to be on a Stream or at least a Stream like thing if generator is not	nil.
	KEG2: removed 'notNil' and replaced it with 'isKindOf: Stream' such that self>>asCanGoBackGen
	can work and KEGAsCanGoBack Generators can be on AbstractGenerators and not just Streams."

						"MT b:#isOnAStream s:self."
						"MT e:#isOnAStream s:self.""
	^generator isKindOf: Stream ."



	( self assert:( 
		( KEGAbstractGenerator new resetBlock:[  ]nextBlock:[  ] ) isOnAStream not
		) description:( '( KEGAbstractGenerator new resetBlock:[  ]nextBlock:[  ] ) isOnAStream not' ) ).

	( self assert:( 
		KEGGenerator streamGenerator isOnAStream
		) description:( 'KEGGenerator streamGenerator isOnAStream' ) ).

	( self assert:( 
		#( 1 3 4 ) asGenerator isOnAStream
		) description:( '#( 1 3 4 ) asGenerator isOnAStream' ) ).

! !

!KEGGeneratorTest methodsFor: 'testing' stamp: 'KjellGodo 4/21/2013 17:21'!
testisSequence "isSequence"

	"Method Version: keg2.  "
	"Copyright Kjell E God Nov 29, 1993"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today September 22 1999, Nov 29, 1993"

	"Return true because self is a Sequence of Objects.  Therefore it can be put into a
	Generator by at least one means and sequenced over.
	KEG2: Moved it from Smalltalk/V 2.0 over to Dolphin 2.1 patch level 2( just some null touch
	ups )."

									"MT b:#isSequence s:self ."
									"MT e:#isSequence s:self ."
	"^true ."

	
	( self assert:( 
		OrderedCollection new isSequence 
		) description:( 'OrderedCollection new isSequence ' ) ).

	( self assert:( 
		Set new isSequence
		) description:( 'Set new isSequence' ) ).

	( self assert:( 
		Dictionary new isSequence
		) description:( 'Dictionary new isSequence' ) ).

	( self assert:( 
		#( 1 2 3 ) isSequence
		) description:( '#( 1 2 3 ) isSequence' ) ).

	( self assert:( 
		'123' isSequence not
		) description:( '''123'' isSequence not' ) ).

	( self assert:( 
		#( 1 2 3 ) asGenerator isSequence
		) description:( '#( 1 2 3 ) asGenerator isSequence' ) ).

	( self assert:( 
		#( 1 2 3 ) readStream isSequence
		) description:( '#( 1 2 3 ) readStream isSequence' ) ).

	( self assert:( 
		#( 1 2 3 ) writeStream isSequence
		) description:( '#( 1 2 3 ) writeStream isSequence' ) ).

	( self assert:( 
		$a isSequence not
		) description:( '$a isSequence not' ) ).

	( self assert:( 
		1 isSequence not
		) description:( '1 isSequence not' ) ).

! !

!KEGGeneratorTest methodsFor: 'testing' stamp: 'KjellGodo 4/25/2013 17:46'!
"(| defineMethod-:(" testisSingleton "isSingleton "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20031212
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20031212
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#isSingleton s:self ).""

	^(
		( ( self first notNil )and:[ self next isNil ] )

	)""return:( 					MT e:#isSingleton s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return true if and only if self has just one element.
	Return true if and only if the size of self = 1 .

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		#(  ) asGenerator isSingleton not 
		) description:( '#(  ) asGenerator isSingleton not ' ) ).

	( self assert:(
		#( 1 ) asGenerator isSingleton 
		) description:( '#( 1 ) asGenerator isSingleton ' ) ).

	( self assert:(
		#( 1 2 ) asGenerator isSingleton not 
		) description:( '#( 1 2 ) asGenerator isSingleton not ' ) ).

	( self assert:(
		#( 1 2 3 ) asGenerator isSingleton not 
		) description:( '#( 1 2 3 ) asGenerator isSingleton not ' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorEvaluation' stamp: 'KjellGodo 4/21/2013 17:22'!
testiterate "iterate"

	"Method Version: keg1.  "
	" Copyright Kjell E God 04-21-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today 04-21-92"

	"Run self out to its end.   "

						"( MT b:#iterate  s:self ).""

	 ( self last ).


	""^( self )return:(			MT e:#iterate  s:self )"

	
	| y |

	y := OrderedCollection new .
	( self assert:(
		( [ ( #(  ) asGenerator collect:[ :x | y add: x ] )iterate. y asArray ] value = #(  ) )
		) description:( '( [ ( #(  ) asGenerator collect:[ :x | y add: x ] )iterate. y asArray ] value = #(  ) )' ) ).

	y := OrderedCollection new .
	( self assert:(
		( [ ( #( 1 ) asGenerator collect:[ :x | y add: x ] )iterate. y asArray ] value = #( 1 ) )
		) description:( '( [ ( #( 1 ) asGenerator collect:[ :x | y add: x ] )iterate. y asArray ] value = #( 1 ) )' ) ).

	y := OrderedCollection new .
	( self assert:(
		( [ ( #( 1 2 3 ) asGenerator collect:[ :x | y add: x ] )iterate. y asArray ] value  = #( 1 2 3 ) )
		) description:( '( [ ( #( 1 2 3 ) asGenerator collect:[ :x | y add: x ] )iterate. y asArray ] value  = #( 1 2 3 ) )' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/25/2013 17:47'!
"(| defineMethod-:(" testkeysAndValuesCollectC "keysAndValuesCollect: transformer "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20031213
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20031213
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#keysAndValuesCollect: s:self ).""
	^(
		( self keysAndValuesDo:( transformer ) )

	)""return:( 					MT e:#keysAndValuesCollect: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Just like KEGGenerator>>keysValuesDo: .  Which is missNamed to
	a certain extent.  And so self-:( this method ) puts that missNaming to
	rights.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( #(  ) asGenerator keysAndValuesCollect:[ :i :x | Array p1: i p2: x ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator keysAndValuesCollect:[ :i :x | Array p1: i p2: x ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( $a ) asGenerator keysAndValuesCollect:[ :i :x | Array p1: i p2: x ] ) asArray = #( ( 1 $a ) )
		) description:( '( #( $a ) asGenerator keysAndValuesCollect:[ :i :x | Array p1: i p2: x ] ) asArray = #( ( 1 $a ) )' ) ).

	( self assert:(
		( #( $a $b ) asGenerator keysAndValuesCollect:[ :i :x | Array p1: i p2: x ] ) asArray = #( ( 1 $a )( 2 $b ) )
		) description:( '( #( $a $b ) asGenerator keysAndValuesCollect:[ :i :x | Array p1: i p2: x ] ) asArray = #( ( 1 $a )( 2 $b ) )' ) ).

	( self assert:(
		( #( $a $b $c ) asGenerator keysAndValuesCollect:[ :i :x | Array p1: i p2: x ] ) asArray = #( ( 1 $a )( 2 $b )( 3 $c ) )
		) description:( '( #( $a $b $c ) asGenerator keysAndValuesCollect:[ :i :x | Array p1: i p2: x ] ) asArray = #( ( 1 $a )( 2 $b )( 3 $c ) )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/21/2013 17:24'!
testlast "last"

	"Method Version: keg1.  "
	" Copyright Kjell E God 04-21-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today 04-21-92"

	"Return the last element of self.
	As a side effect, all the elements of self will be calculated.   This can be useful in situations where
	the actual values of the elements of self are not important but the side effects caused by calculating
	all the values of self are desired.""

	| answer |
						""MT b:#last  s:self .""

	self do:[ :x | answer := x ] .

						""MT e:#last  s:self .""
	 ^answer ."


	( self assert:(
		#(  ) asGenerator last = nil
		) description:( '#(  ) asGenerator last = nil' ) ).

	( self assert:(
		#( 1 ) asGenerator last = 1
		) description:( '#( 1 ) asGenerator last = 1' ) ).

	( self assert:(
		#( 1 2 ) asGenerator last = 2
		) description:( '#( 1 2 ) asGenerator last = 2' ) ).

	( self assert:(
		#( 1 2 3 ) asGenerator last = 3
		) description:( '#( 1 2 3 ) asGenerator last = 3' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/21/2013 17:24'!
testlastC "last: anInteger"

	"Method Version: keg1.  "
	"Copyright Kjell E God May 26 1997"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today May 26 1997"

	"Return the a Generator on the last anInteger elements of self.  The initial use of this
	method was to return the last 20 lines in a file.  PS: it is assumed that self size is quite
	a bit larger than anInteger.""

	| answer |
						""MT b:#last: s:self.""

	answer := ( self reverse first: anInteger ) reverse . #todoKEG. ""<---( Please reinstate the old code below if possible as it may be more efficient.  You can do time trials to find out. )"

						"MT e:#last: s:self.""
	^answer .

""(-OLD-CODE----------------------------------:
	answer := ( KEGFixedSizeQue new: anInteger ) fill: self .""<---( self is reset and does next anInteger number of times. )""
	self noReset do:[ :x | answer addLast: x ] . ""<--------------------------( self continues where it left off during the >>fill: above. )""
	answer := answer asGenerator .
:=====================OLD=CODE=)"

	( self assert:(
		( #(  ) asGenerator last: 3 ) asArray = #(  )
		) description:( '( #(  ) asGenerator last: 3 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator last: 3 ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator last: 3 ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator last: 3 ) asArray = #( 1 2 )
		) description:( '( #( 1 2 ) asGenerator last: 3 ) asArray = #( 1 2 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator last: 3 ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 ) asGenerator last: 3 ) asArray = #( 1 2 3 )' ) ).

	( self assert:(
		( #( 1 2 3 4 ) asGenerator last: 3 ) asArray = #( 2 3 4 )
		) description:( '( #( 1 2 3 4 ) asGenerator last: 3 ) asArray = #( 2 3 4 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator last: 3 ) asArray = #( 3 4 5 )
		) description:( '( #( 1 2 3 4 5 ) asGenerator last: 3 ) asArray = #( 3 4 5 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator last: 2 ) asArray = #( 4 5 )
		) description:( '( #( 1 2 3 4 5 ) asGenerator last: 2 ) asArray = #( 4 5 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator last: 1 ) asArray = #( 5 )
		) description:( '( #( 1 2 3 4 5 ) asGenerator last: 1 ) asArray = #( 5 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator last: 0 ) asArray = #(  )
		) description:( '( #( 1 2 3 4 5 ) asGenerator last: 0 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator last: -1 ) asArray = #(  )
		) description:( '( #( 1 2 3 4 5 ) asGenerator last: -1 ) asArray = #(  )' ) ).


	! !

!KEGGeneratorTest methodsFor: 'generatorCollecting' stamp: 'KjellGodo 4/25/2013 17:47'!
"(| defineMethod-:(" testlastDoC "lastDo: doLastBlk "")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God 20001209
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20021003 20001209
	)-notes methodBody-:(
 (| let-:(""| next stopNow n |"")
    letBody-:("					"( MT b:#lastDo: s:self ).""

	^(
		self abstractGenerator new
			resetBlock:[ stopNow := ( next := self first ) isNil ]
			nextBlock:[ 
				( stopNow )ifFalse:[
					( n := next ).
					( next := self next ) isNil 
						ifTrue:[ ( stopNow:=true ).( doLastBlk value:( n ) ) ]
						ifFalse:[ n ]
				]
			]

	)""return:( 					MT e:#lastDo: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a Generator that returns the value of doLastBlk <---( a monadicValuable )
	as it's last element.
	If self = <s1 s2 s3 ... sN > then the returned Generator 
	r = < s1 s2 s3 ... ( doLastBlk value: sN) >.
	Also please note that the nils below are empty valuables in self( the picoVerse )
	so nil is equivalent to [ :x | x ] .

 )-summary
 methodDescriptionDetail-:(

	a monadicValuable is anything that responds to the message-:( >>value: ) .
	oldCode-:(
		( self first:( nil )next:( nil )last:( doLastBlk ) )
	)-oldCode

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG3-:( Changes onDate-:( ... ) madeChanges-:( ... ) )-chg )-keg3
	(| KEG2-:( Changes onDate-:( 20021003 ) madeChanges-:( removed the old code and
		replaced it with the faster code which was previously commented out so that I wouldn't
		be so reticent to use lastDo: because of the perception that it must be slow. Thus we
		no longer have to use >>lookAhead1: testing for nil because self-:( this method )
		should be faster than that. ) )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:( 
		( ( #(  ) asGenerator lastDo:[ :x | 4 ] ) asArray = #(  ) )
		) description:( '( ( #(  ) asGenerator lastDo:[ :x | 4 ] ) asArray = #(  ) )' ) ).

	( self assert:( 
		( ( #( 1 ) asGenerator lastDo:[ :x | 4 ] ) asArray = #( 4 ) )
		) description:( '( ( #( 1 ) asGenerator lastDo:[ :x | 4 ] ) asArray = #( 4 ) )' ) ).

	( self assert:( 
		( ( #( 1 2 ) asGenerator lastDo:[ :x | 4 ] ) asArray = #( 1 4 ) )
		) description:( '( ( #( 1 2 ) asGenerator lastDo:[ :x | 4 ] ) asArray = #( 1 4 ) )' ) ).

	( self assert:( 
		( ( #( 1 2 3 ) asGenerator lastDo:[ :x | 4 ] ) asArray = #( 1 2 4 ) )
		) description:( '( ( #( 1 2 3 ) asGenerator lastDo:[ :x | 4 ] ) asArray = #( 1 2 4 ) )' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCollecting' stamp: 'KjellGodo 4/21/2013 17:45'!
testlookAhead1C "lookAhead1: pairingBlock"

	"Method Version: keg1.  "
	" Copyright Kjell E God 04-22-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today 04-22-92""
	| lastNext next |			""( MT b: #lookAhead1:  s: self ).""
	^(
		( self abstractGenerator new
			resetBlock:[ next := self first  ]
			nextBlock:[ ( lastNext := next ).( next := self next ).
				lastNext ifNotNil:[ pairingBlock value: lastNext value: next ]
			] )

	)""return:(					MT e: #lookAhead1:  s: self )"

	"Return a generator which has as its elements the
		following:
			Let s be self.   Then s = <s1, s2, s3, s4, s5, s6 ..., sN>
				where <s1, s2, s3, s4, s5, s6 ..., sN> is the sequence
					of elements in s.   Where N is an Integer >= 0 .
				Let g be the returned generator.
				Let p(x,y) be the results of executing the pairingBock
					on x and y.   (pairingBlock [ :x :y | <code> ] is a two parameter block
					the first parameter x to the pairingBlock is considered
					the main do: value to be executed on, the y parameter is considered
					the look ahead value.	One can also do a pairing operation
					like the pairUp: and allNeighborsPairUp: methods do but unlike
					those methods here the y parameter to the pairingBlock will be nil)
				Then	  g = < p(s1,s2), p(s2,s3), p(s3,s4), p(s4,s5), ..., p(sN, nil)>
	"
	
	( self assert:(
		( #(  ) asGenerator lookAhead1:[ :x :y | Array p1: x p2: y ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator lookAhead1:[ :x :y | Array p1: x p2: y ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator lookAhead1:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 nil ) )
		) description:( '( #( 1 ) asGenerator lookAhead1:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 nil ) )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator lookAhead1:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 ) ( 2 nil ) )
		) description:( '( #( 1 2 ) asGenerator lookAhead1:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 ) ( 2 nil ) )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator lookAhead1:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )  ( 2 3 )  ( 3 nil ) )
		) description:( '( #( 1 2 3 ) asGenerator lookAhead1:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )  ( 2 3 )  ( 3 nil ) )' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorCollecting' stamp: 'KjellGodo 4/25/2013 17:47'!
"(| defineMethod-:(" testlookAheadCDoC ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20100903
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20100903 15:13 )
	)-notes methodBody-:(
 (| let-:(""| fixedSizeQue next |"")
    letBody-:(""					""( MT b: #lookAhead:do:  s: self ).""
	( fixedSizeQue := self theKEGFixedSizedQueClass new size: anInteger ; yourself ).
	^(
		( self abstractGenerator new
			resetBlock:[ ( self reset ).( 1 to: anInteger do:[ :na | fixedSizeQue addLast:( self next ) ] ) ]
			nextBlock:[ 
				( next := fixedSizeQue first ).
				( next notNil ifTrue:[ aDiadicValuable value: next value:( fixedSizeQue addLast:( self next ) ; yourself ) ] )
			] )

	)""return:(					MT e: #lookAhead:do:  s: self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a KEGGenerator that looks ahead anInteger elements into self.
	The lookAhead is contained in a KEGFixedSizedQue circular list.
	
 )-summary
 methodDescriptionDetail-:(

	Suppose self = < s1 s2 s3 ... > and anInteger = 3.
	And suppose aDiadicValuable =
		[ :x :fsq | Array with: x with:( ( fsq asArray collect:[ :x | x contents ] ) asArray ) ]
	Then the Generator r returned is of the following form:

	r = <	( s1 ( s2 s3 s4 ) )
		( s2 ( s3 s4 s5 ) )
		( s3 ( s4 s5 s6 ) ) ... >

	Suppose ( self size = 6 ) then 
	self = < s1 s2 s3 s4 s5 s6 >
	and then
	r = <	( s1 ( s2 s3 s4 ) )
		( s2 ( s3 s4 s5 ) )
		( s3 ( s4 s5 s6 ) )
		( s4 ( s5 s6 nil ) )
		( s5 ( s6 nil nil ) )
		( s6 ( nil nil nil ) ) >

	Now suppose aDiadicValuable = [ :x :fsq | Array with: x with:( fsq asGenerator asArray ) ]
	and then
	r = <	( s1 ( s2 s3 s4 ) )
		( s2 ( s3 s4 s5 ) )
		( s3 ( s4 s5 s6 ) )
		( s4 ( s5 s6 ) )
		( s5 ( s6 ) )
		( s6 (  ) ) >

	See the test cases below and in the KEGGeneratorTest Class 
	KEGGeneratorTest>>testLookAheadDo.

 )-detail
 usage-:(
	usage
 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGLambdaLispEvalV6p1>>evalWithActivationRec:returningToContinuation:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:("

	self assert:( 
	( ( #(  ) asGenerator lookAhead: 3 do:[ :x :fsq | Array with: x with:( fsq asArray ) ] )
	) asArray = #()
	) description:( '( #(  ) asGenerator lookAhead: 3 do:[ :x :fsq | Array with: x with:( fsq asArray ) ] )' ).

	self assert:( 
	( ( #( 1 2 3 ) asGenerator lookAhead: 3 do:[ :x :fsq | Array with: x with:( fsq asArray ) ] )
	) asArray = #(  (1 (2 3 nil))  (2 (3 nil nil))  (3 (nil nil nil)))
	) description:( '( #( 1 2 3 ) asGenerator lookAhead: 3 do:[ :x :fsq | Array with: x with:( fsq asArray ) ] )' ).

	self assert:( 
	( ( #( 1 2 3 4 5 6 ) asGenerator lookAhead: 3 do:[ :x :fsq | Array with: x with:( fsq asArray ) ] )
	) asArray = #( (1 (2 3 4))  (2 (3 4 5))  (3 (4 5 6))  (4 (5 6 nil))  (5 (6 nil nil))  (6 (nil nil nil)))
	) description:( '( #( 1 2 3 4 5 6 ) asGenerator lookAhead: 3 do:[ :x :fsq | Array with: x with:( fsq asArray ) ] )' ).

	self assert:(
	( ( #( 1 2 3 ) asGenerator lookAhead: 3 do:[ :x :fsq | Array with: x with:( fsq asGenerator asArray ) ] )
	) asArray = #(  (1 (2 3))  (2 (3))  (3 ())  )
	) description:( '( #( 1 2 3 ) asGenerator lookAhead: 3 do:[ :x :fsq | Array with: x with:( fsq asGenerator asArray ) ] )' ).

" )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"



! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:47'!
"(| defineMethod-:(" testmaximum "maximum "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20100213
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20100213 11:50 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#maximum s:self ).""
	
	^(	( self inject:( self first )into:[ :max :x | ( x <= max )ifTrue:[ max ]ifFalse:[ x ] ] )

	)""return:( 					MT e:#maximum s:self )

    )-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return the maximal element of self according to the <= method.
	
 )-summary
 methodDescriptionDetail-:(
	detail
 )-detail
 usage-:(
	usage
 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGLambdaLispEvalV6p1>>evalWithActivationRec:returningToContinuation:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( ( #(  ) asGenerator maximum ) = nil )
		) description:( '( ( #(  ) asGenerator maximum ) = nil )' ) ).

	( self assert:(
		( ( #( 1 ) asGenerator maximum ) = 1 )
		) description:( '( ( #( 1 ) asGenerator maximum ) = 1 )' ) ).

	( self assert:(
		( ( #( 2 1 ) asGenerator maximum ) = 2 )
		) description:( '( ( #( 2 1 ) asGenerator maximum ) = 2 )' ) ).

	( self assert:(
		( ( #( 1 3 2 ) asGenerator maximum ) = 3 )
		) description:( '( ( #( 1 3 2 ) asGenerator maximum ) = 3 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"



! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:48'!
"(| defineMethod-:(" testminimum "minimum "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20100213
	licensed as MIT Open Source: Please execute ( Object licensedMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20100213 11:56 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#minimum s:self ).""
	
	^(	( self inject:( self first )into:[ :min :x | ( min <= x )ifTrue:[ min ]ifFalse:[ x ] ] )

	)""return:( 					MT e:#minimum s:self )

    )-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return the minimal element of self according to the <= method.
	
 )-summary
 methodDescriptionDetail-:(
	detail
 )-detail
 usage-:(
	usage
 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGLambdaLispEvalV6p1>>evalWithActivationRec:returningToContinuation:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( ( #(  ) asGenerator minimum ) = nil )
		) description:( '( ( #(  ) asGenerator minimum ) = nil )' ) ).

	( self assert:(
		( ( #( 1 ) asGenerator minimum ) = 1 )
		) description:( '( ( #( 1 ) asGenerator minimum ) = 1 )' ) ).

	( self assert:(
		( ( #( 2 1 ) asGenerator minimum ) = 1 )
		) description:( '( ( #( 2 1 ) asGenerator minimum ) = 1 )' ) ).

	( self assert:(
		( ( #( 1 3 2 ) asGenerator minimum ) = 1 )
		) description:( '( ( #( 1 3 2 ) asGenerator minimum ) = 1 )' ) ).

	( self assert:(
		( ( #( 3 1 2 ) asGenerator minimum ) = 1 )
		) description:( '( ( #( 3 1 2 ) asGenerator minimum ) = 1 )' ) ).

	( self assert:(
		( ( #( 2 3 1 ) asGenerator minimum ) = 1 )
		) description:( '( ( #( 2 3 1 ) asGenerator minimum ) = 1 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"



! !

!KEGGeneratorTest methodsFor: 'generator' stamp: 'KjellGodo 4/21/2013 21:18'!
testnext "next "

        "Method Version: keg2.  "
        "Copyright Kjell E God April 13, 1999"
        "Date of Last Revision: Date today September 25 1999, April 13, 1999 "

	"Get the next element of the Read Only Stream self is on.
	In future one might comment out of the MT debugging stuff in this 
	often used method.
	KEG2: added the stop and the reuse stuff."

	"| answer |"
				"MT b:#next s:self .""

	stop ifTrue:[ ^nil ] . ""<---( This speeds up the case of FileStreams which have involved atEnd methods.  It speeds them up after we have reached the end of the file and there is nothing more to return. )"
	"answer :=" "
	^generator atEnd 
		ifTrue:[ stop := true .  reuse ifTrue:[ self class reuse: self ] . nil ]
		ifFalse:[ generator next ] . ""<------------------------( Read Only Stream Case )"

				"MT e:#next s:self ."
	"^answer ."

	( self assert:(
		#( 1 2 3 ) asGenerator ifNotNil:[ :g |
			( g reset ).	( g next = 1 )and:[
					( g next = 2 )and:[
					( g next = 3 )and:[
					( g next = nil )and:[
					( g next = nil )and:[ 
					( g next = nil ) ] ] ] ] ]
		] ) description:( 'g reset , g next = 1 , g next = 2 , g next = 3 , g next = nil ...' ) )


	! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:48'!
"(| defineMethod-:(" testnextC "next: anInteger "")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God Sep 29 1995
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20021010 , Sep 29 1995
	)-notes methodBody-:(
 (| let-:(""| gen selector cluster returnedCluster atEnd counter size collection blk
		writeSize writeStream count next collectionClass g nextWriteStream nextGen
		aFooArray |"")
    letBody-:(""					""( MT b:#next: s:self ).""
	#todoKEG. ""<---( not in the package scripts that we use isKindOf: here. )""

	^(
		""------------------------BlockClosure Case-------------------------------""
		( 
			( anInteger isKindOf: BlockClosure )or:[ ""<--------------------( KEG3 begin-: )( Testing methods for this Context case are at: << See HelpString AT-: 11 >> )""
			( anInteger respondsTo:( #value: ) ) ] ""<-----------------------( Now anInteger can be any monadicValuable but we still retain the isKindOf: check as an atomic ''method primative'' speed up.  Since >>isKindOf: is a fast primative and >>respondsTo: is not. )""
		)
			ifTrue:[ selector := anInteger .
				( cluster := OrderedCollection new ).
				( aFooArray := KEGFooArray new ). ""<---( the Generator nul element object which can exist in a Generator sequence.  nil is always the last element in every Generator.  Except that all Generators are infinite in length.  A lot of them have an infinity of nils in them.  nils are always trailing in Generators.  you can never have a non nil element of a Generator follow nil in a Generator.  nil is always the last element in all Generators.  And most Generators have an infinite number of nils following their nonNil elements. )""
				( self ""<-----------------------------------------( One might want to inline this >>first:next:last: message for speed at some point if needed.  IE: use a boat load of boolean flags and ifTrue:ifFalse: things instead. )""
					first:[ :x | ( returnedCluster := true ).( atEnd := false ).( x ) ] 
					next:( nil )""<----( Remember nil = [ :x | x ] )""
					last:[ :x | ( atEnd := true ).( x ) ]
				) collect:[ :x |
					( returnedCluster ifTrue:[ ( cluster removeAll ).( returnedCluster := false ) ] ).
					( atEnd
						ifTrue:[ ( cluster add:( x ) ).( cluster ) ]
						ifFalse:[
							( selector value:( x ) )
								ifTrue:[ ( cluster add:( x ) ).( aFooArray ) ]
								ifFalse:[ ( returnedCluster := true ).( cluster add:( x ) ).( cluster ) ] ] )
				 ]ignoring:( aFooArray ) ""<---( the KEGFooArray Class Object is the nul element in KEGGenerators since nil always terminates Generators and so can't be used as the nul element. ( where nul is ignored or used for some meta purpose ) So we use a specific instance of KEGFooArray as the ignore flag here.  Rather than doing the old practice of using KEGFooArray which was dual overlapping nondeterministic usage of the nul element and therefore not good. )""
				""<---( You might think you could use the method
				KEGGenerator>>bagSimilars:init: here to reduce
				self-:( this case ) down to a single line of code but you can't
				because the next x that causes selector Block to return false
				is included last in the present returned OC bag
				where as >>bagSimilars:init: does not include it.  The first x
				to cause the selector valuable to return false is left out of the
				present OC bag and it goes out as the first element of the next
				OC bag( or cluster ). ( OC = OrderedCollection )
				All of which are the same OC bag.
				( Here bag doesn't mean the Bag Class or any instances there of.
				They are all OrderedCollections. ) )"" ] ifFalse:[ ""<----------------------------------------------------( KEG3 :-end .  << See HelpString AT-: 12 >> )""
		""|||||||||||||||||||||||||||||||-BlockClosure Case-|||||||||||||||||||||||||||||||||||||||||""

		""------------------------IntervalGenerator Case-------------------------------""
		( anInteger isParam and:[ anInteger size = 1 ] )
			ifTrue:[
				counter := ( 1 to: anInteger p1 ) asGenerator .
				self abstractGenerator new
					resetBlock:[ self reset ]
					nextBlock:[ counter collect:[ :n | self next ] ] ]ifFalse:[
		""|||||||||||||||||||||||||||||||-IntervalGenerator Case-|||||||||||||||||||||||||||||||||||||||||""

		""--------------------Default+LowMemoryAllocation Case--------------------""
		(	(	""<--------------------------(  isInteger default case )""
				( ( writeSize := anInteger ) isInteger )
				and:[ ( collectionClass := Array ).( true ) ]				
			)or:[""<--------------------------( KEGParam-:( #writeStream <aCollectionClass> <anInteger> ) case )""
				( anInteger isParam )
				and:[
					( ( anInteger at:1 ) == #writeStream )
					and:[
						( collectionClass := anInteger p2 ).
						( writeSize := anInteger p3 ).( true )
					]
				]
			]
		)ifTrue:[
			( gen := KEGGenerator streamGenerator ).
			( nextGen := KEGGenerator streamGenerator ).
			( writeStream		:= ( collectionClass new:( writeSize ) ) writeStream ).
			( nextWriteStream	:= ( collectionClass new:( writeSize ) ) writeStream ).
			self abstractGenerator new
				resetBlock:[ ( self reset ) ]
				nextBlock:[
					( g := writeStream ).( writeStream := nextWriteStream ).( writeStream := g ). ""<---( Switch the writeStreams . This is done because some KEGGenerator methods like KEGGenerator>>lookAhead1: need to have two elements of its underlying Generator on hand at a time so we provide two return sequences here writeStream and nextWriteStream and keep switching them for each iteration of the self>>next message.  Most KEGGenerator ''converting'' messages only need at most 2 elements of the underlying sequence so I hope I can get away with just using two here.   alternate code-:( 		( writeStream := ( nextWriteStream doYourself:[ nextWriteStream := gen ] ) )		) which is perhaps more elegant but is slower so we don't use it here. )""
					( g := gen ).( gen := nextGen ).( nextGen := g ). ""<-------------------------------------( same with the gens. )""
					( writeStream initialize ).( count := 0 ).
					( [
						( ( count := count + 1 ) <= anInteger ) 	and:[
						( next := self next ) notNil			]
					]whileTrue:[ writeStream nextPut:( next ) ] ).
					(( writeStream contentsKEG asStreamGeneratorOn: gen ) ""<---( The new >>contentsKEG message should somewhat revolutionize the persuit of less Generator memory allocations.  And one has to ask oneself why it was not thought of sooner.  Oh well.  Like about 10 years sooner.  Oh well.  I guess these things just happen.  And happen.  And happen. )""
						ifEmpty:[ :e |   ] )
				] ]ifFalse:[
		""|||||||||||||||||||||||||-Default+LowMemoryAllocation Case-||||||||||||||||||||||||||""

		""------------------------asArrayGenerator: Case-------------------------------""
		( anInteger isParam and:[ anInteger size = 3 ] )
			ifTrue:[
				gen := ( collection := ( anInteger p1 ; p2 ) new:( size := anInteger p3 ) ) asGenerator .
				self abstractGenerator new
					resetBlock:[ self reset ]
					nextBlock:[ 1 to: size do:[ :i | collection at: i put: self next ] .
						collection asArrayGenerator: gen ] ]ifFalse:[
		""|||||||||||||||||||||||||||||||-asArrayGenerator: Case-|||||||||||||||||||||||||||||||||||||||||""

		""------------------------2 Misc Cases-------------------------------""
		( anInteger isParam and:[ anInteger size = 2 ] )
			ifTrue:[
				( ( anInteger at:2 ) isKindOf: BlockClosure )
					ifTrue:[ gen := anInteger p1 . blk := anInteger p2 . ""<-------------------------( cluster above is returned by the returned Generator r over and over again but with mostly different elements each time.  This means that a new cluster does not need to be allocated for each >>next iteration of r.  The same cluster OC is reused over and over again for that job. )""
						gen isOnAStream ifFalse:[ gen := KEGGenerator streamGenerator ] . ""<---( gen must be on a Stream for the reuse of cluster above to work. )""
						( self next: blk )
							first:[ :oc | oc asStreamGeneratorOn: gen ] ""<------------------------( We set the reused cluster( oc here ) from above into gen so the returned Generator r can return gen over and over on cluster rather than returning cluster over and over.  r becomes a sequence of gen rather than a sequence of cluster.  Where gen is a wrapper around cluster.  So the same gen is returned over and over but with different contents.  Thus memory allocations are minimized. )""
							next:[ :oc | gen generator initialize . gen ]] ""<-------------------------( Each time cluster gets new contents we must reinitialize the stream in gen to fit the new size of cluster. )""
					ifFalse:[ 
						collection := anInteger p1 new:( size := anInteger p2 ). ""<---( p1 and p2 used to be removeFirst.  This change hasn't been tested. )""
						self abstractGenerator new
							resetBlock:[ self reset ]
							nextBlock:[ 1 to: size do:[ :i | collection at: i put: self next ] .
								collection ifEmpty: nil ] ] ]  ""<-----------------( nil = [ :e |  e  ] )""
		""|||||||||||||||||||||||||||||||-2 Misc Cases-|||||||||||||||||||||||||||||||||||||||||""
		] ] ] ]

	)""return:( 					MT e:#next: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	The main idea is-:
	Let self = < s1 s2 s3 ... sN sa1 sa2 sa3 ... s2N sb1 sb2 sb3 ... s3N ... >
	where sN = s( N ) , sa2 = s( a2 ) , s3N = s( 3N ) , etc where N and a2 and
	3N are positive Integers etc, in the standard Integer order and where
	3N = 3*N .
	THEN-: ( self next: N ) = r where
	r = < 	<s1 s2 s3 ... sN>
			<sa1 sa2 sa3 ... s2N>
			<sb1 sb2 sb3 ... s3N>
			. . .
			. . .
			. . .
			<sz1 sz2 sz3 ... szM> > .
	In other words a sequence is returned that contains the contiguous
	subsequences of size N in the standard Integer order.  And where
	M <= N 
 )-summary
 methodDescriptionDetail-:(
	( It should be 
	noted that the <s1 s2 s3 ... sN>
			<sa1 sa2 sa3 ... s2N>
			<sb1 sb2 sb3 ... s3N>
	etc in this sequence may be implemented as seperate sequence Objects
	like KEGGenerators etc or they may be implemented as a single or
	pair of sequence Objects which are refilled with different elements each
	time.  So you have to check here or in the code above or make a test case
	to make sure which kind you are dealing with.  And if a few sequence
	Objects are being reused over and over then if you want to get individual
	unique copies of the sequence objects for some reason like if you want to
	instantiate an OrderedCollection of them via the
	self>>asOrderedCollection message then you have to do it like-:(
		( ( self next: ??? ) collect:[ :seq | seq copy ] )
		if each seq is something like a Collection or
		( ( self next:( 20 ) ) collect:[ :seq | seq generator contents ] )
		where each seq is a single Stream based KEGGenerator and you really
		want a sequence of unique Collections instead.
		( ( self next:( 20 ) )asOrderedCollection )
		will return an OrderedCollection filled with one single
		Stream based KEGGenerator which has as its contents the very last
		subSequence in the 
		r = < 	<s1 s2 s3 ... sN>
				<sa1 sa2 sa3 ... s2N>
				<sb1 sb2 sb3 ... s3N>
				. . .
				. . .
				. . . 
				<sz1 sz2 sz3 ... szM> > main sequence.
		In other words you will get-:(
			OrderedCollection(
			 	Array1( sz1 sz2 sz3 ... szM )
			 	Array2( sz12 sz22 sz32 ... szM2 )
			 	Array1( sz1 sz2 sz3 ... szM )
			 	Array2( sz12 sz22 sz32 ... szM2 )
			 	Array1( sz1 sz2 sz3 ... szM )
			 	Array2( sz12 sz22 sz32 ... szM2 )
			 	Array1( sz1 sz2 sz3 ... szMY )
				. . .
				. . .
				. . . 
			 	ArrayY( sz1 sz2 sz3 ... szMY ) )
		)-youwillget
		But-:(
			( ( self next: 20 ) collect:[ :seq | seq generator contents ] )
		)will return-:(
			OrderedCollection(
			 	Array1( s1 s2 s3 ... sN )
			 	Array2( sa1 sa2 sa3 ... s2N )
			 	Array3( sb1 sb2 sb3 ... s3N )
				. . .
				. . .
				. . . 
			 	ArrayZ( sz1 sz2 sz3 ... szM ) )
		)-willreturn
		where Z is some positive Integer.  ( and M is some positive Integer )
		( remembering that all these sequences and or main sequences can
		be empty ie: < > OrderedCollection(  ) Array(  ) . )
		And where Y is either 1 or 2.  IE: ArrayY is either Array1 or Array2
		where Array1 is an Array and Array2 is a different Array and Array3
		is yet a third Array.  But Array1 is the same as Array1 everywhere it
		apears.  It is one single unique Array that is in the sequence over and
		over again but with different contents each time.  IE: the underlying
		KEGGenerator>>next message returns Array1 or Array2 over and
		over again but with different contents.  But when you try to do the
		asOrderedCollection you are sticking these two Arrays over and over
		into the returned OrderedCollection but with different contents.
		So all the slots in the OrderedCollection will point to one or the other
		of the two Arrays and the two Arrays will have the last contents that
		they received.
		You have to keep this sort of thing in mind when dealing with
		KEGGenerators.  Most of the time you don't have to think about it.
		But you may come up against some really squirrelly problems that
		just look like they defy any and all forms logic.  And in that case
		you should look to see if you have the problem of reused sub
		sequence Objects or reused iteration return Objects.  In which case
		you will solve your problem by using a collect:[ :x | x copy ] type
		fix of some kind.  As shown above.
	)-like )-itshouldbenoted

	See the main comment at << See HelpString AT-: 10 >> <---( As of 
	<D:20021010> the HelpString AT-: functionality is no longer accessible.
	Not since the ole PCKJPen/166 broke down and the Dolphin stuff had to be
	moved to the PCKJDuron/750 and that old HelpString stuff was never fixed.
	yet. )
	( This method best viewed with the word wrap off to see the code and on
	to see the comments.  You can turn the word wrap on and off using the KEG
	RightClick=> Manipulate...=> ''Toggle The Word Wrap'' command. )




 )-detail
 usage-:(
	
	The following is a list of the different usage cases as labelled above in the
	code( some are not commented yet )-:





	( BlockClosure Case )-:( 
		( self next: N ) = r where
		r = < 	<s1 s2 s3 ... sN1>
				<sa1 sa2 sa3 ... s2N2>
				<sb1 sb2 sb3 ... s3N3>
				. . .
				. . .
				. . .
				<sz1 sz2 sz3 ... szNM> > .
		Where N1 , N2 , N3 , NM = N( M ) are all positive Integers
			( or zero in the case any of the subsequences is empty )
		and sN1 = s( N1 ) , sN2 = s( N2 ) , sN3 = s( N3 ) , ... etc
		and
			( selector value:( sN1 ) ) = false
			( selector value:( s2N2 ) ) = false
			( selector value:( s3N3 ) ) = false
			. . .
			. . .
			. . .
			( selector value:( szNM ) ) = false
		but ( selector value:( s( i ) ) = true for all the other values of i .
		This is the main case that is the most used.  It is often used to
		find text sections in a String text that has been broken up into
		a sequence of lines of text ( Strings of text ).  You can do
		things like-:(
			( ( aTextString linesStrGen )
				next:[ :ln | ( 'sectionEnd' containedIn: ln ) not ]
			)
		)-thingslike    which will return a sequence T of ( sequences S )
		where each sequence S is a sequence of all the lines of
		text starting from the beginning of the text and including
		all the lines down to and including the first line ln that makes the 
			next:[ :ln | ( 'sectionEnd' containedIn: ln ) not ]
		Block return false.  The next sub sequence S in the
		main sequence T will be all
		the lines down to the next line ln that has the subString
		'sectionEnd' in it.  Where 'sectionEnd' is supposed to represent
		some arbitrary text that is not present in the body of each
		section but is present in the last line of each text section.
		So this kind of thing seems to be used over and over again to
		pick out different repeated sections of text.  And then those
		sections can be broken up into subsections also using the
		>>next: message.
		Some text section text structures are too difficult to find using the
		>>next: message.  So instead you can try a simple mirror like
		KEGGenerator>>sortInto: finite state machine that uses
		states that are mirror images of each other as shown in the
		comments of the >>sortInto: method.  And there are other
		more experimental ways that have been proposed and coded
		up but not debugged.  A new version of sortInto: that is more
		flexible and functional.  And various simple minimal
		recursive decent parser ideas including the newest one in
		the KEGPicoLARCParser Class that is an example of such 
		backtracking recursive decent parsers that can be made by making
		new subClasses of the KEGBackTrackingRecursiveDecentParser
		Class.  Such parsers can be used to parse natural languages and
		such like junk.  And to make simple minimal quickly coded up
		and easily modified little parsers.  Where the parser code itself is
		also easily modified since it is only about 20 lines long.
		As of <D:20021010> the anInteger parameter can be any
		monadicValuable.  ie: anything that responds to the >>value:
		message.
	 )-case






	( IntervalGenerator Case )-:( 
	 )






	( Default+LowMemoryAllocation Case )-:( 
		(  isInteger default case )-:( 
			This is the default case described above. examples-:( 
				( aGenerator next:( 20 ) )
				or
				( 1 halt ).
				(( 	(	(	( Clipboard current getText asStringGenerator 
								subStringsWithBlanks 
							)next:( 20 )
						) collect:[ :gen | gen generator contents ]
					) withCrLfs
				) inlineEmbeddedSequences asString edit )
				which works right because the >>contents message makes
				copies of the reused stream collection Array.
				or( 1 )-:
				( 1 halt ).
				(( 	(	( Clipboard current getText asStringGenerator 
							subStringsWithBlanks 
						)next:( 20 )
					) withCrLfs
				) inlineEmbeddedSequences asString edit )
				which doesn't work for some reason even with the double
				writeStream and gen just added to self-:( this case ) above
				today <D:20021010> .
				( [_]:[]:WK SMALLTALK-: Dolphin Smalltalk-: 
					Figure out why the test case at =>or( 1 )-:<=
					in KEGGenerator>>next: still doesn't work even though
					there are double gen and writeStreams being used . )
			)-examples
		)
		. . . . . . . . . . . . . . . .
		( KEGParam-:( #writeStream <aCollectionClass> <anInteger> ) case )-:(
			This case is just like the isInteger default case above except that it
			allows you to choose the CollectionClass that you want to use to
			return the individual subSequences.
			The default is to use Array.  But you might well want to use String
			if self is a sequence of Characters.  example-:(
				( r := aString asCharacter next:( 
					P p1:( #writeStream )p2:( String )p3:( 20 )
				))
				which would return a sequence of KEGGenerators
				on a pair of Streams
				on a pair of Strings
				that keep getting returned over and over alternately
				by the ( r next ) expression.  Where r is how I refer to the
				sequence returned by the example here above.  But don't get
				confused by this ''pair of'' business. It is just an implementation
				issue that is supposed to help minimize the amount of memory
				that a Generator needs to allocate during each iteration of
				the >>next message.  Always a goal as far as KEGGenerators
				are concerned.  For the last 10 years.  It is hoped that the
				new WriteStream>>contentsKEG will somewhat revolutionize
				that old effort.  It's a very small method >>contentsKEG is
				but with some wide ranging implications for the reduction of
				memory allocations in KEGGenerators.
			)-example where P is the Abreviation for KEGParam which you
			get access to by including the Abreviations Dictionary as a pool
			Dictionary in your Class definition example-:(
				See the Class definition of the KEGGenerator Class.
			)
		 )
	 )





	( asArrayGenerator: Case )-:( 
	 )





	( 2 Misc Cases )-:( 
	 )

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(

	(| KEG3-:( Changes onDate-:( ... ) madeChanges-:( ... ) )-chg )-keg3
	(| KEG2-:( Changes onDate-:( 20021010 ) madeChanges-:( Converted over to
		the PicoLARC style of Smalltalk which is easy to translate into PicoLARC.
		And is more organized and readable to my mind.  As can be proven
		( 
		ie: ''proven''=''can be argued'' and has nothing to do with the antique
		notion of absolute truth held by many nonMathematitians as supposedly
		seperate from blind faith.  blind faith that 3 or 3 billion successful cases
		constitutes an absolute ''proof''.
		)
		scientifically as the eye likes to follow circular patterns like parenthesis
		if they can be organized in such a ( way ) as to be destingt and easily
		seperated.  Also added all new comments and added the nextGen and
		nextWriteStream and added comments and cleaned up the
		BlockClosure Case and converted it too over to the PicoLARC style of
		Smalltalk.  And added to the isKindOf: BlockClosure by adding
		>>respondsTo: #value: )-madeC )-chg )-keg2

	(| COMMENT-: I believe that there are more changes that were lost in the
		conversion from Smalltalk/V 2.0 to Dolphin.  The comments of the
		changes were lost.  But not the changes themselves.  The KEG3 markers
		above indicate that there were at least 3 changes done prior to
		the KEG2 change noted here in self-:( this changes section ). )-comment
 )-changes
 testCases-:( "

	( self assert:(
		( #(  ) asGenerator next: 3 ) asArray = #(  )
		) description:( '( #(  ) asGenerator next: 3 ) asArray = #(  )' ) ).

	( self assert:(
		( ( ( #( 1 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 ) )
		) description:( '( ( ( #( 1 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 ) )
		) description:( '( ( ( #( 1 2 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 3 ) )
		) description:( '( ( ( #( 1 2 3 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 3 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 4 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 3 )( 4 ) )
		) description:( '( ( ( #( 1 2 3 4 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 3 )( 4 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 4 5 6 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 ) )
		) description:( '( ( ( #( 1 2 3 4 5 6 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) )
		) description:( '( ( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 4 5 6 7 8 9 10 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 ) )
		) description:( '( ( ( #( 1 2 3 4 5 6 7 8 9 10 ) asGenerator next: 3 ) collect:[ :g | g asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 ) )' ) ).

	( self assert:(
		( #(  ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) asArray = #(  )' ) ).

	( self assert:(
		( ( ( #( 1 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 ) )
		) description:( '( ( ( #( 1 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 ) )
		) description:( '( ( ( #( 1 2 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 3 ) )
		) description:( '( ( ( #( 1 2 3 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 3 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 4 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 3 )( 4 ) )
		) description:( '( ( ( #( 1 2 3 4 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 3 )( 4 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 4 5 6 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 ) )
		) description:( '( ( ( #( 1 2 3 4 5 6 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) )
		) description:( '( ( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 4 5 6 7 8 9 10 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 ) )
		) description:( '( ( ( #( 1 2 3 4 5 6 7 8 9 10 ) asGenerator next:[ :i | i \\ 3 ~= 0 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 ) )' ) ).

	"There are other cases of inputs you can input into the >>next: method which are documented above in the source code but I don't remember
	using them.  Each one should have been tested on some test data but that was before i was using test driven development.  I have done
	here the two main cases and so I am moving on.  A reused KEGGenerator  g is returned by each >>next message where g has different
	contents each time and that is why we have to keep copying g using g asArray when we are trying to make the larger array or results. Also
	oc is a reused OrderedCollection which we copy using oc asArray.

 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCollecting' stamp: 'KjellGodo 4/25/2013 17:48'!
"(| defineMethod-:(" testnextClastC "next: nextBlock last: lastBlk "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030205
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030205
	)-notes methodBody-:(
 (| let-:(""| next checkForLast return nextBlk |"")
    letBody-:("					"( MT b:#next:last: s:self ).""
	^(
		( self abstractGenerator new
		) resetBlock:[ 
			( next := self first ).( checkForLast := self next ).(nextBlk := nextBlock) ]
		  nextBlock:[ 
			( checkForLast ifNil:[ nextBlk := lastBlk ] ).
			( next ifNotNil:[
				( return := nextBlk value:( next ) ).
				( next := checkForLast ).
				( checkForLast := self next ).
				( return )
			] )
		  ]
		

	)""return:( 					MT e:#next:last: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	See KEGGenerator>>first:next: and KEGGenerator>>first:next:last: for
	related comments.  self-:( this method ) works just like those.

 )-summary
 methodDescriptionDetail-:(

	But self This Method is perhaps a better implementation.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	
	( [_]:[]:WK SMALLTALK-: Dolphin Smalltalk-: 
		Rework KEGGenerator>>first:next: and KEGGenerator>>first:next:last:
		more in the style of KEGGenerator>>next:last: and perhaps remake
		>>first:next:last: using the same style of >>next:last: so that perhaps
		one could think about doing first:next: and next:last: in terms of first:next:last:
		just by setting one or the other of the blocks to the empty Block nil -trd . )

 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( ( #(  )asGenerator ) next:[ :x | x + 1 ]last:[ :x | x + 1000 ] ) asArray =#(  )
		) description:( '( ( #(  )asGenerator ) next:[ :x | x + 1 ]last:[ :x | x + 1000 ] ) asArray =#(  )' ) ).

	( self assert:(
		( ( #( 0 )asGenerator ) next:[ :x | x + 1 ]last:[ :x | x + 1000 ] ) asArray =#( 1000 )
		) description:( '( ( #( 0 )asGenerator ) next:[ :x | x + 1 ]last:[ :x | x + 1000 ] ) asArray =#( 1000 )' ) ).

	( self assert:(
		( ( #( 0 2 )asGenerator ) next:[ :x | x + 1 ]last:[ :x | x + 1000 ] ) asArray =#( 1 1002 )
		) description:( '( ( #( 0 2 )asGenerator ) next:[ :x | x + 1 ]last:[ :x | x + 1000 ] ) asArray =#( 1 1002 )' ) ).

	( self assert:(
		( ( #( 0 1 2 3 5 )asGenerator ) next:[ :x | x + 1 ]last:[ :x | x + 1000 ]	) asArray =#( 1 2 3 4 1005 )
		) description:( '( ( #( 0 1 2 3 5 )asGenerator ) next:[ :x | x + 1 ]last:[ :x | x + 1000 ]	) asArray =#( 1 2 3 4 1005 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorEvaluation' stamp: 'KjellGodo 4/23/2013 19:21'!
testnoReset "noReset"

	"Method Version: keg1.  "
	"Copyright Kjell E God May 14, 1993"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today May 14, 1993"
						"( MT b:#noReset s:self ).""
	^(
		self abstractGenerator new
			resetBlock:[ self ]
			nextBlock:[ self next ]

	)""return:(				MT e:#noReset s:self )"

	"Return a Generator r which is exactly like self except that it can't be reset back to its beginning.
	When the returned Generator is reset it does nothing but it returns self.   Self could then be reset 
	if one desired and this would cause the return generator r to also be reset.  This function is useful
	when you want to do operations like do: to a generator but you do not want the generator to be
	reset at the beginning of the do: .  This can be useful in cases where a Stream is being Generated
	starting from somewhere in the middle."

	( self assert:(
		#(  ) asGenerator noReset ifNotNil:[ :g | g next = nil ]
		) description:( '#(  ) asGenerator noReset ifNotNil:[ :g | g next = nil ]' ) ).

	( self assert:(
		#( 1 ) asGenerator noReset ifNotNil:[ :g | ( g next = 1 )and:[ g next = nil ] ]
		) description:( '#( 1 ) asGenerator noReset ifNotNil:[ :g | ( g next = 1 )and:[ g next = nil ] ]' ) ).

	( self assert:(
	 	#( 1 2 ) asGenerator noReset ifNotNil:[ :g | ( g next = 1 )and:[ ( ( g reset ; next ) = 2 )and:[ g next = nil ] ] ]
		) description:( '#( 1 2 ) asGenerator noReset ifNotNil:[ :g | ( g next = 1 )and:[ ( g reset ; next = 2 )and:[ g next = nil ] ] ]' ) ).

! !

!KEGGeneratorTest methodsFor: 'accessing' stamp: 'KjellGodo 5/11/2013 12:41'!
"(| defineMethod-:(" testnowNextCintoC "nowNext: anInteger into: aStream "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130511 yyyymmdd
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130511 9:08 )
	)-notes methodBody-:(
 (| let-:(""| count |"")
    letBody-:("					"( MT b:#nowNext:into: s:self ).""
	( count := anInteger + 1 ).
	( [ 0 < ( count := count - 1 ) ]whileTrue:[ aStream nextPut:( self next ) ] ).
	^(
		( aStream )

	)""return:( 					MT e:#nowNext:into: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	>>nextPut: anInteger number of the next elements of self onto
	the end of aStream.  We don't look for the end of self to keep
	the nils from being put onto the end of aStream.

 )-summary
 methodDescriptionDetail-:(

	self This Method can be useful for looking ahead in a KEGGenerator
	Like in the case of >>disperse: . See below for examples.
	Also see the >>lookAhead1: and >>lookAhead:do: Methods for looking ahead.
	If you want to look ahead without moving the KEGGenerator ahead then you
	can look into using a KEGSimpleCanBackup or KEGPositionableGeneratorV1.
	Also since KEGGenerators respond to >>doesNotUnderstand: you can sometimes
	reposition a KEGGenerator using the Stream >>position: Message if it is on a Stream.
	( aReadWriteStream reset ; truncated ) can be useful in Dolphin Smalltalk.
	( aReadWriteStream reset ) works in Pharo Smalltalk I think.
	And also ( aWriteStream contentsKEG ) for avoiding new memory allocations.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	| a |

	( self assert:(
		( #(  ) asGenerator nowNext: 2 into:( Array new writeStream ) ) contents = #( nil nil )
		) description:( '( #(  ) asGenerator nowNext: 2 into:( Array new writeStream ) ) contents = #( nil nil )' ) ).

	( self assert:(
		( #( 1 ) asGenerator nowNext: 2 into:( Array new writeStream ) ) contents = #( 1 nil )
		) description:( '( #( 1 ) asGenerator nowNext: 2 into:( Array new writeStream ) ) contents = #( 1 nil )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator nowNext: 2 into:( Array new writeStream ) ) contents = #( 1 2 )
		) description:( '( #( 1 2 ) asGenerator nowNext: 2 into:( Array new writeStream ) ) contents = #( 1 2 )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator nowNext: 2 into:( ( a := Array new:2 ) writeStream ) ) contentsKEG ifNotNil:[ :x | ( x = #( 1 2 ) )and:[ x == a ] ]
		) description:( '( #( 1 2 ) asGenerator nowNext: 2 into:( ( a := Array new:2 ) writeStream ) ) contentsKEG ifNotNil:[ :x | ( x = #( 1 2 ) )and:[ x == a ] ]' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator nowNext: 2 into:( Array new writeStream ) ) contents = #( 1 2 )
		) description:( '( #( 1 2 3 ) asGenerator nowNext: 2 into:( Array new writeStream ) ) contents = #( 1 2 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'accessing' stamp: 'KjellGodo 5/11/2013 12:41'!
"(| defineMethod-:(" testnowNextUntilCintoC "nowNextUntil: monadicValuable into: aStream "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130511 yyyymmdd
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130511 9:32 )
	)-notes methodBody-:(
 (| let-:(""| next |"")
    letBody-:("					"( MT b:#nowNextUntil:into: s:self ).""
	( [ ( next := self next )notNil and:[ ( monadicValuable value:( next ) ) not ] ]whileTrue:[ aStream nextPut:( next ) ] ).
	^(
		( aStream )

	)""return:( 					MT e:#nowNextUntil:into: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	>>nextPut: the next elements of self onto the end of aStream unril
	monadicValuable returns true.  monadicValuable is anything that
	responds to >>value: .  We do look for the end of self to keep
	the nils from being put onto the end of aStream.  We discard the
	element of self that caused monadicValuable to return true.

 )-summary
 methodDescriptionDetail-:(

	self This Method can be useful for looking ahead in a KEGGenerator
	Like in the case of >>disperse: . See below for examples.
	Also see the >>lookAhead1: and >>lookAhead:do: Methods for looking ahead.
	If you want to look ahead without moving the KEGGenerator ahead then you
	can look into using a KEGSimpleCanBackup or KEGPositionableGeneratorV1.
	Also since KEGGenerators respond to >>doesNotUnderstand: you can sometimes
	reposition a KEGGenerator using the Stream >>position: Message if it is on a Stream.
	( aReadWriteStream reset ; truncated ) can be useful in Dolphin Smalltalk.
	( aReadWriteStream reset ) works in Pharo Smalltalk I think.
	And also ( aWriteStream contentsKEG ) for avoiding new memory allocations.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:( 
		( #(  ) asGenerator nowNextUntil:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #(  )
		) description:( '( #(  ) asGenerator nowNextUntil:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #(  )' ) ).

	( self assert:( 
		( #( 1 ) asGenerator nowNextUntil:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 )
		) description:( '( #( 1 ) asGenerator nowNextUntil:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 )' ) ).

	( self assert:( 
		( #( 1 2 ) asGenerator nowNextUntil:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 2 )
		) description:( '( #( 1 2 ) asGenerator nowNextUntil:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 2 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator nowNextUntil:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 2 )
		) description:( '( #( 1 2 3 ) asGenerator nowNextUntil:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 2 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'accessing' stamp: 'KjellGodo 5/11/2013 12:41'!
"(| defineMethod-:(" testnowNextUntilV1CintoC "nowNextUntilV1: monadicValuable into: aStream "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130511 yyyymmdd
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130511 10:02 )
	)-notes methodBody-:(
 (| let-:(""| next |"")
    letBody-:("					"( MT b:#nowNextUntilV1:into: s:self ).""
	( [ ( next := self next )notNil and:[ ( monadicValuable value:( next ) ) not ] ]whileTrue:[ aStream nextPut:( next ) ] ).
	( next notNil ifTrue:[ aStream nextPut: next ] ).
	^(
		( aStream )

	)""return:( 					MT e:#nowNextUntilV1:into: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	>>nextPut: the next elements of self onto the end of aStream unril
	monadicValuable returns true.  monadicValuable is anything that
	responds to >>value: .  We do look for the end of self to keep
	the nils from being put onto the end of aStream.  We don't discard the
	element of self that caused monadicValuable to return true.

 )-summary
 methodDescriptionDetail-:(

	self This Method can be useful for looking ahead in a KEGGenerator
	Like in the case of >>disperse: . See below for examples.
	Also see the >>lookAhead1: and >>lookAhead:do: Methods for looking ahead.
	If you want to look ahead without moving the KEGGenerator ahead then you
	can look into using a KEGSimpleCanBackup or KEGPositionableGeneratorV1.
	Also since KEGGenerators respond to >>doesNotUnderstand: you can sometimes
	reposition a KEGGenerator using the Stream >>position: Message if it is on a Stream.
	( aReadWriteStream reset ; truncated ) can be useful in Dolphin Smalltalk.
	( aReadWriteStream reset ) works in Pharo Smalltalk I think.
	And also ( aWriteStream contentsKEG ) for avoiding new memory allocations.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:( 
		( #(  ) asGenerator nowNextUntilV1:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #(  )
		) description:( '( #(  ) asGenerator nowNextUntilV1:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #(  )' ) ).

	( self assert:( 
		( #( 1 ) asGenerator nowNextUntilV1:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 )
		) description:( '( #( 1 ) asGenerator nowNextUntilV1:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 )' ) ).

	( self assert:( 
		( #( 1 2 ) asGenerator nowNextUntilV1:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 2 )
		) description:( '( #( 1 2 ) asGenerator nowNextUntilV1:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 2 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator nowNextUntilV1:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 2 3 )
		) description:( '( #( 1 2 3 ) asGenerator nowNextUntilV1:[ :x | x = 3 ] into:( Array new writeStream ) ) contents = #( 1 2 3 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'accessing' stamp: 'KjellGodo 5/11/2013 12:40'!
"(| defineMethod-:(" testnowNextV1CintoC "nowNextV1: anInteger into: aStream "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130511 yyyymmdd
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130511 9:32 )
	)-notes methodBody-:(
 (| let-:(""| count |"")
    letBody-:("					"( MT b:#nowNextV1:into: s:self ).""
	( count := anInteger + 1 ).
	( [ 0 < ( count := count - 1 ) ]whileTrue:[ aStream nextPut:( self next ifNil:[ ^( aStream )""return:( MT e:#nowNext1:into: s:self )"" ] ) ] ).
	^(
		( aStream )

	)""return:( 					MT e:#nowNextV1:into: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	>>nextPut: anInteger number of the next elements of self onto
	the end of aStream.  We do look for the end of self to keep
	the nils from being put onto the end of aStream.

 )-summary
 methodDescriptionDetail-:(

	self This Method can be useful for looking ahead in a KEGGenerator
	Like in the case of >>disperse: . See below for examples.
	Also see the >>lookAhead1: and >>lookAhead:do: Methods for looking ahead.
	If you want to look ahead without moving the KEGGenerator ahead then you
	can look into using a KEGSimpleCanBackup or KEGPositionableGeneratorV1.
	Also since KEGGenerators respond to >>doesNotUnderstand: you can sometimes
	reposition a KEGGenerator using the Stream >>position: Message if it is on a Stream.
	( aReadWriteStream reset ; truncated ) can be useful in Dolphin Smalltalk.
	( aReadWriteStream reset ) works in Pharo Smalltalk I think.
	And also ( aWriteStream contentsKEG ) for avoiding new memory allocations.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( #(  ) asGenerator nowNextV1: 2 into:( Array new writeStream ) ) contents = #(  )
		) description:( '( #(  ) asGenerator nowNextV1: 2 into:( Array new writeStream ) ) contents = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator nowNextV1: 2 into:( Array new writeStream ) ) contents = #( 1 )
		) description:( '( #( 1 ) asGenerator nowNextV1: 2 into:( Array new writeStream ) ) contents = #( 1 )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator nowNextV1: 2 into:( Array new writeStream ) ) contents = #( 1 2 )
		) description:( '( #( 1 2 ) asGenerator nowNextV1: 2 into:( Array new writeStream ) ) contents = #( 1 2 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator nowNextV1: 2 into:( Array new writeStream ) ) contents = #( 1 2 )
		) description:( '( #( 1 2 3 ) asGenerator nowNextV1: 2 into:( Array new writeStream ) ) contents = #( 1 2 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'accessing' stamp: 'KjellGodo 4/25/2013 17:48'!
testonC "on: aCollection"

        "Method Version: keg1.  "
        "Copyright Kjell E God Date today"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today "

	"Insert a new Collection into the Stream self is on."

				"MT b:#on: s:self .""

	generator collection: aCollection ; initialize .

				""MT e:#on: s:self ."
	"^self ."


	( KEGGenerator streamGenerator on:#( 1 2 3 ) ) asArray = #( 1 2 3 )

! !

!KEGGeneratorTest methodsFor: 'generatorCollecting' stamp: 'KjellGodo 4/23/2013 19:24'!
testpairUpAllNeighborsC "pairUpAllNeighbors: pairingBlock"

	"Method Version: keg1.  "
	" Copyright Kjell E God 04-22-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today 04-22-92""
	| answer last next |
						""MT b: #pairUpAllNeighbors:  s: self .""

	 answer := self abstractGenerator new
		resetBlock:[ next := self first  ]
		nextBlock:[  last := next .   next := self next .
			(( last notNil ) and:[ next notNil ])
			   ifTrue:[ pairingBlock value: last value: next ]
			   ifFalse:[ nil ]
		] .
						""MT e: #pairUpAllNeighbors:  s: self .""
	 ^answer .

	""Return a generator which has as its elements the following:

	Let s be self.   Then s = <s1, s2, s3, s4, s5, s6 ...>
	where <s1, s2, s3, s4, s5, s6 ... sN > is the sequence
	of elements in s.
	Let g be the returned generator.
	Let p(x,y) be the results of executing the pairingBock
	on x and y.   (pairingBlock is a two parameter block)
	Then g = < p(s1,s2), p(s2,s3), p(s3,s4), p(s4,s5), ... p(sN-1, sN)>"

	( self assert:(
		( #(  ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #(  )
		) description:( '( #( 1 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 ) )
		) description:( '( #( 1 2 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 ) )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 2 3 ) )
		) description:( '( #( 1 2 3 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 2 3 ) )' ) ).

	( self assert:(
		( #( 1 2 3 4 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 2 3 )( 3 4 ) )
		) description:( '( #( 1 2 3 4 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 2 3 )( 3 4 ) )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 2 3 )( 3 4 )( 4 5 ) )
		) description:( '( #( 1 2 3 4 5 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 2 3 )( 3 4 )( 4 5 ) )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 6 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 2 3 )( 3 4 )( 4 5 )( 5 6 ) )
		) description:( '( #( 1 2 3 4 5 6 ) asGenerator pairUpAllNeighbors:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 2 3 )( 3 4 )( 4 5 )( 5 6 ) )' ) ).


! !

!KEGGeneratorTest methodsFor: 'generatorCollecting' stamp: 'KjellGodo 4/23/2013 19:24'!
testpairUpC "pairUp: pairingBlock"

        "Method Version: keg1.  "
	" Copyright Kjell E God 04-22-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today 04-22-92""
     | answer |
                                    ""MT b: #pairUp:  s: self .""

       answer := self dot: pairingBlock with: self .

                                    ""MT e: #pairUp:  s: self .""
     ^answer .

        ""Return a generator r which has as its elements the
               following:
                    Let s be self.   Then s = <s1, s2, s3, s4, s5, s6 ...>
                         where <s1, s2, s3, s4, s5, s6 ...> is the sequence
                         of elements.
                    Let p(x,y) be the results of executing the two parameter pairingBock
                         on x and y.
                    Then r = < p(s1,s2), p(s3,s4), p(s5,s6), p(s7,s8), ... , p(s2N-1,s2N)>
                          where N is some Positive Integer.  And all si in r are nonNil.  Thus if s has an odd number of elements then the last one will not be paired with anything it will just be discarded."

	( self assert:(
		( #(  ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #(  )
		) description:( '( #( 1 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 ) )
		) description:( '( #( 1 2 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 ) )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 ) )
		) description:( '( #( 1 2 3 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 ) )' ) ).

	( self assert:(
		( #( 1 2 3 4 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 3 4 ) )
		) description:( '( #( 1 2 3 4 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 3 4 ) )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 3 4 ) )
		) description:( '( #( 1 2 3 4 5 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 3 4 ) )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 6 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 3 4 )( 5 6 ) )
		) description:( '( #( 1 2 3 4 5 6 ) asGenerator pairUp:[ :x :y | Array p1: x p2: y ] ) asArray = #( ( 1 2 )( 3 4 )( 5 6 ) )' ) ).

	
! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/23/2013 19:25'!
testrejectC "reject: aBlock"

	"Method Version: keg3.  "
	"Copyright Kjell E God Date today"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today February 28 2000, September 22 1999, 04-21-92"
	
	"For the main comment see below the body of self( this method ).""

	| result |
							""( MT b:#reject: s:self ).""
	^( self abstractGenerator new
		resetBlock:[ self reset ]
		nextBlock:[ result := self next .
			[ ( result notNil )and:[ aBlock value: result ] ]
				whileTrue: [ result := self next ] .
			result 
		] 
	)""return:(					MT e:#reject: s:self )"

		"Return a generator r with the following structure:
			Let self = s.   s = <s1,s2,s3,...> (a sequence of elements)
			Let t(x) be the Boolean result of executing aBlock on x.

			Then r = <r1,r2,r3, ...> = s - A      ( s - A = s minus A )
				where A is the set of all si in s for which t(si) = true.

			In other words return a sequence r of all the elements of s
			that made aBlock return false.   And throw away all the elements
			of s for which aBlock returned true.   In other words reject
			all elements of s that cause aBlock to return true.
		
		KEG2: Moved it from Smalltalk/V 2.0 over to Dolphin 2.1 patch level 2( converted
		spaces to tabs, Got rid of the << See BOOK-: A Little Smalltalk>> testBlock.  ).

		KEG3: Switched from ( result ~= nil ) to ( results notNil ) to take advantage of modern
		Smalltalk optimizations( used in Dolphin ).  Perhaps it works out that ~= was primative
		in Smalltalk/V 2.0 but is not in Dolphin.  But I do know that >>notNil is not inlined in
		Smalltalk/V 2.0 but it is in Dolphin.  So we do it the more modern efficient way."

	
	( self assert:(
		( #(  ) asGenerator reject:[ :x | x even ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator reject:[ :x | x even ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator reject:[ :x | x even ] ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator reject:[ :x | x even ] ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator reject:[ :x | x even ] ) asArray = #( 1 )
		) description:( '( #( 1 2 ) asGenerator reject:[ :x | x even ] ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator reject:[ :x | x even ] ) asArray = #( 1 3 )
		) description:( '( #( 1 2 3 ) asGenerator reject:[ :x | x even ] ) asArray = #( 1 3 )' ) ).

	( self assert:(
		( #( 1 2 3 4 ) asGenerator reject:[ :x | x even ] ) asArray = #( 1 3 )
		) description:( '( #( 1 2 3 4 ) asGenerator reject:[ :x | x even ] ) asArray = #( 1 3 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator reject:[ :x | x even ] ) asArray = #( 1 3 5 )
		) description:( '( #( 1 2 3 4 5 ) asGenerator reject:[ :x | x even ] ) asArray = #( 1 3 5 )' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorRemove' stamp: 'KjellGodo 4/25/2013 17:49'!
testremoveAllC "removeAll: aSequence "

	"Method Version: keg2.  "
	" Copyright Kjell E God 20000917"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020716 , 20000917""
	| answer set fA |
							""MT b:#removeAll: s:self.""

	answer := ( aSequence isParam )
		ifTrue:[ 
			set := aSequence p1 .
			fA := KEGFooArray new .
			( self keysAndValuesDo:[ :i :x |
				( set includes: i )ifTrue:[ fA ]ifFalse:[ x ] ]
			)reject:[ :x | x == fA ] ]
		ifFalse:[
			set := ( ( aSequence isKindOf: Set )or:[ ( aSequence isKindOf: Collection ) and:[ aSequence size < 6 ] ] )
					ifTrue:[ aSequence ]
					ifFalse:[ aSequence asGenerator asSet ] .
			self reject:[ :x | set includes: x ] ] .

							""MT e:#removeAll: s:self.""
	^answer .

	""Remove all the Objects in aSequence from self. aSequence is anything that
	responds to >>isSequence. But actually it can be any Object.
	Or if aSequence is a KEGParam of form-:(
		< seq >
	)-ofform where seq is a sequence of Integer indexes which responds to >>includes:
	then return a new sequence with the elements of self which are not at those indexes
	included.  IE-: all the elements of self at those indexes are excluded from the new
	Generator.  Examples-:  "

	( self assert:(
		( #( a b c d e )asGen removeAll:( #( 1 3 5 )asSet asP ) ) asArray = #( b d )
		) description:( '( #( a b c d e )asGen removeAll:( #( 1 3 5 )asSet asP ) ) asArray = #( b d )' ) ).

	( self assert:(
		( #( a b c d e )asGen removeAll:( #( 2 )asP ) ) asArray = #( a c d e )
		) description:( '( #( a b c d e )asGen removeAll:( #( 2 )asP ) ) asArray = #( a c d e )' ) ).

	( self assert:(
		( #( a b c d e )asGen removeAll:( #( a c e ) asGen ) ) asArray = #( b d )
		) description:( '( #( a b c d e )asGen removeAll:( #( a c e ) asGen ) ) asArray = #( b d )' ) ).

	( self assert:(
		( #( a b c d e )asGen removeAll:( #( a c e ) ) ) asArray = #( b d )
		) description:( '( #( a b c d e )asGen removeAll:( #( a c e ) ) ) asArray = #( b d )' ) ).

	( self assert:(
		( #( a b c d e )asGen removeAll:( #( a c e ) asSet ) ) asArray = #( b d )
		) description:( '( #( a b c d e )asGen removeAll:( #( a c e ) asSet ) ) asArray = #( b d )' ) ).

	( self assert:(
		( #(  )asGen removeAll:( #( a c e ) asSet ) ) asArray = #(  )
		) description:( '( #(  )asGen removeAll:( #( a c e ) asSet ) ) asArray = #(  )' ) ).
! !

!KEGGeneratorTest methodsFor: 'generatorRemove' stamp: 'KjellGodo 4/25/2013 17:49'!
testremoveC "remove: anObject "

	"Method Version: keg1.  "
	" Copyright Kjell E God 20000917"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20000917"

	"Remove anObject from self.""

	| answer |
							""MT b:#remove: s:self.""

	answer := self reject:[ :x | x == anObject ] .

							""MT e:#remove: s:self.""
	^answer .

	"
	( self assert:(
		( #(  ) asGenerator remove: 2 ) asArray = #(  )
		) description:( '( #(  ) asGenerator remove: 2 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 2 ) asGenerator remove: 2 ) asArray = #(  )
		) description:( '( #( 2 ) asGenerator remove: 2 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator remove: 2 ) asArray = #( 1 )
		) description:( '( #( 1 2 ) asGenerator remove: 2 ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 2 1 ) asGenerator remove: 2 ) asArray = #( 1 )
		) description:( '( #( 2 1 ) asGenerator remove: 2 ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 2 1 2 3 2 4 ) asGenerator remove: 2 ) asArray = #( 1 3 4 )
		) description:( '( #( 2 1 2 3 2 4 ) asGenerator remove: 2 ) asArray = #( 1 3 4 )' ) ).
! !

!KEGGeneratorTest methodsFor: 'generatorRemove' stamp: 'KjellGodo 4/25/2013 17:49'!
"(| defineMethod-:(" testremoveFirstC "removeFirst: anInteger "")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God Feb 19, 1994
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030201, Feb 19, 1994
	)-notes methodBody-:(
 (| let-:(""| first temp start size |"")
    letBody-:("					"( MT b:#removeFirst: s:self ).""

	^(
		( ( anInteger isKindOf: BlockClosure )or:[ anInteger respondsTo: #value: ] )
		ifTrue:[
			self abstractGenerator new
				resetBlock:[ self reset . [ ( first := self next ) notNil and:[ anInteger value:( first ) ] ] whileTrue:[  ]  ]
				nextBlock:[ first == nil ifTrue:[ self next ]ifFalse:[ temp := first . first := nil . temp ] ] ]ifFalse:[
		( ( self isOnAStream )and:[ ( start := anInteger + 1 ) <= ( size := self size ) ] ) ""<---( Speed optimization in case self is on a Stream.  Further optimizations happen if self is on a Stream on an Array. )""
		ifTrue:[ 
			(
			( self generator contentsKEG""<---( If size of Stream = readLimit then no copy is done. or something. )""
			) copyFrom:( start )to:( size ) 
			) asGenerator ]
		ifFalse:[
			self abstractGenerator new
				resetBlock:[ self reset . 1 to: anInteger do:[ :i | self next ]  ]
				nextBlock:[ self next ]
		] ]

	)""return:( 					MT e:#removeFirst: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	Return a Generator with the first anInteger elements of self removed.
        If anInteger is a Context then return a Generator with all the elements of self after
        the initial elements that caused anInteger to return true.
 )-summary
 methodDescriptionDetail-:(
	Some speed optimizations happen if self is on a Stream.  Some few more happen
	if self is on a Stream on an Array.
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG3-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg3
	(| KEG2-:( Changes onDate-:( 20030201 )
		madeChanges-:( added the >>isOnAStream speed optimizations. )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( #(  ) asGenerator removeFirst:[ :x | x <= 2 ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator removeFirst:[ :x | x <= 2 ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator removeFirst:[ :x | x <= 2 ] ) asArray = #(  )
		) description:( '( #( 1 ) asGenerator removeFirst:[ :x | x <= 2 ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator removeFirst:[ :x | x <= 2 ] ) asArray = #(  )
		) description:( '( #( 1 2 ) asGenerator removeFirst:[ :x | x <= 2 ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator removeFirst:[ :x | x <= 2 ] ) asArray = #( 3 )
		) description:( '( #( 1 2 3 ) asGenerator removeFirst:[ :x | x <= 2 ] ) asArray = #( 3 )' ) ).

	( self assert:(
		( #( 1 2 3 4 ) asGenerator removeFirst:[ :x | x <= 2 ] ) asArray = #( 3 4 )
		) description:( '( #( 1 2 3 4 ) asGenerator removeFirst:[ :x | x <= 2 ] ) asArray = #( 3 4 )' ) ).
	
	( self assert:(
		( #(  ) asGenerator removeFirst: 2 ) asArray = #(  )
		) description:( '( #(  ) asGenerator removeFirst: 2 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator removeFirst: 2 ) asArray = #(  )
		) description:( '( #( 1 ) asGenerator removeFirst: 2 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator removeFirst: 2 ) asArray = #(  )
		) description:( '( #( 1 2 ) asGenerator removeFirst: 2 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator removeFirst: 2 ) asArray = #( 3 )
		) description:( '( #( 1 2 3 ) asGenerator removeFirst: 2 ) asArray = #( 3 )' ) ).

	( self assert:(
		( #( 1 2 3 4 ) asGenerator removeFirst: 2 ) asArray = #( 3 4 )
		) description:( '( #( 1 2 3 4 ) asGenerator removeFirst: 2 ) asArray = #( 3 4 )' ) ).

	( self assert:(
		( ( #(  ) asGen collect:[ :x | x + 1 ] ) removeFirst: 2 ) asArray = #(  )
		) description:( '( ( #(  ) asGen collect:[ :x | x + 1 ] ) removeFirst: 2 ) asArray = #(  )' ) ).

	( self assert:(
		( ( #( 0 ) asGen collect:[ :x | x + 1 ] ) removeFirst: 2 ) asArray = #(  )
		) description:( '( ( #( 0 ) asGen collect:[ :x | x + 1 ] ) removeFirst: 2 ) asArray = #(  )' ) ).

	( self assert:(
		( ( #( 0 1 ) asGen collect:[ :x | x + 1 ] ) removeFirst: 2 ) asArray = #(  )
		) description:( '( ( #( 0 1 ) asGen collect:[ :x | x + 1 ] ) removeFirst: 2 ) asArray = #(  )' ) ).

	( self assert:(
		( ( #( 0 1 2 ) asGen collect:[ :x | x + 1 ] ) removeFirst: 2 ) asArray = #( 3 )
		) description:( '( ( #( 0 1 2 ) asGen collect:[ :x | x + 1 ] ) removeFirst: 2 ) asArray = #( 3 )' ) ).

	( self assert:(
		( ( #( 0 1 2 3 ) asGen collect:[ :x | x + 1 ] ) removeFirst: 2 ) asArray = #( 3 4 )
		) description:( '( ( #( 0 1 2 3 ) asGen collect:[ :x | x + 1 ] ) removeFirst: 2 ) asArray = #( 3 4 )' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorRemove' stamp: 'KjellGodo 4/25/2013 17:49'!
"(| defineMethod-:(" testremoveFirstIntoC "removeFirstInto: aBlock "")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God 20030210
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030306, 20030210
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#removeFirstInto: s:self ).""
	^(
		( self abstractGenerator new 
		) resetBlock:[ aBlock value:( self first ) ]
		  nextBlock:[ self next ]

	)""return:( 					MT e:#removeFirstInto: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a new sequence that is the same as self but with the first element removed
	and passed into aBlock which is any Object that respondsTo: #value: .

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(

		| gen first |
		( gen := ( aGenerator removeFirstInto:[ :f | first := f ] ) )
	will pass the first element of aGenerator back to the method that is creating
	gen.  So that >>removeFirstInto: works more like the Collection version of
	>>removeFirst than the Generator version of >>removeFirst .

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG3-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg3
	(| KEG2-:( Changes onDate-:( <D:20030306> ) theOldCode-:( 
			'firstBlock:[ ( aBlock value:( self first ) ).( self next )' 
		)wasReplacedBy-:( 
			'resetBlock:[ aBlock value:( self first )' 
		) )-chg )-keg2
 )-changes
 testCases-:( "

	| first |

	( self assert:( 
		( ( ( #(  ) asGenerator removeFirstInto:[ :x | first := x ] ) asArray = #(  ) )and:[ first = nil ] )
		) description:( '( ( ( #(  ) asGenerator removeFirstInto:[ :x | first := x ] ) asArray = #(  ) )and:[ first = nil ] )' ) ).

	( self assert:( 
		( ( ( #( 1 ) asGenerator removeFirstInto:[ :x | first := x ] ) asArray = #(  ) )and:[ first = 1 ] )
		) description:( '( ( ( #( 1 ) asGenerator removeFirstInto:[ :x | first := x ] ) asArray = #(  ) )and:[ first = 1 ] )' ) ).

	( self assert:( 
		( ( ( #( 1 2 ) asGenerator removeFirstInto:[ :x | first := x ] ) asArray = #( 2 ) )and:[ first = 1 ] )
		) description:( '( ( ( #( 1 2 ) asGenerator removeFirstInto:[ :x | first := x ] ) asArray = #( 2 ) )and:[ first = 1 ] )' ) ).

	( self assert:( 
		( ( ( #( 1 2 3 ) asGenerator removeFirstInto:[ :x | first := x ] ) asArray = #( 2 3 ) )and:[ first = 1 ] )
		) description:( '( ( ( #( 1 2 3 ) asGenerator removeFirstInto:[ :x | first := x ] ) asArray = #( 2 3 ) )and:[ first = 1 ] )' ) ).

	( self assert:( 
		( ( ( ( #( 1 2 3 ) asGenerator removeFirstInto:[ :x | first := x ] ) inject:( first )into:[ :sum :x | sum + x ] ) = 6 )and:[ first = 1 ] ) "<---[ Good if first is hard to make.  Not so in this case ]"
		) description:( '( ( ( ( #( 1 2 3 ) asGenerator removeFirstInto:[ :x | first := x ] ) inject:( first )into:[ :sum :x | sum + x ] ) = 6 )and:[ first = 1 ] )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorRemove' stamp: 'KjellGodo 4/23/2013 20:14'!
testremoveLast "removeLast"

	"Method Version: keg1.  "
	"Copyright Kjell E God Feb 19 1994"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020716, Feb 19 1994""
	| answer next nextNext |

						""MT b:#removeLast s:self .""

	answer := self abstractGenerator new
		resetBlock:[ nextNext := self first ]
		nextBlock:[ 
			( next := nextNext )ifNotNil:[ ( nextNext := self next )ifNotNil:[ next ] ]
		] .

						""MT e:#removeLast s:self .""
	^answer .

	""Return a Generator with the last element of self removed. ( PLEASE-NOTE-:
	You cannot use self-:( this method ) with Generators like those produced by
	KEGGenerator>>next: which return the same OrderedCollection over and over
	all the time.  In that case self-:( this method ) reverts to >>removeFirst.
	In that case you can do-:(
		( nextGen collect:[ :oc | oc copy ] ) removeLast
	)-cando and that is the only way I can think of to do it. )-pleaseNote"

	"
	(| KEG2-: It looks like self-:( this method )
	has never ever been used since it was made because it removes the first element
	and not the last.  So it must have just been a copy of self>>removeFirst .  So
	totally rewrote self-:( this method ) to make it remove the last element of self.
	Perhaps self-:( this method ) should be used as a new simpler way to look out for
	the end of the Generator.  Much simpler than the ways that are being used now I
	think. So new versions of old Generator methods that look ahead for the end of
	self perhaps should be made. )-keg2
	"

	( self assert:(
		( #(  ) asGenerator removeLast asArray = #(  ) )
		) description:( '( #(  ) asGenerator removeLast asArray = #(  ) )' ) ).

	( self assert:(
		( #( 1 ) asGenerator removeLast asArray = #(  ) )
		) description:( '( #( 1 ) asGenerator removeLast asArray = #(  ) )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator removeLast asArray = #( 1 ) )
		) description:( '( #( 1 2 ) asGenerator removeLast asArray = #( 1 ) )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator removeLast asArray = #( 1 2 ) )
		) description:( '( #( 1 2 3 ) asGenerator removeLast asArray = #( 1 2 ) )' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorRemove' stamp: 'KjellGodo 4/25/2013 17:49'!
"(| defineMethod-:(" testremoveLastIntoC "removeLastInto: aBlock "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030210
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030210
	)-notes methodBody-:(
 (| let-:(""| next nextNext |"")
    letBody-:("					"( MT b:#removeLastInto: s:self ).""
	^(

		( self abstractGenerator new )
			resetBlock:[ nextNext := self first ]
			nextBlock:[ 
				( next := nextNext )ifNotNil:[ 
					( nextNext := self next )
						ifNil:[ ( aBlock value:( next ) ).( nil ) ]""<---[ nil stops the KEGGenerator ]""
						ifNotNil:[ next ] ]
			]

	)""return:( 					MT e:#removeLastInto: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a new sequence that is the same as self but with the last element
	removed and passed into aBlock which is any Object that respondsTo: #value: .

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(

		| gen last |
		( gen := ( aGenerator removeLastInto:[ :f | last := f ] ) )
	will pass the last element of aGenerator back to the method that is creating
	gen.  So that >>removeLastInto: works more like the Collection version of
	>>removeLast than the Generator version of >>removeLast .

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	| last |
	
	( self assert:( 
		( ( ( #(  ) asGenerator removeLastInto:[ :x | last := x ] ) asArray = #(  ) )and:[ last = nil ] )
		) description:( '( ( ( #(  ) asGenerator removeLastInto:[ :x | last := x ] ) asArray = #(  ) )and:[ last = nil ] )'  ) ).

	( self assert:( 
		( ( ( #( 1 ) asGenerator removeLastInto:[ :x | last := x ] ) asArray = #(  ) )and:[ last = 1 ] )
		) description:( '( ( ( #( 1 ) asGenerator removeLastInto:[ :x | last := x ] ) asArray = #(  ) )and:[ last = 1 ] )'  ) ).

	( self assert:( 
		( ( ( #( 1 2 ) asGenerator removeLastInto:[ :x | last := x ] ) asArray = #( 1 ) )and:[ last = 2 ] )
		) description:( '( ( ( #( 1 2 ) asGenerator removeLastInto:[ :x | last := x ] ) asArray = #( 1 ) )and:[ last = 2 ] )'  ) ).

	( self assert:( 
		( ( ( #( 1 2 3 ) asGenerator removeLastInto:[ :x | last := x ] ) asArray = #( 1 2 ) )and:[ last = 3 ] )
		) description:( '( ( ( #( 1 2 3 ) asGenerator removeLastInto:[ :x | last := x ] ) asArray = #( 1 2 ) )and:[ last = 3 ] )'  ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generator' stamp: 'KjellGodo 4/23/2013 20:24'!
testreset "reset" 

        "Method Version: keg1.  "
        "Copyright Kjell E God April 13, 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today April 13, 1999 "

	"Reset the Read Only Stream self is on."

						"( MT b:#reset s:self ).""

	stop := reuse := false .
	generator reset . ""<------------------------( Read Only Stream Case )"

	"^( self )return:(			MT e:#reset s:self )."

	"^self ."


	( self assert:( 
		( ( #(  ) asGenerator reset ; next )= nil )
		) description:( '( #(  ) asGenerator reset ; next = nil )' ) ).

	( self assert:( 
		( ( #(  ) asGenerator reset ; next ; reset ; next ) = nil )
		) description:( '( #(  ) asGenerator reset ; next ; reset ; next = nil )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator ifNotNil:[ :g | ( ( g reset ; next ) = 1 )and:[ ( ( g next ; next ) = 3 ) and:[ ( g reset ; next ) = 1 ] ] ] )
		) description:( '( #( 1 2 3 ) asGenerator ifNotNil:[ :g | ( ( g reset ; next ) = 1 )and:[ ( ( g next ; next ) = 3 ) and:[ ( g rese ; next ) = 1 ] ] ] )' ) ).

! !

!KEGGeneratorTest methodsFor: 'generatorEvaluation' stamp: 'KjellGodo 4/25/2013 17:50'!
testresetC "reset: resetBlk"

	"Method Version: keg2.  "
	" Copyright Kjell E God 20020205"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint ( 20110709 20:15 ) 20020205""
	| answer deferReset selfGen |
				""MT b:#reset: s:self .""
	( selfGen := self ).""<---[ Bind self to thisContext so it won't convert to nil by garbage collection. ]""
	( deferReset := [ selfGen reset ] ).
	answer := self abstractGenerator new
		resetBlock:[ resetBlk value: deferReset ]
		nextBlock:[ self next ] .

				""MT e:#reset: s:self .""
	^answer .

	""KEG2-: convert ( self reset ) to [ self reset ] such that self This Method
	can do the work of self>>noReset as well if needed so self>>reset: and
	self>>noReset don't need to be used together because self>>reset: can
	do self>>noReset's job also.  Just don't evaluate deferReset from inside
	of resetBlk( comment:-- ( yyyymmdd 20121227 ) I think that it is okay
	to evaluate deferReset inside of resetBlk because I think that it has been
	done before and also the following comments might not be all the way valid
	anymore because of that.  There are several actual usages of self This
	Method.  So if you have access to them I would look at them. )."

	"Return a new Generator on self that has a modified reset process where
	the reset of self is done and then the results are passed in to resetBlk.  In case
	any modification of the reset process of self is to be done.  The default case is
	for ( self reset ) to return nonsense giberish.  But here we break with that
	Generator convension and allow self to have its reset Block return something
	useful and then for that something to be optionally modified by resetBlk.  There
	is no real need for this functionality as of now but hell, it is easily added and
	doesn't corrupt the Generator protocal so what the hell.

	Here is a case that probably should be remembered on the back burner-:

	( selfReset := [ :testBlk | ( testBlk value: locals ) and:[ do some resetting . true ] ] ).
	gen := ( KEGAbstractGenerator new
		resetBlock:[ selfReset ]''<---------[ ( deferReset below = [ self reset ] above ) value above = [ selfReset ] value ]''
		nextBlock:[ get the next element ]
	).

	. . . far far way in some other method a long long time later . . .

	gen := gen reset:[ :deferReset | ( deferReset value ''<---------[ returns selfReset block from gen above ]''
			value:[ :locals | some test( including locals ) ]''<-----[ is testBlk above ]'' )
		ifTrue:[ blablabla ] ] .

	As you can see by passing blocks back and forth you can keep all the resetting
	up to date with each other.  This is a general principle of Blocks.  That's why
	it is often a good default case to pass a null value into a block anyway even if
	you don't have a specific use for it yet.  And the same thing can go for methods.
	Often it can be better to include a dummy parameter that you might use later
	if not now rather than making the method monadic( 0 input parameters )." 

	
	| flag |
	
	( self assert:(
		( ( ( #(  ) asGenerator reset:[ :deferReset | deferReset value ] ) asArray ; asArray ) = #(  ) )
		) description:( '( ( #(  ) asGenerator reset:[ :deferReset | deferReset value ] ) asArray ; asArray = #(  ) )' ) ).

	( self assert:(
		( ( ( #( 1 ) asGenerator reset:[ :deferReset | deferReset value ] ) asArray ; asArray ) = #( 1 ) )
		) description:( '( ( #( 1 ) asGenerator reset:[ :deferReset | deferReset value ] ) asArray ; asArray = #( 1 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 ) asGenerator reset:[ :deferReset | deferReset value ] ) asArray ; asArray ) = #( 1 2 ) )
		) description:( '( ( #( 1 2 ) asGenerator reset:[ :deferReset | deferReset value ] ) asArray ; asArray = #( 1 2 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 ) asGenerator reset:[ :deferReset | deferReset value ] ) asArray ; asArray ) = #( 1 2 3 ) )
		) description:( '( ( #( 1 2 3 ) asGenerator reset:[ :deferReset | deferReset value ] ) asArray ; asArray = #( 1 2 3 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 ) asGenerator reset:[ :deferReset |  ] ) asArray ; asArray ) = #(  ) )
		) description:( '( ( #( 1 2 3 ) asGenerator reset:[ :deferReset |  ] ) asArray ; asArray = #(  ) )' ) ).

	( self assert:(
		( ( ( ( #( 1 2 3 ) asGenerator reset:[ :deferReset | deferReset value . flag := true ] ) collect:[ :x | flag ifTrue:[ flag := false . x ]ifFalse:[ x + 1 ] ] ) asArray ; asArray ) = #( 1 3 4 ) )
		) description:( '( ( ( #( 1 2 3 ) asGenerator reset:[ :deferReset | deferReset value . flag := true ] ) collect:[ :x | flag ifTrue:[ flag := false . x ]ifFalse:[ x + 1 ] ] ) asArray ; asArray = #( 1 3 4 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 ) asGenerator reset:[ :deferReset | flag := true ] ) collect:[ :x | flag ifTrue:[ flag := false . x ]ifFalse:[ x + 1 ] ] ) asArray = #( 1 3 4 ) )
		) description:( '( ( ( #( 1 2 3 ) asGenerator reset:[ :deferReset | flag := true ] ) collect:[ :x | flag ifTrue:[ flag := false . x ]ifFalse:[ x + 1 ] ] ) asArray = #( 1 3 4 ) )' ) ).

	( self assert:(
		( ( ( ( #( 1 2 3 ) asGenerator reset:[ :deferReset | flag := true ] ) collect:[ :x | flag ifTrue:[ flag := false . x ]ifFalse:[ x + 1 ] ] ) asArray ; asArray ) = #(  ) )
		) description:( '( ( ( #( 1 2 3 ) asGenerator reset:[ :deferReset | flag := true ] ) collect:[ :x | flag ifTrue:[ flag := false . x ]ifFalse:[ x + 1 ] ] ) asArray ; asArray = #(  ) )' ) ).

	"Please note that you can do other reseting besides the ( deferReset value ) which
	does a ( self reset ).  You can set Boolean flags and etc things that would be hard
	to reset any other way.  You can see above that the [ :deferReset |  ] case is
	just like the self>>noReset Message as it stops the reset from happening. You can
	also do things like open or close Files or reOpen them."! !

!KEGGeneratorTest methodsFor: 'generatorReverse' stamp: 'KjellGodo 4/24/2013 18:11'!
testreverse "reverse"

        "Method Version: keg2.  "
        "Copyright Kjell E God Jun 25 1994"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today July 26 1999, Jun 25 1994"

	"For the main comment see below the body of self( this method )."
                                                  "( MT b:#reverse s:self ).""
	^(
		( self isOnAStream
			ifTrue:[ self generator asReversedGenerator ]
			ifFalse:[ self asOrderedCollection asReversedGenerator ] )
		""Alternate-: oc := OrderedCollection new.  self reverseDo:[ :x | oc add: x ]. oc asGenerator.""

	)""return:(				MT e:#reverse s:self )"

	"If self = <s1 s2 s3 ...sn-2 sn-1 sn> then return
	r = <sn sn-1 sn-2 ... s3 s2 s1> which is self reversed.
	This is a somewhat unfortunate method to use if self is infinite in length.  Because then reverse is
	undefined because an infinite thing has no end.
	TODO: perhaps you could figure out how to use IndexedCollection>>reverseDo: to speed this 
	method up.
	KEG2: I show below how self( this method ) could be done using reverseDo:. The returned Generator
	may actually be a little svelter and quicker.  But we are keeping on using the asReversedGenerator 
	because I want to keep asReversedGenerator in business.  Also, how do I implement self>>reverseDo:?
	I have to do it using self>>reverse.  I could do asOrderedCollection reverse instead.  But this would
	be like doing asOrderedCollection twice.  It probably doesn't make any performance difference man.
	I'm just keeping asReversedGenerator in business here.  It's irrational but there it is.  I also changed
	the name of self( this method ) from reversed to the ANSI reverse."


	( self assert:(
		#(  ) asGenerator reverse asArray = #(  )
		) description:( '#(  ) asGenerator reverse asArray = #(  )' ) ).

	( self assert:(
		#(  ) asGenerator reverse asOrderedCollection asArray = #(  )
		) description:( '#(  ) asGenerator reverse asOrderedCollection asArray = #(  )' ) ).

	( self assert:(
		#( 1 ) asGenerator reverse asOrderedCollection asArray = #( 1 )
		) description:( '#( 1 ) asGenerator reverse asOrderedCollection asArray = #( 1 )' ) ).

	( self assert:(
		#( 1 2 ) asGenerator reverse asOrderedCollection asArray = #( 2 1 )
		) description:( '#( 1 2 ) asGenerator reverse asOrderedCollection asArray = #( 2 1 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator collect:[ :x | x ] ) reverse asArray = #( 3 2 1 ) 
		) description:( '( #( 1 2 3 ) asGenerator collect:[ :x | x ] ) reverse asArray = #( 3 2 1 )' ) ).

	( self assert:(
		#( 1 2 3 ) asGenerator reverse asOrderedCollection asArray = #( 3 2 1 ) 
		) description:( '#( 1 2 3 ) asGenerator reverse asOrderedCollection asArray = #( 3 2 1 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator reverse collect: nil ) asArray = #( 3 2 1 )  "<---[ nil = [ :x | x ] ]"
		) description:( '( #( 1 2 3 ) asGenerator reverse collect: nil ) asArray = #( 3 2 1 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator reverse collect:[ :x | x ] ) asArray = #( 3 2 1 ) "<---[ collect: thwarts the isOnAStream optimization in asArray that screws things up otherwise ]"
		) description:( '( #( 1 2 3 ) asGenerator reverse collect:[ :x | x ] ) asArray = #( 3 2 1 )' ) ).
! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:50'!
"(| defineMethod-:(" testsectionPrefixesCfromSuffixesC "sectionPrefixes: numPrefixes fromSuffixes: numSuffixes "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030210
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20121228 18:44 ) 20030210
	)-notes methodBody-:(
 (| let-:(""| version1 version2 rwriteStream returnGen last lastOC removePrefixesGen lastOCGen |"")
    letBody-:(""					""( MT b:#sectionPrefixes:fromSuffixes: s:self ).""

	( version1 := [
	    ( rwriteStream := ( Array new:( 1000 ) ) readWriteStream ).
	    ( returnGen := rwriteStream asGenerator ).
	    ( self abstractGenerator new
			firstBlock:[ ( last := false ).
				( self first ) ifNotNil:[ :firstOC |
					( rwriteStream reset ; truncated ; nextPutAll:( firstOC ) ).
					(
					( ( lastOC := ( self next ) ) notNil 
					) ifTrue:[ rwriteStream nextPut:( ( lastOC := lastOC copy ) removeFirst ) ] ""<---[ lastOC might be being reused so we must copy it ]""
					  ifFalse:[ last := true ]
					).
					returnGen ] ]""<---[ firstBlock: ]""
			nextBlock:[
				( last ) ifFalse:[
					( self next ) 
						ifNil:[ ( last := true ).
							( ( lastOC isEmpty ) ifFalse:[
								( rwriteStream reset ; truncated ; nextPutAll:( lastOC ) ).
								returnGen ] ) ]
						ifNotNil:[ :nextOC |
							( rwriteStream reset ; truncated ; nextPutAll:( lastOC ) ).
							( rwriteStream nextPut:( nextOC removeFirst ) ).
							( lastOC := nextOC copy ).""<------------------------------------------------------[ nextOC might be being reused so we must copy it ]""
							returnGen ] ] ]""<---[ nextBlock: ]""
	    )
	] ).

	( version2 := [
	    ( rwriteStream := ( Array new:( 1000 ) ) readWriteStream ).
	    ( returnGen := rwriteStream asGenerator ).
	    ( removePrefixesGen := KEGGenerator streamGenerator removeFirst:( numPrefixes ) ).
	    ( self abstractGenerator new
		firstBlock:[ 
			( self first )ifNotNil:[ :firstOC | ( last := false ).
				( rwriteStream reset ; truncated ; nextPutAll:( firstOC ) ).
				(
				( ( lastOC := ( self next ) ) notNil 
				) ifTrue:[ 	( rwriteStream nextPutAll:( lastOC copyFrom:( 1 )to:( numSuffixes ) ) ).""<---( [_]: Perhaps one could get rid of this extra copy which does a memory allocation, in order to get rid of the extra memory allocation as is the hobby of Generator coders, it seems. )""
						( lastOCGen := ( removePrefixesGen on:( lastOC copy ) ; yourself ) ) ] ""<-------------[ lastOC might be being reused so we must copy it ]""
				  ifFalse:[ last := true ]
				).
				returnGen ] ]""<---[ firstBlock: ]""
		nextBlock:[ 
			( last ) ifFalse:[
				( self next ) 
					ifNil:[ ( last := true ).
						( ( lastOCGen isEmpty ) ifFalse:[
							( rwriteStream reset ; truncated ; nextPutAll:( lastOCGen ) ).""<----------[ Probably won't work in Pharo ]""
							returnGen ] ) ]
					ifNotNil:[ :nextOC | 
						( rwriteStream reset ; truncated ; nextPutAll:( lastOCGen ) ).""<----------[ Probably won't work in Pharo ]""
						( rwriteStream nextPutAll:( nextOC copyFrom:( 1 )to:( numSuffixes ) ) ).
						( lastOCGen := ( removePrefixesGen on:( nextOC copy ) ; yourself ) ).""<---[ nextOC might be being reused so we must copy it ]""
						returnGen ] ] ]""<---[ nextBlock: ]""
	    )
	] ).


	^(
		( ( numPrefixes = 1 )and:[ numSuffixes = 1 ] 
		) ifTrue:[ version1 value ]
		  ifFalse:[ version2 value ]

	)""return:( 					MT e:#sectionPrefixes:fromSuffixes: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	If self = <  <s1 s2 s3...sN> <a1 a2 a3...aM> <b1 b2 b3...bK> <c1 c2 ... > ... >
	then if-:(  numPrefixes = 1  )and-:(  numSuffixes = 1  ) THEN-:
	return r = < <s1 s2 s3...sN a1> < a2 a3...aM b1 > <b2 b3...bK c1> <c2 ... >... >
	where self is assumed to be a sequence of OrderedCollections where the sequence
	might be a single OrderedCollection returned over and over with different contents
	each time( from the ( self next ) message ).
	And each subSequence
	in r is a Generator on a ReadWriteStream which can be converted into an Array
	using collect:[ :g | g asArray ] as shown below in the testCases.

	If-:(  1 < numPrefixes  )and-:(  1 < numSuffixes  )then-: we get something like-:
	return r = < <s1 s2 s3...sN a1 ... aS> < a(P+1) a(P+2)...aM b1 ... bS > <b(P+1) b(P+2)...bK c1> <c2 ... >... >
	where-:(  S = numSuffixes  )and-:(   P = numPrefixes   )
	and a slower algorithm is used than in
	the-:(  numPrefixes = 1  )and-:(  numSuffixes = 1  ) case
	and
	I don't know if that is the sane way to do things or not so for that reason the
	code is sectioned up into versions using local niladic
	BlockClosures( of zero input parameters ).

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(

	self-:( this method ) can be used in cahoots with the KEGGenerator>>sortInto:
	method.  IE-:(    

		(
		(
		( aGeneratorOfCharacters sortInto:( KEGRuleBaseParam new 
		   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
			here:( nil )whenLeaving:( nil ) ;
			''............................................''
		   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
			here:( nil )whenLeaving:( nil )
			)
		) sectionPrefixes:( 1 )fromSuffixes:( 1 )
		) 
		) 

	)-ie which can work if the section prefix( here $. ) of one section really 
	wants
	to be the last element of the previous section.  KEGGenerator>>next: can
	also sometimes be used as a substitute for KEGGenerator>>sortInto:
	which doesn't have the ''section prefix wants to be the sextion end of
	the next section'' problem.  And may in fact be the preferred
	way to go and may well make self-:( this method ) defunct.  Or maybe not.

	See the test case below.  The problem is that >>sortInto: creates a
	Generator that reuses its OrderedCollection over and over with different
	contents each time in response to the >>next Message.  And the above
	code will want to stick the $. at the beginning of each new sub sequence.
	But the >>sectionPrefixes:fromSuffixes: Message removes the $. from
	the beginning of each section and sticks it at the end of the previous one.
	It does this by copying the OrderedCollection from the >>sortInto: Generator
	over and over.  So if you can avoid this copying because your OrderedCollections
	are unique and are not being reused with different contents then you should
	use >>sectionPrefixes:noCopyFromSuffixes: because it will not do all that copying
	and so it should might be faster.

	self This Method probably should have been called >>fromPrefixes:toSuffixes:
	but what are you going to do?

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:( 
		( ( ( #(  ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #(  )
		) description:( '( ( ( #(  ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #(  )' ) ).

	( self assert:( 
		( ( ( #(  ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #(  )
		) description:( '( ( ( #(  ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #(  )' ) ).

	( self assert:( 
		( ( ( #( (  ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( (  ) )
		) description:( '( ( ( #( (  ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( (  ) )' ) ).

	( self assert:( 
		( ( ( #( (  ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( (  ) )
		) description:( '( ( ( #( (  ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( (  ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 ) )
		) description:( '( ( ( #( ( 1 2 3 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 ) )
		) description:( '( ( ( #( ( 1 2 3 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 ) ) 
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 7 ) ( 8 9 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 7 ) ( 8 9 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 7 8 ) ( 9 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 7 8 ) ( 9 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 11 12 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 7 ) ( 8 9 10 ) ( 11 12 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 11 12 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )fromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 7 ) ( 8 9 10 ) ( 11 12 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 11 12 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 7 8 ) ( 9 10 11 ) ( 12 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 11 12 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )fromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 7 8 ) ( 9 10 11 ) ( 12 ) )' ) ).
		
	( KEGGenerator streamGenerator respondsTo: #sortInto: ) ifTrue:[ "<---[ Check if >>sortInto: is implemented yet ]"

	( self assert:( 
		(
		(
		( ( '123.456.789' asSequence ) sortInto:( KEGRuleBaseParam new
			when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ] here:( nil )whenLeaving:( nil ) ;
			when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ] here:( nil )whenLeaving:( nil )
			)
		) sectionPrefixes:( 1 )fromSuffixes:( 1 )
		) collect:[ :oc | oc asArray ]
		) asArray = #( ( $1 $2 $3 $. ) ( $4 $5 $6 $. ) ( $7 $8 $9 ) )
		) description:( '( ''123.456.789'' asCharacter ) sortInto:( KEGRuleBaseParam new' ) ).

	( self assert:( 
		(
		(
		( ( '123.456.789.' asCharacter ) sortInto:( KEGRuleBaseParam new
			when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ] here:( nil )whenLeaving:( nil ) ;
			when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ] here:( nil )whenLeaving:( nil )
			)
		) sectionPrefixes:( 1 )fromSuffixes:( 1 )
		) collect:[ :oc | oc asArray ]
		) asArray = #( ( $1 $2 $3 $. ) ( $4 $5 $6 $. ) ( $7 $8 $9 $. ) )
		) description:( '( ''123.456.789.'' asCharacter ) sortInto:( KEGRuleBaseParam new' ) ).
		
		]"<---[ ifTrue: ]"

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:50'!
"(| defineMethod-:(" testsectionPrefixesCnoCopyFromSuffixesC "sectionPrefixes: numPrefixes noCopyFromSuffixes: numSuffixes "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20121228
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20121228 18:55 )
	)-notes methodBody-:(
 (| let-:(""| version1 version2 rwriteStream returnGen last lastOC removePrefixesGen lastOCGen |"")
    letBody-:(""					""( MT b:#sectionPrefixes:noCopyFromSuffixes: s:self ).""

	( version1 := [
	    ( rwriteStream := ( Array new:( 1000 ) ) readWriteStream ).
	    ( returnGen := rwriteStream asGenerator ).
	    ( self abstractGenerator new
			firstBlock:[ ( last := false ).
				( self first ) ifNotNil:[ :firstOC |
					( rwriteStream reset ; truncated ; nextPutAll:( firstOC ) ).
					(
					( ( lastOC := ( self next ) ) notNil 
					) ifTrue:[ rwriteStream nextPut:( ( lastOC := lastOC ) removeFirst ) ] ""<---[ lastOC can't be being reused so we don't copy it ]""
					  ifFalse:[ last := true ]
					).
					returnGen ] ]""<---[ firstBlock: ]""
			nextBlock:[
				( last ) ifFalse:[
					( self next ) 
						ifNil:[ ( last := true ).
							( ( lastOC isEmpty ) ifFalse:[
								( rwriteStream reset ; truncated ; nextPutAll:( lastOC ) ).
								returnGen ] ) ]
						ifNotNil:[ :nextOC |
							( rwriteStream reset ; truncated ; nextPutAll:( lastOC ) ).
							( rwriteStream nextPut:( nextOC removeFirst ) ).
							( lastOC := nextOC ).""<------------------------------------------------------[ nextOC can't be being reused so we don't copy it ]""
							returnGen ] ] ]""<---[ nextBlock: ]""
	    )
	] ).

	( version2 := [
	    ( rwriteStream := ( Array new:( 1000 ) ) readWriteStream ).
	    ( returnGen := rwriteStream asGenerator ).
	    ( removePrefixesGen := KEGGenerator streamGenerator removeFirst:( numPrefixes ) ).
	    ( self abstractGenerator new
		firstBlock:[ 
			( self first )ifNotNil:[ :firstOC | ( last := false ).
				( rwriteStream reset ; truncated ; nextPutAll:( firstOC ) ).
				(
				( ( lastOC := ( self next ) ) notNil 
				) ifTrue:[ 	( rwriteStream nextPutAll:( lastOC copyFrom:( 1 )to:( numSuffixes ) ) ).""<---( [_]: Perhaps one could get rid of this extra copy which does a memory allocation, in order to get rid of the extra memory allocation as is the hobby of Generator coders, it seems. )""
						( lastOCGen := ( removePrefixesGen on:( lastOC ) ; yourself ) ) ]""<------------[ lastOC can't be being reused so we don't copy it ]""
				  ifFalse:[ last := true ]
				).
				returnGen ] ]""<---[ firstBlock: ]""
		nextBlock:[ 
			( last ) ifFalse:[
				( self next ) 
					ifNil:[ ( last := true ).
						( ( lastOCGen isEmpty ) ifFalse:[
							( rwriteStream reset ; truncated ; nextPutAll:( lastOCGen ) ).""<----------[ Probably won't work in Pharo ]""
							returnGen ] ) ]
					ifNotNil:[ :nextOC | 
						( rwriteStream reset ; truncated ; nextPutAll:( lastOCGen ) ).""<------------------[ Probably won't work in Pharo ]""
						( rwriteStream nextPutAll:( nextOC copyFrom:( 1 )to:( numSuffixes ) ) ).
						( lastOCGen := ( removePrefixesGen on:( nextOC ) ; yourself ) ).""<------------[ nextOC can't be being reused so we don't copy it ]""
						returnGen ] ] ]""<---[ nextBlock: ]""
	    )
	] ).


	^(
		( ( numPrefixes = 1 )and:[ numSuffixes = 1 ] 
		) ifTrue:[ version1 value ]
		  ifFalse:[ version2 value ]

	)""return:( 					MT e:#sectionPrefixes:noCopyFromSuffixes: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	If self = <  <s1 s2 s3...sN> <a1 a2 a3...aM> <b1 b2 b3...bK> <c1 c2 ... > ... >
	then if-:(  numPrefixes = 1  )and-:(  numSuffixes = 1  ) THEN-:
	return r = < <s1 s2 s3...sN a1> < a2 a3...aM b1 > <b2 b3...bK c1> <c2 ... >... >
	where self is assumed to be a sequence of OrderedCollections where the sequence
	MUST NOT be a single OrderedCollection returned over and over with different contents
	each time( from the ( self next ) message ).  All the OrderedCollections must be seperate
	and not equal using ( a == b ) for the equality test.  If this is the case then we don't have
	to do a copy in the loop and that should speed things up a little.
	And each subSequence
	in r is a Generator on a ReadWriteStream which can be converted into an Array
	using collect:[ :g | g asArray ] as shown below in the testCases.

	If-:(  1 < numPrefixes  )and-:(  1 < numSuffixes  )then-: we get something like-:
	return r = < <s1 s2 s3...sN a1 ... aS> < a(P+1) a(P+2)...aM b1 ... bS > <b(P+1) b(P+2)...bK c1> <c2 ... >... >
	where-:(  S = numSuffixes  )and-:(   P = numPrefixes   )
	and a slower algorithm is used than in
	the-:(  numPrefixes = 1  )and-:(  numSuffixes = 1  ) case
	and
	I don't know if that is the sane way to do things or not so for that reason the
	code is sectioned up into versions using local niladic
	BlockClosures( of zero input parameters ).

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(

	self-:( this method ) can't be used in cahoots with the KEGGenerator>>sortInto:
	method.  IE-:(    

		(
		( aGen sortInto:( KEGRuleBaseParam new 
		   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
			here:( nil )whenLeaving:( nil ) ;
			''............................................''
		   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
			here:( nil )whenLeaving:( nil )
			)
		) sectionPrefixes:( 1 )fromSuffixes:( 1 )
		)

	)-ie because >>sortInto: reuses the OrderedCollection that the
	Generator it creates uses over and over with different contents
	each time in response to the >>next message.

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:( 
		( ( ( #(  ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #(  )
		) description:( '( ( ( #(  ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #(  )' ) ).

	( self assert:( 
		( ( ( #(  ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #(  )
		) description:( '( ( ( #(  ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #(  )' ) ).

	( self assert:( 
		( ( ( #( (  ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( (  ) )
		) description:( '( ( ( #( (  ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( (  ) )' ) ).

	( self assert:( 
		( ( ( #( (  ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( (  ) )
		) description:( '( ( ( #( (  ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( (  ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 ) )
		) description:( '( ( ( #( ( 1 2 3 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 ) )
		) description:( '( ( ( #( ( 1 2 3 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 7 ) ( 8 9 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 7 ) ( 8 9 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 7 8 ) ( 9 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 7 8 ) ( 9 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 11 12 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 7 ) ( 8 9 10 ) ( 11 12 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 11 12 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 1 )noCopyFromSuffixes:( 1 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 ) ( 5 6 7 ) ( 8 9 10 ) ( 11 12 ) )' ) ).

	( self assert:( 
		( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 11 12 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 7 8 ) ( 9 10 11 ) ( 12 ) )
		) description:( '( ( ( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 11 12 ) ) asGenerator collect:[ :x | x asOrderedCollection ] ) sectionPrefixes:( 2 )noCopyFromSuffixes:( 2 ) ) collect:[ :x | x asArray ] ) asArray = #( ( 1 2 3 4 5 ) ( 6 7 8 ) ( 9 10 11 ) ( 12 ) )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:51'!
testsectionsEndingWithC "sectionsEndingWith: anObject"

	"Method Version: keg2.  "
	" Copyright Kjell E God 20020423"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20020508, 20020423""
	| answer ""testBlk"" |
							""MT b:#sectionsEndingWith: s:self.""

	answer := ( anObject isKindOf:( [ ] class ) ) ""<---( ( [ ] class ) is more Smalltalk implementation independent than doing-:( BlockClosure ) instead. )""
		ifTrue:[ ""testBlk := anObject p1 . <---( no longer used )""
			self next:[ :x | ( anObject value: x ) not ] ]
		ifFalse:[
			self next:[ :x | ( x = anObject ) not ]
		] .
							""MT e:#sectionsEndingWith: s:self.""
	^answer .
	""Return a sequence of sequences( IE: return a Generator of OrderedCollections(
		unless I am wrong.  See KEGGenerator>>next: for details.  Hopefully
		the helpString is accessible from there now.  If not you will just have to
		try it out or look at the 
		KEGConsolidated1099TaxYearForm>>openOn: if you have an account
		on http://www.eTrade.com and can get access to your 
		Consolidated 1099 Tax Year .pdf form and if 
		KEGConsolidated1099TaxYearForm>>openOn: has been commented
		by the time you read this. ) ).

	It is highly probable that the returned subsequences are the same
	OrderedCollection returned over and over via the >>next Message but with
	different contents each time.  This might cause problems if you are not expecting
	it.  You can get rid of this problem by doing collect:[ :oc | oc asArray ] or
	by collect:[ :oc | oc copy ] if oc is a Collection or collect:[ :oc | oc asOrderedCollection ]
	if oc is a KEGGenerator( see self>>next: to find out if this is a possibility ).  In the
	test cases shown below the oc was an OrderedCollection.
	In this way you cause the missing memory allocations to be done.  The allocations
	are not done in the first place as a speed optimization.

	Suppose self = 
	   <s1 s2 s3 ... sJ s11 s12 ... s1N sJ s21 s22 s23 ... s2M  sJ s31 s32 ... s3P sJ ... >
	and the answer returned from self( this method ) = r = < r0 r1 r2 r3 ... >
	and sJ = anObject
	Then	r0 = <s1 s2 s3 ... sJ>
			r1 = <s11 s12 ... s1N sJ>
			r2 = <s21 s22 s23 ... s2M sJ>
			r3 = <s31 s32 ... s3P sJ>
			etc . . .
			rK = <sK1 sK2 ... sKQ>
		or	rK	  does not exist
	where s1N = s( 1, N ), s23 = s( 2, 3 ), etc . . .
	where sKQ = s( K, Q ) =/= sJ
	where =/= means ''does not equal'' .

	In other words return the ( * sJ ) subSequences which match with self in the
	psuedo regular expression matching pattern-:
		( * sJ )* *

	In other words return all the subSequences of self that end with anObject .
	( I can't remember if anObject is included at the end of the subSequences but
	I think it is. )
	A frequently used function relating to Strings is-:
	( 'someString' containedIn: x )
	Like if you were to do-:
	( someString linesStrGen sectionsEndingWith:[ :ln | 'someString' containedIn: ln ] )
	where someString is some text on seperate lines( ie: it includes 
	( String lineDelimiter ) subSequences ).

   (| noLongerUsed-:
	Please note that P is the Abreviation for KEGParam and in order to get access
	to this abreviation you must include the Abreviations( [_]: should be
	changed to KEGAbreviations ) in the poolDictionaries: of the Class you are
	creating a method for.  See the KEGGenerator Class definition for an example.

	Now you should also note that anObject can be a KEGParam so it can
	participate in the KEGParameter patterns protocals.  As of today
	<D:20020423> if anObject isParam then anObject is expected to have the
	following form-: aKEGParam( aMonadicValuable )
	where aMonadicValuable is anything that responds to the >>value: message.
   )-noLongerUsed 

	(| KEG2-:( Removed the KEGParam stuff and replaced it with ( [  ] class ) .
		because it is so much easier to read in the calling methods. ) ) "


	"Please see the KEGGenerator>>next: method for more details." 

	( self assert:( 
		( #(  ) asGenerator sectionsEndingWith: 1 ) asArray = #(  )
		) description:( '( #(  ) asGenerator sectionsEndingWith: 1 ) asArray = #(  )' ) ).

	( self assert:( 
		( ( #( 1 ) asGenerator sectionsEndingWith: 1 ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) )
		) description:( '( ( #( 1 ) asGenerator sectionsEndingWith: 1 ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) )' ) ).

	( self assert:( 
		( ( #( 1 2 1 ) asGenerator sectionsEndingWith: 1 ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 1 ) )
		) description:( '( ( #( 1 2 1 ) asGenerator sectionsEndingWith: 1 ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 1 ) )' ) ).

	( self assert:( 
		( ( #( 1 2 3 1 4 5 6 ) asGenerator sectionsEndingWith: 1 ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 3 1 ) ( 4 5 6 ) )
		) description:( '( ( #( 1 2 3 1 4 5 6 ) asGenerator sectionsEndingWith: 1 ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 3 1 ) ( 4 5 6 ) )' ) ).

	( self assert:( 
		( ( #( 1 2 3 1 4 5 6 1 ) asGenerator sectionsEndingWith: 1 ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 3 1 ) ( 4 5 6 1 ) )
		) description:( '( ( #( 1 2 3 1 4 5 6 1 ) asGenerator sectionsEndingWith: 1 ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 3 1 ) ( 4 5 6 1 ) )' ) ).

	( self assert:( 
		( #(  ) asGenerator sectionsEndingWith:[ :x | x = 1 ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator sectionsEndingWith:[ :x | x = 1 ] ) asArray = #(  )' ) ).

	( self assert:( 
		( ( #( 1 ) asGenerator sectionsEndingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) )
		) description:( '( ( #( 1 ) asGenerator sectionsEndingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) )' ) ).

	( self assert:( 
		( ( #( 1 2 1 ) asGenerator sectionsEndingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 1 ) )
		) description:( '( ( #( 1 2 1 ) asGenerator sectionsEndingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 1 ) )' ) ).

	( self assert:( 
		( ( #( 1 2 3 1 4 5 6 ) asGenerator sectionsEndingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 3 1 ) ( 4 5 6 ) )
		) description:( '( ( #( 1 2 3 1 4 5 6 ) asGenerator sectionsEndingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 3 1 ) ( 4 5 6 ) )' ) ).

	( self assert:( 
		( ( #( 1 2 3 1 4 5 6 1 ) asGenerator sectionsEndingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 3 1 ) ( 4 5 6 1 ) )
		) description:( '( ( #( 1 2 3 1 4 5 6 1 ) asGenerator sectionsEndingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray  ] ) asArray = #( ( 1 ) ( 2 3 1 ) ( 4 5 6 1 ) )' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/24/2013 19:11'!
testselectC "select: aBlock"

	"Method Version: keg2.  "
	"Copyright Kjell E God 05-20-92"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today September 22 1999, 05-20-92""
	| next |
							""( MT b:#select: s:self ).""
	^( self abstractGenerator new
		resetBlock: [ self reset ]
		nextBlock: [ next := self next .
			[ ( next isNil ) or:[ aBlock value: next ] ]
				whileFalse:[ next := self next ] .
			next
		]
	)""return:(					MT e:#select: s:self )"

		"Return the subsequence of self that includes all the elements
		of self for which aBlock returns true.

		In other words: Return a generator r with the following structure:
			Let self = s.   s = <s1,s2,s3,...> (a sequence of elements)
			Let t(x) be the Boolean result of executing aBlock on x.

			Then r = <r1,r2,r3, ...> = < si in s    &    t( si ) = true >
			r = The subsequence of all si elements of s such that t( si ) is true.

		KEG2: Moved it from Smalltalk/V 2.0 over to Dolphin 2.1 patch level 2( converted
		spaces to tabs, Got rid of the << See BOOK-: A Little Smalltalk>> testBock and
		reduced the number of messages sends in the whileTrue: loop by converting to 
		whileFalse: and changing [ A and: B ] to [ A not or: B not ] )."

	( self assert:(
		( #(  ) asGenerator select:[ :x | x even ] ) asArray = #(  ) 
		) description:( '( #(  ) asGenerator select:[ :x | x even ] ) asArray = #(  ) ' ) ).

	( self assert:(
		( #( 1 ) asGenerator select:[ :x | x even ] ) asArray = #(  ) 
		) description:( '( #( 1 ) asGenerator select:[ :x | x even ] ) asArray = #(  ) ' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator select:[ :x | x even ] ) asArray = #( 2 ) 
		) description:( '( #( 1 2 ) asGenerator select:[ :x | x even ] ) asArray = #( 2 ) ' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator select:[ :x | x even ] ) asArray = #( 2 ) 
		) description:( '( #( 1 2 3 ) asGenerator select:[ :x | x even ] ) asArray = #( 2 ) ' ) ).

	( self assert:(
		( #( 1 2 3 4 ) asGenerator select:[ :x | x even ] ) asArray = #( 2 4 ) 
		) description:( '( #( 1 2 3 4 ) asGenerator select:[ :x | x even ] ) asArray = #( 2 4 ) ' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator select:[ :x | x even ] ) asArray = #( 2 4 ) 
		) description:( '( #( 1 2 3 4 5 ) asGenerator select:[ :x | x even ] ) asArray = #( 2 4 ) ' ) ).

	( self assert:(
		( #( 1 2 3 4 5 6 ) asGenerator select:[ :x | x even ] ) asArray = #( 2 4 6 ) 
		) description:( '( #( 1 2 3 4 5 6 ) asGenerator select:[ :x | x even ] ) asArray = #( 2 4 6 ) ' ) ).

! !

!KEGGeneratorTest methodsFor: 'generatorShuffling' stamp: 'KjellGodo 4/25/2013 17:51'!
"(| defineMethod-:(" testshuffleCwithC "shuffle: shuffleBlock with: secondGenerator "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 04-22-1992
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 04-22-1992
	)-notes methodBody-:(
 (| let-:(""| nextX nextY result secondGen |"")
    letBody-:(""					""( MT b:#shuffle:with: s:self ).""
	( secondGen := secondGenerator asGenerator ).""<---[ A convenience to the sender ]""
	^(
		self abstractGenerator new
			resetBlock:[
				nextX := self first.
				nextY := secondGen first ]
			nextBlock:[
				nextX 
					ifNil:[
						nextY ifNotNil:[ 
							( result := nextY ).( nextY := secondGen next ).
							( result ) ] ]
					ifNotNil:[
						(
							( nextY isNil ) or:[ 
							( shuffleBlock value:( nextX )value:( nextY ) ) ]
						)
							ifTrue:[ ( result := nextX ).( nextX := self next ).( result ) ]
							ifFalse:[ 
								( result := nextY ).( nextY := secondGen next ).
								( result )
							]
					]
			]

	)""return:( 					MT e:#shuffle:with: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	self-:( this method ) can be used to do a merge sort between two sorted
	sequences-:( self , secondGenerator ) .  Or it can be used to do what ever kind
	of shuffling you want.  But the main most obvious use is to do merge sorts.
	I suppose you could also use it in a highway simulation to force cars to yield
	to oncoming traffic like at a yield sign.  etc.

 )-summary
 methodDescriptionDetail-:(

	Return a generator r with the following structure:
               Let self = s.    s = <s1,s2,s3,...>  (a sequence of elements)
               Let secondGenerator = g.   g = <g1,g2,g3,...>
               Let t(x,y) be the Boolean result of executing shuffleBlock
                    on x and y.

               Then r = a sequence of the elements of (s U g),
                    where U is the set union operation.

                    Perhaps the best way to describe r is to describe
                    what happens in the r next message.

                    r is a generator and contains two generators s and g.
                    It also has two instance variables cS and cG.
                    cS is the current value of s and cG is the current value of g.
                    When r is reset then cS gets (s first)
                                               and cG gets (g first).
                    When r gets the next message it executes t(cS, cG).
                    If t(cS,cG) is true then cS is returned and (cS := s next) is
                         executed.
                    If t(cS,cG) is false then cG is returned and (cG := g next) is
                         executed.
                    So either the current s or the current g is returned and then
                    which ever current value was returned is updated by using
                    the next message on its generator.

		If either of the Generators sG or cG runs out of non nil elements
		then the other Generator will be used exclusively until it runs out
		of non nil elements and then r will be shut down and from then
		on will only return nil from the >>next message until r gets the
		>>reset message.

 )-detail
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-: ( Changes onDate-:( ... ) theOldCode-:( ... ) wasReplacedBy-:( ... ) )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:( 
		( ( #(  ) asGenerator shuffle:[ :x :y | x < y ]with: #(  ) ) asArray = #(  ) )
		) description:( '( ( #(  ) asGenerator shuffle:[ :x :y | x < y ]with: #(  ) ) asArray = #(  ) )' ) ).

	( self assert:( 
		( ( #( 1 ) asGenerator shuffle:[ :x :y | x < y ]with: #(  ) ) asArray = #( 1 ) )
		) description:( '( ( #( 1 ) asGenerator shuffle:[ :x :y | x < y ]with: #(  ) ) asArray = #( 1 ) )' ) ).

	( self assert:( 
		( ( #(  ) asGenerator shuffle:[ :x :y | x < y ]with: #( 2 ) ) asArray = #( 2 ) )
		) description:( '( ( #(  ) asGenerator shuffle:[ :x :y | x < y ]with: #( 2 ) ) asArray = #( 2 ) )' ) ).

	( self assert:( 
		( ( #( 1 ) asGenerator shuffle:[ :x :y | x < y ]with: #( 2 ) ) asArray = #( 1 2 ) )
		) description:( '( ( #( 1 ) asGenerator shuffle:[ :x :y | x < y ]with: #( 2 ) ) asArray = #( 1 2 ) )' ) ).

	( self assert:( 
		( ( #( 1 3 5 7 ) asGenerator shuffle:[ :x :y | x < y ]with: #(  ) ) asArray = #( 1 3 5 7 ) )
		) description:( '( ( #( 1 3 5 7 ) asGenerator shuffle:[ :x :y | x < y ]with: #(  ) ) asArray = #( 1 3 5 7 ) )' ) ).

	( self assert:( 
		( ( #(  ) asGenerator shuffle:[ :x :y | x < y ]with: #( 2 4 6 8 ) ) asArray = #( 2 4 6 8 ) )
		) description:( '( ( #(  ) asGenerator shuffle:[ :x :y | x < y ]with: #( 2 4 6 8 ) ) asArray = #( 2 4 6 8 ) )' ) ).

	( self assert:( 
		( ( #( 1 3 5 7 ) asGenerator shuffle:[ :x :y | x < y ]with: #( 2 4 6 8 ) ) asArray = #( 1 2 3 4 5 6 7 8 ) )
		) description:( '( ( #( 1 3 5 7 ) asGenerator shuffle:[ :x :y | x < y ]with: #( 2 4 6 8 ) ) asArray = #(1 2 3 4 5 6 7 8) )' ) ).

	( self assert:( 
		( ( #( 1 3 4 5 7 ) asGenerator shuffle:[ :x :y | x < y ]with: #( 2 6 8 ) ) asArray = #( 1 2 3 4 5 6 7 8 ) )
		) description:( '( ( #( 1 3 4 5 7 ) asGenerator shuffle:[ :x :y | x < y ]with: #( 2 6 8 ) ) asArray = #(1 2 3 4 5 6 7 8) )' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorShuffling' stamp: 'KjellGodo 4/24/2013 19:21'!
testshufflePairWiseCwithC "shufflePairWise: shuffleBlock with: aGenerator"

	"Method Version: keg4.  "
	" Copyright Kjell E God 04-22-1992"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today September 22 1999, Feb  6 1998, 04-22-1992""
	| nextX nextY result answer otherGenerator |
								""MT b: #shufflePairWise:with: s: self .""

	otherGenerator := aGenerator asGenerator . ""<----( KEG4 )""
	answer := self abstractGenerator new
		resetBlock:[ nextX := self first.
				   nextY := otherGenerator first ]
		nextBlock: [ 
			nextX
				ifNil:[ 
					( nextY
						ifNil:[ result := nil ]
						ifNotNil:[ 
							( shuffleBlock value: nextX value: nextY )""<---[ nextX isNil so stop ]""
								ifNil:[ result := nextX := nextY := nil ]
								ifNotNil:[ :bool | 
									bool	ifTrue:[ ( result := nextX ).( nextX := nextY := nil ) ]
										ifFalse:[ ( result := nextY ).( nextX := nextY := nil ) ] ] ] ).
					( result ) ]
				ifNotNil:[ 
					nextY
						ifNil:[ 
							( shuffleBlock value: nextX value: nextY )""<---[ nextY isNil so stop ]""
								ifNil:[ result := nextX := nextY := nil ]
								ifNotNil:[ :bool | 
									bool
										ifTrue:[ ( result := nextX ).( nextX := nextY := nil ) ]
										ifFalse:[ ( result := nextY ).( nextX := nextY := nil ) ] ] ]
						ifNotNil:[ 
							( shuffleBlock value: nextX value: nextY )
								ifTrue:[ ( result := nextX ).( nextX := self next ) ]
								ifFalse:[ ( result := nextY ).( nextY := otherGenerator next ) ] ] .
					result ]
		] .

								""MT e: #shufflePairWise:with: s: self .""
	 ^answer .

	""For main comment <<See Zoomer FILE: c:\teleagnt\text\paperfil.zmr AT: I >> or below the
	body of this method. KEG3: Moved it from Smalltalk/V 2.0 over to Dolphin 2.1 patch level 2( just
	some null touch ups ). KEG4: made it so aGenerator can be any Object."

		"Returns r aGenerator which is Exactly like the one that #shuffle:with:
		would have returned given the same input except that when one of the two
		base generators (self or aGenerator) runs out of elements then the
		shuffleBlock will get nil from that generator.  This is a warning to the
		shuffleBlock that r is going to shut down( return nil from then on ).
		shuffleBlock will then return R which is either
		a Boolean B or nil.    If R = nil then r is shut down and returns nil from
		then on.   If shuffleBlock 
		ever returns nil then the r is shut down and returns nil from then on.
		The other case is R is a Boolean B.
		If  B is true then the next element from self will be returned( could be nil ).
		If B is false then the next element from aGenerator will be returned( could be nil ).
		And after that r will shut down and only return nil( in response to the >>next Message ).
		KEG2: added the case where R is nil using new local var bool. If you change this method
		in future please check the following test code when you are done:

		( OrderedCollection new
			add:( ( #( 1 3 ) asGenerator alternateWith: #( 2 4 ) ) asArray = #(1 2 3 4) ) ;
			add:( ( #( 1 3 5 ) asGenerator alternateWith: #( 2 4 ) ) asArray = #(1 2 3 4) ) ;
			add:( ( #( 1 3 ) asGenerator alternateWith: #( 2 4 5 ) ) asArray = #(1 2 3 4) ) ;
			add:( ( #( 1 3 ) asGenerator alternateWith: #( 2 4 5 6 7 8 9 ) ) asArray = #(1 2 3 4) ) ;
			add:( ( #( 1 3 5 6 7 8 9 ) asGenerator alternateWith: #( 2 4 ) ) asArray = #(1 2 3 4) ) ;
			asArray )"

	"PLEASE-NOTE-: The following are just some somewhat random tests and if any of them breaks for one reason or another it might not be any great harm."

	( self assert:( 
		( #(  ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#(  ) ) asArray = #(  )
		) description:( '( #(  ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#(  ) ) asArray = #(  )' ) ).

	( self assert:( 
		( #( 1 ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#( 2 ) ) asArray = #( 1 2 )
		) description:( '( #( 1 ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#( 2 ) ) asArray = #( 1 2 )' ) ).

	( self assert:( 
		( #( 1 3 ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#( 2 4 ) ) asArray = #( 1 2 3 4 )
		) description:( '( #( 1 3 ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#( 2 4 ) ) asArray = #( 1 2 3 4 )' ) ).

	( self assert:( 
		( #( 1 3 5 7 ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#( 2 4 6 ) ) asArray = #( 1 2 3 4 5 6 7 )
		) description:( '( #( 1 3 5 7 ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#( 2 4 6 ) ) asArray = #( 1 2 3 4 5 6 7 )' ) ).

	( self assert:( 
		( #( 1 3 5 7 ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#( 2 4 6 8 ) ) asArray = #( 1 2 3 4 5 6 7 8 )
		) description:( '( #( 1 3 5 7 ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#( 2 4 6 8 ) ) asArray = #( 1 2 3 4 5 6 7 8 )' ) ).

	( self assert:( 
		( #( 1 3 5 7 ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#( 2 4 6 8 9 ) ) asArray = #( 1 2 3 4 5 6 7 8 )
		) description:( '( #( 1 3 5 7 ) asGenerator shufflePairWise:[ :x :y | x ifNil:[ false ]ifNotNil:[ y ifNil:[ true ]ifNotNil:[ x < y ] ] ] with:#( 2 4 6 8 9 ) ) asArray = #( 1 2 3 4 5 6 7 8 )' ) ).

	( self assert:( 
		( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | y ifNotNil:[ true ] ] with:#(  ) ) asArray = #(  )
		) description:( '( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | y ifNotNil:[ true ] ] with:#(  ) ) asArray = #(  )' ) ).

	( self assert:( 
		( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | true ] with:#(  ) ) asArray = #( 1 )
		) description:( '( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | true ] with:#(  ) ) asArray = #( 1 )' ) ).

	( self assert:( 
		( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | true ] with:#( 5 ) ) asArray = #( 1 2 3 4 )
		) description:( '( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | true ] with:#( 5 ) ) asArray = #( 1 2 3 4 )' ) ).

	( self assert:( 
		( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | true ] with:#( 5 6 ) ) asArray = #( 1 2 3 4 )
		) description:( '( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | true ] with:#( 5 6 ) ) asArray = #( 1 2 3 4 )' ) ).

	( self assert:( 
		( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | true ] with:#( 5 6 7 8 ) ) asArray = #( 1 2 3 4 )
		) description:( '( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | true ] with:#( 5 6 7 8 ) ) asArray = #( 1 2 3 4 )' ) ).

	( self assert:( 
		( #(  ) asGenerator shufflePairWise:[ :x :y | false ] with:#( 5 6 7 8 ) ) asArray = #( 5 )
		) description:( '( #(  ) asGenerator shufflePairWise:[ :x :y | false ] with:#( 5 6 7 8 ) ) asArray = #( 5 )' ) ).

	( self assert:( 
		( #( 1 ) asGenerator shufflePairWise:[ :x :y | false ] with:#( 5 6 7 8 ) ) asArray = #( 5 6 7 8 )
		) description:( '( #( 1 ) asGenerator shufflePairWise:[ :x :y | false ] with:#( 5 6 7 8 ) ) asArray = #( 5 6 7 8 )' ) ).

	( self assert:( 
		( #( 1 2 ) asGenerator shufflePairWise:[ :x :y | false ] with:#( 5 6 7 8 ) ) asArray = #( 5 6 7 8 )
		) description:( '( #( 1 2 ) asGenerator shufflePairWise:[ :x :y | false ] with:#( 5 6 7 8 ) ) asArray = #( 5 6 7 8 )' ) ).

	( self assert:( 
		( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | false ] with:#( 5 6 7 8 ) ) asArray = #( 5 6 7 8 )
		) description:( '( #( 1 2 3 4 ) asGenerator shufflePairWise:[ :x :y | false ] with:#( 5 6 7 8 ) ) asArray = #( 5 6 7 8 )' ) ).

	! !

!KEGGeneratorTest methodsFor: 'generatorShuffling' stamp: 'KjellGodo 4/25/2013 17:51'!
"(| defineMethod-:(" testshuffleRandomC "shuffleRandom: seed "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130101
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130101 18:29 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#shuffleRandom s:self ).""
	^(
		( self shuffleUsingRandom:( self class randomNumberGenerator: seed ) )

	)""return:( 					MT e:#shuffleRandom s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a sequence of the elements of self but in a random order determined
	by the selected random number generator.  The seed can be any integer except
	for zero( i think ).

 )-summary
 methodDescriptionDetail-:(

	Remember that self must have a finite size or there will be an infinite loop
	entered into when the new Generator resets or gets created.  The size of
	self must be finite.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	( change:onDate:madeChanges: keg2 yyyymmdd ( ... ) )---[chg] )---[keg2]
 )-changes
 testCases-:( "

	( self assert:( 
		( #(  ) asGenerator shuffleRandom: 1 ) asArray = #(  )
		) description:( '( #(  ) asGenerator shuffleRandom: 1 ) asArray = #(  )' ) ).

	( self assert:( 
		( #( 1 ) asGenerator shuffleRandom: 1 ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator shuffleRandom: 1 ) asArray = #( 1 )' ) ).

	( self assert:( 
		( #( 1 2 ) asGenerator shuffleRandom: 1 ) asArray = #( 2 1 )
		) description:( '( #( 1 2 ) asGenerator shuffleRandom: 1 ) asArray = #( 2 1 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator shuffleRandom: 1 ) asArray = #( 3 1 2 )
		) description:( '( #( 1 2 3 ) asGenerator shuffleRandom: 1 ) asArray = #( 3 1 2 )' ) ).

	( self assert:( 
		( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator shuffleRandom: 1 ) ifNotNil:[ :g | Array p1: g asArray p2: g asArray ] ) = #( ( 6 7 1 8 2 9 3 4 5 ) ( 9 6 7 1 3 8 2 4 5 ) )
		) description:( '( ( #( 1 2 3 4 5 6 7 8 9 ) asGenerator shuffleRandom: 1 ) ifNotNil:[ :g | Array p1: g asArray p2: g asArray ] ) = #( ( 6 7 1 8 2 9 3 4 5 ) ( 9 6 7 1 3 8 2 4 5 ) )' ) ).

	"If you want the self Generator to be reconsulted at each reset of g then debug and test that functionality of self>>shuffleUsingRandom: here.  There
	are two input flags that can be set.  One for recutting the deck each time a ( g reset ) is done and one for resetting the random number generator each
	time a ( g reset ) is done.  The default is to consult self only once at the beginning and then just keep reshuffling the elements of self each time
	( g asArray ) ie ( g reset ) is done.  That is the default case.

 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'accessing' stamp: 'KjellGodo 4/25/2013 17:16'!
testsize "size"

        "Method Version: keg2.  "
        "Copyright Kjell E God Mar 30, 1993"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Apr 18 1995, Mar 30 1993""
	| answer |
                                                  ""MT b:#size s:self .""

	answer := ( self isOnAStream )
		ifTrue:[ self generator size ]
		ifFalse:[ self inject: 0 into:[ :val :each | val + 1 ] ] .

                                                  ""MT e:#size s:self .""
	^answer .

        ""Return the size of self .   KEG2: got rid of the generator short cut because in the 
	case where the generator is a GeneratorStream and that GeneratorStream has a 
	nil in it then the nil will get counted as an element and will add one to the size 
	which is wrong for Generators.   A Generator can never contain nil except at the
	end.   DEPENDENCIES: this is needed by: Collector>>releaseMe: which is used 
	when workSetLaunchers close otherwise they don't close properly and then they 
	look like they are still open. KEG3: Put the isOnAStream optimization back in
	because KEGGeneratorStream is not used much anymore if at all."


"out:------------ORIGINAL CODE:------------------>

    answer := generator isNil
        ifTrue:[ self inject: 0 into:[ :val :each | val + 1 ] ]
        ifFalse:[ generator size ] .

<--------------original code-------------------------------:"

	
	( self assert:( 
		( #(  ) asGenerator size ) = 0
		) description:( '( #(  ) asGenerator size ) = 0' ) ).

	( self assert:( 
		( #( 1 ) asGenerator size ) = 1
		) description:( '( #( 1 ) asGenerator size ) = 1' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator collect:[ :x | x ] ) size = 3
		) description:( '( #( 1 2 3 ) asGenerator collect:[ :x | x ] ) size = 3' ) ).

	

! !

!KEGGeneratorTest methodsFor: 'generatorCollectionLike' stamp: 'KjellGodo 4/25/2013 17:20'!
"(| defineMethod-:(" testsortBlockC "sortBlock: discriminatorBlk "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20021005
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20021005
	)-notes methodBody-:(
 (| let-:(""| sortedGen |"")
    letBody-:(""					""( MT b:#sortBlock: s:self ).""

	^(
		self abstractGenerator new
			resetBlock:[ 
				( ""sortedGen ifNil:[""
					sortedGen := 
						(	( discriminatorBlk isNil )
								ifTrue:[ ( OrderedCollection new )addAll:( self ) ; yourself ]ifFalse:[
							( discriminatorBlk == #default )
								ifTrue:[ ( SortedCollection new )addAll:( self ) ; yourself ]
							ifFalse:[
								( SortedCollection sortBlock:( discriminatorBlk )
								) addAll:( self ) ; yourself
							]]
						) asGenerator
				""]"" ) reset
			]
			nextBlock:[ sortedGen next ]

	)""return:( 					MT e:#sortBlock: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a sorted cached version of self sorted by the discriminatorBlk which is a
	diadicValuable or the #default Symbol or nil.  
	The sorting and caching is postponed until the returned sequence
	is reset via the >>reset message or the >>first: message or any of the immediate
	iteration messages like >>do: , >>inject:into: , iterate etc.
	If discriminatorBlk is nil then an OrderedCollection is used to do the caching.
	Each time the returned Generator r is reset the sort is redone in case self changed
	during reset. If you don't want the sort to be redone during each reset then do
	( self asOrderedCollection asGenerator ) or
	( self asSortedCollection asGenerator ) or 
	( self asSortedCollection:[ :a :b | a < b ] ) asGenerator

 )-summary
 methodDescriptionDetail-:(

	self-:( this method ) is functionally equivalent to-:(
		( self asOrderedCollection asGenerator )
	)in case discriminatorBlk isNil but self-:( this method ) is slightly slower since 1 
	extra layer of BlockClosures is involved.
	( aSequence sortBlock:( #default ) )
	is functionally equivalent to-: ( aSequence sortBlock:[ :a :b | a < b ] )
	but may be slightly faster( or slower ) since no actual BlockClosure is used.
	See SortedCollection class>>value:value: for more explanations.

 )-detail
 usage-:(

	The default version of descriminatorBlk is [ :a :b | a < b ] but you can just do-:(
		( aSequence sortBlock:( #default ) )
	) if you can't remember it.
	self-:( this method ) can be used with the KEGGenerator>>atAllShuffle: method.
	Several sequences can be sorted via self-:( this method ) or via 
	KEGGenerator>>asSortedCollection .
	And then the results collected into a Generator and the whole mess done over
	via the atAllShuffle: method.  Like-:(
		(	( Array
				p1:( seq1 sortBlock:( descriminator ) )
				p2:( seq2 sortBlock:( descriminator ) )
				p3:( seq3 sortBlock:( descriminator ) )
				p4:( seq4 sortBlock:( descriminator ) )
			)asGenerator atAllShuffle:( descriminator )
		)
	)-like which might make sense if the seqi( i =1...4 ) were coming from files on Disk.
	But the fact that they get cached in RAM makes one want to throw up one's hands
	and just do-:(
		(	( Array
				p1:( seq1 sortBlock:( descriminator ) )
				p2:( seq2 sortBlock:( descriminator ) )
				p3:( seq3 sortBlock:( descriminator ) )
				p4:( seq4 sortBlock:( descriminator ) )
			)inject:( SortedCollection sortBlock:( descriminator ) )
			into:[ :sc :sq | sc addAll: sq . sc ]
		)asGenerator
	)which is the same thing but might be a little faster.  Since the whole thing is in
	RAM all at once anyway.  The >>atAllShuffle: would make more sense if the 4
	sequences were on Disk in 4 seperate files and so you could just do-:(
		(	( Array
				p1:( seq1 )
				p2:( seq2 )
				p3:( seq3 )
				p4:( seq4 )
			)asGenerator atAllShuffle:( descriminator )
		)
	)
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG4-:( Changes onDate-:( ... ) madeChanges-:( ... ) )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( #(  ) asGenerator sortBlock: nil ) asArray = #(  )
		) description:( '( #(  ) asGenerator sortBlock: nil ) asArray = #(  )' ) ).

	( self assert:(
		( #(  ) asGenerator sortBlock: #default ) asArray = #(  )
		) description:( '( #(  ) asGenerator sortBlock: #default ) asArray = #(  )' ) ).

	( self assert:(
		( #(  ) asGenerator sortBlock:[ :a :b | a < b ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator sortBlock:[ :a :b | a < b ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator sortBlock: nil ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator sortBlock: nil ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 ) asGenerator sortBlock: #default ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator sortBlock: #default ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 ) asGenerator sortBlock:[ :a :b | a < b ] ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator sortBlock:[ :a :b | a < b ] ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 3 2 1 ) asGenerator sortBlock: nil ) asArray = #( 3 2 1 )
		) description:( '( #( 3 2 1 ) asGenerator sortBlock: nil ) asArray = #( 3 2 1 )' ) ).

	( self assert:(
		( #( 2 3 1 ) asGenerator sortBlock: #default ) asArray = #( 1 2 3 )
		) description:( '( #( 2 3 1 ) asGenerator sortBlock: #default ) asArray = #( 1 2 3 )' ) ).

	( self assert:(
		( #( 1 3 2 ) asGenerator sortBlock:[ :a :b | a < b ] ) asArray = #( 1 2 3 )
		) description:( '( #( 1 3 2 ) asGenerator sortBlock:[ :a :b | a < b ] ) asArray = #( 1 2 3 )' ) ).

	( self assert:(
		( ( #( 3 2 1 ) asGenerator sortBlock: nil ) asArray ; asArray ) = #( 3 2 1 )
		) description:( '( #( 3 2 1 ) asGenerator sortBlock: nil ) asArray ; asArray = #( 3 2 1 )' ) ).

	( self assert:(
		( ( #( 2 3 1 ) asGenerator sortBlock: #default ) asArray ; asArray ) = #( 1 2 3 )
		) description:( '( #( 2 3 1 ) asGenerator sortBlock: #default ) asArray ; asArray = #( 1 2 3 )' ) ).

	( self assert:(
		( ( #( 1 3 2 ) asGenerator sortBlock:[ :a :b | a < b ] ) asArray ; asArray ) = #( 1 2 3 )
		) description:( '( #( 1 3 2 ) asGenerator sortBlock:[ :a :b | a < b ] ) asArray ; asArray = #( 1 2 3 )' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorCommands' stamp: 'KjellGodo 4/25/2013 17:24'!
teststop "stop"

	"Method Version: keg1.  "
	" Copyright Kjell E God Sep 25 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Sep 25 1999"
									"MT b:#stop s:self.""
	stop  := true .
	reuse ifTrue:[ self class reuse: self ] .

									""MT e:#stop s:self."

	"Private - Tell self to explicitly stop, even though self still has nonNil values that
	it could return via the self>>next method.  If self is to be reused then put self on
	the reuse stack for the class of self."

	( self assert:(
		( #( 1 2 3 ) asGenerator stop ; first ) = 1
		) description:( '( #( 1 2 3 ) asGenerator stop ; first ) = 1' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator first ; stop ; next ) = nil
		) description:( '( #( 1 2 3 ) asGenerator first ; stop ; next ) = nil' ) ).


! !

!KEGGeneratorTest methodsFor: 'converting' stamp: 'KjellGodo 4/25/2013 17:26'!
"(| defineMethod-:(" teststopOnNextReturningC "stopOnNextReturning: anObject "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20110624 yyyymmdd
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110624 23:46 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#stopOnNextReturning: s:self ).""
	^(
		( KEGStopOnNonNilGenerator new 
			stopMatchObject:( anObject ) ;
			resetBlock:[ self reset ]
			nextBlock:[ self next ] ;
			yourself )

	)""return:( 					MT e:#stopOnNextReturning: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a KEGAbstractGenerator r which will stop only when anObject
	is returned by [ self next ] above.  By stop I mean that ( r next ) will
	return nil from then on.

 )-summary
 methodDescriptionDetail-:(

	You still mostly can't have the nil Object in the sequence of a KEGGenerator.
	Every element after nil in most KEGGenerators must also be nil.
	But that is not the case for r that self This Method returns.  So it can have
	nil inside of it and it will not stop so there can be a non nil after a nil.
	See below in the testCases where I try to put a nil into an Array and
	wrap that Array in a KEGGenerator and then wrap that in a Generator
	that stops when it sees a 3.  But inside of the >>asArray Method
	there is a >>do: call and inside that >>do: there is a test for nil
	and so the Generator stops at the nil.  If you want to have a nil like
	Object in a KEGGenerator then you can create a ( nl := KEGFooArray new )
	or any unique Object that you know will not otherwise be in the sequence
	of the Generator.  And then you can designate the nl Object to be your
	private nil in the sequence.
	If you do try to have nil in your sequence, well, there are many checks for
	nil everywhere and if you hit one of those checks then the sequence will
	stop and ( r next ) will return nil from then on.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... ) )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( #(  )asGenerator stopOnNextReturning: 3 ) asArray = #(  )
		) description:( '( #(  )asGenerator stopOnNextReturning: 3 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 )asGenerator stopOnNextReturning: 1 ) asArray = #(  )
		) description:( '( #( 1 )asGenerator stopOnNextReturning: 1 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 )asGenerator stopOnNextReturning: 3 ) asArray = #( 1 )
		) description:( '( #( 1 )asGenerator stopOnNextReturning: 3 ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator stopOnNextReturning: 3 ) asArray = #( 1 2 )
		) description:( '( #( 1 2 3 4 5 ) asGenerator stopOnNextReturning: 3 ) asArray = #( 1 2 )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 ) collect:[ :x | x = 3 ifFalse:[ x ] ] ) asGenerator stopOnNextReturning: 3 ) asArray = #( 1 2 )
		) description:( '( ( #( 1 2 3 4 5 ) collect:[ :x | x = 3 ifFalse:[ x ] ] ) asGenerator stopOnNextReturning: 3 ) asArray = #( 1 2 )' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorTransposing' stamp: 'KjellGodo 4/25/2013 17:28'!
"(| defineMethod-:(" testtranspose "transpose "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030124
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030124
	)-notes methodBody-:(
 (| let-:(""| columnBags distribute1RowToNColumnsGen columnSize |"")
    letBody-:(""					""( MT b:#transpose s:self ).""
	( columnSize := ( self isOnAStream )ifTrue:[ self size ]ifFalse:[ 10 ] ).
	( columnBags := 
		( 1 to:( self first size )""<--------------------------------------------------------------[ if self first isOnAStream this will be quick. ]""
		) collect:[ :na | ( Array new:( columnSize ) )readWriteStream ] ""<---[ self size = the size of each new columnj( as defined below ) . ]""
	).
	( distribute1RowToNColumnsGen := KEGGenerator streamGenerator""<---[ refilled by row below. ]""
		dot:[ :aIj :columnj | columnj nextPut:( aIj ) ]with:( columnBags )""<----[ the imaginary index I is a constant.  So we are taking each element aIj of rowI below and sticking it into the columnj that it is in. ( I is a Natural Number and is an Integer, it's not the imaginary part of a Complex Number. ) ]""
	).
	( self do:[ :rowI | distribute1RowToNColumnsGen on:( rowI ); iterate ] ).""<---[ seq = config ( for the initial usage of self-:( this method ) ) ]""
	^(
		( columnBags )""<---[ Here we mean bags in the >>sortInto: sense of a long narrow grocery bag full of a long loaf of column bread.  We don't mean a sequence of actual instances of the Bag class. ]""

	)""return:( 					MT e:#transpose s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return the transpose of self.  Think Matrixes.  Where rows become columns
	and columns become rows.  Or something like that.  Return an Array of
	WriteStreams on Arrays.

	( View the above code with Wordwrap toggled on or off as needed	)-view

 )-summary
 methodDescriptionDetail-:(

	self is assumed to be a sequence of sequences S.  Where all the sequences S
	have the same size.  Otherwise the-:( self first size ) bit above will need to look
	at all the sizes and find the largest one and use that.  And since
	self-:( this method ) is supposed to be more minimal and quick and not so much
	''More Functional'' in style we continue to assume all the same size.
	They are all of the same size.  So
	self = < r1  r2  r3  r4  ...  rM >
	where r1 = r(1), r2=r(2), r3=r(3), ... etc ...
	where r(i)= <ai1 ai2 ai3...aiN> : <---( ie: the r(i) are ''rows'' by matrix style.
		therefore self is a sequence of rows as far as self-:( this text ) is
		concerned.  the i matrix row index is the same for each aij in r(i) .
		( aij is pronounced ''aye eye jay'' even though the jay looks like an eye
		here.  We need a change of Font to see it better.  We need to go
		non italic. ) ) )
	: where N, the row size, is the same for all the r(i) since they are all the
	same size. <---( ie:   each   =>ROW<=   has size = N )
	THEN-:
	self-:( this method ) returns the-:(

		Array( C1 C2 C3 ... CN )<---( Array of N =>COLUMNS<= )

	)-returnsthe
	where C1 = < a11 a21 a31 ... aM1 ><---( column indexes all the same j=1 )
	and C(j) = < a1j a2j a3j ... aMj > for j = 2 , ... , N-1 <---( C(j) = Cj )
	. . .							<---( Cj = column( j ) )
	and CN = < a1N a2N a3N ... aMN> <------( column N )
	where a( i, j ) = aij <---( : by matrix style i = rowIndex , j = columnIndex )
	<---( pardon if ''eye''---> i    looks just like ''jay''---> j  above.  Copy
		self-:( this text ) to a new Workspace and change its Font using-:
		<PopUpMenu>=> <S>( SelectAll )=> <PopUpMenu>=>
		<C>( Copy )=> <Alt>=> <T>( Tools )=> <W>( Workspace... )=>
		( text should be in the new Workspace in a larger Font but if not-: )=>
		<PopUpMenu>=> <M>=> <End>=> <PageUp>=>
		<F>( Set the Font )=> <Enter> )-pardon

	Where each C( j ), ( ie: column( j ) returned ), is actually a WriteStream on
	an Array.  If you want an Array of Arrays rather than an Array of WriteStreams
	you could just do-:(
		( aGen transpose collect:[ :column | column contentsKEG ] )
		or
		( aGen transpose collect:[ :column | column contents ] )
		if
		you don't care about the minor
		memory allocation based speed optimization( >>contentsKEG may
		skip the >>copy done by contents.  Which might be good for you
		or of no concern according to your situation.  as to whether your
		columns are really large or not.  where larger = a little slower. )-opt .
	)-do .
	We don't do the collect:[ :strm | strm contents ] for you because because
	it is easy for you to do that yourself and if you don't need it or want it
	then you don't have to pay for it.  So we choose efficiency over pretty.
	And also because Stream>>asGenerator often does the job for you
	automatically by making new small KEGGenerators instead of new big
	Arrays-:(
		( aGen transpose collect:[ :column | column asGenerator ] )
		might be faster than
		( aGen transpose collect:[ :column | column contents ] )
	)
	In other words if each element of self is a ROW then return an Array
	full of the COLUMNS.  But if you want to think of it the other way round
	above and switch the indexes then self can be a sequence of COLUMNS
	and the returned Array can be a sequence of ROWS.  Since here ROW
	and COLUMN are purely just something that we say to ourselves to keep
	things straight in our own minds.

	( self-:( this method ) is not lazy  :  It does all the processing right here
	in self-:( this method ) and completely fills in all the returned Arrays
	and Streams. )

 )-detail
 usage-:(

	See KEGGainDelta>>displayOn: for an untested usage idea.
	self-:( this method ) can also be used for Matrixes and you can get
	some idea of the scope available of that sort of thing by looking at
	the KEGVectorizedMath.pac Package.

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG4-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:( 
		( #(  ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #(  )
		) description:( '( #(  ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #(  )' ) ).

	( self assert:( 
		( #( (  )(  ) ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #(  )
		) description:( '( #( (  )(  ) ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #(  )' ) ).

	( self assert:( 
		( #( ( 1 )( 2 ) ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #( ( 1 2 ) )
		) description:( '( #( ( 1 )( 2 ) ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #( ( 1 2 ) )' ) ).

	( self assert:( 
		( #( ( 1 )( 2 )( 3 ) ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #( ( 1 2 3 ) )
		) description:( '( #( ( 1 )( 2 )( 3 ) ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #( ( 1 2 3 ) )' ) ).

	( self assert:( 
		( #( ( 1 2 )( 3 4 )( 5 6 ) ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #( ( 1 3 5 )( 2 4 6 ) )
		) description:( '( #( ( 1 2 )( 3 4 )( 5 6 ) ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #( ( 1 3 5 )( 2 4 6 ) )' ) ).

	( self assert:( 
		( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #( ( 1 4 7 )( 2 5 8 )( 3 6 9 ) )
		) description:( '( #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) ) asGenerator transpose collect:[ :column | column contentsKEG ] ) = #( ( 1 4 7 )( 2 5 8 )( 3 6 9 ) )' ) ).

	( self assert:( 
		(
		#(
			( 1    2   3  4    5 )	"<---[ row 1 ]"
			( 6    7  8   9   10 )	"<---[ row 2 ]"
			( 11 12 13 14 15 )	"<---[ row 3 ]"
		) asGenerator transpose collect:[ :column | column contentsKEG ]
		) =
		#(	( 1 6 11 )	"<---[ column 1 ]"
			( 2 7 12 )	"<---[ column 2 ]"
			( 3 8 13 )	"<---[ column 3 ]"
			( 4 9 14 )	"<---[ column 4 ]"
			( 5 10 15 )	"<---[ column 5 ]"
		)
		) description:( 'big transpose 1' ) ).

	( self assert:( 
		(
		#(	( 1   6   11 )	"<---[ row 1 ]"
			( 2   7   12 )	"<---[ row 2 ]"
			( 3   8   13 )	"<---[ row 3 ]"
			( 4   9   14 )	"<---[ row 4 ]"
			( 5   10  15 )	"<---[ row 5 ]"
		) asGenerator transpose collect:[ :column | column contentsKEG ]
		) =
		#(
			( 1    2    3   4    5 )  "<---[ column 1 ]"
			( 6    7   8    9   10 ) "<---[ column 2 ]"
			(11  12  13  14  15 ) "<---[ column 3 ]"
		)
		) description:( 'big transpose back again 2' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:37'!
"(| defineMethod-:(" testuntilIncludingC "untilIncluding: descriminator "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20040203
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20040203
	)-notes methodBody-:(
 (| let-:(""| quit n |"")
    letBody-:("					"( MT b:#untilIncluding: s:self ).""

	^( self abstractGenerator new 
		resetBlock:[ ( quit := false ).( self reset ) ]
		nextBlock:[
			( quit )ifFalse:[
				(
				( descriminator value:( n := self next ) 
				) ifTrue:[ quit := true ] 
				).( n )
			]
		]

	)""return:( 					MT e:#untilIncluding: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Let self = < s1 s2 s3 . . . SE . . . >
	( descriminator value:( si ) ) = false forAll: i = 1 2 3 ... E-1
	( descriminator value:( sE ) ) = true
	Then
	Return r = < s1 s2 s3 ... SE >

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG4-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( #(  ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 2 ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray = #( 1 2 )
		) description:( '( #( 1 2 ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray = #( 1 2 )' ) ).

	( self assert:(
		( #( 1 2 3 ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray = #( 1 2 3 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 6 7 8 ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 4 5 6 7 8 ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray = #( 1 2 3 )' ) ).

	( self assert:(
		( ( #( 1 2 3 4 5 6 7 8 ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray ; asArray )= #( 1 2 3 )
		) description:( '( #( 1 2 3 4 5 6 7 8 ) asGenerator untilIncluding:[ :i | i = 3 ] ) asArray ; asArray = #( 1 2 3 )' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:38'!
testupToC "upTo: anObject"

	"Method Version: keg1.  "
	"Copyright Kjell E God Jan 18, 1995"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Jan 18, 1995""
	| answer |
							""MT b:#upTo: s:self.""
	answer :=
		( anObject isSequence )
				ifTrue:[ self whileFalse:[ :x | anObject includes: x ] ]ifFalse:[
		( ( anObject isKindOf: BlockClosure ) or:[ anObject respondsTo: #value: ] )
				ifTrue:[ self whileFalse: anObject""[Block]"" ]
		ifFalse:[ self whileFalse:[ :x | x = anObject ] ] ] .

							""MT e:#upTo: s:self.""
	^answer .


		""anObject can be either an arbitrary Object
		or it can be a sequence object that responds to both >>isSequence and >>includes:
		or it can be a single parameter Context.

		Let self = <s1 s2 s3 s4 ...>
		Then return <s1 s2 s3 s4 ... si> where

			[ si+1 = anObject ] == true		if anObject was NOT a Context or a sequence.
			or
			[ anObject value: si+1 ] == true		if anObject was a Context
			or
			[ anObject includes: si+1 ] == true .	if anObject was a sequence.

	When FixedSizedQues are ported over to Dolphin then you can implement a clause above that
	is like the Param( aSequence ) clause of the self>>after: method.  You can also write down an
	alternate using FixedSizedQues to that clause in self>>after: but don't implement it as it is probably
	slower than what is there.  Although it will probably be nicer looking.

		TESTS: "

	( self assert:(
		( #(  ) asGenerator upTo: 4 ) asArray = #(  )
		) description:( '( #(  ) asGenerator upTo: 4 ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator upTo: 4 ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator upTo: 4 ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator upTo: 4 ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 4 5 ) asGenerator upTo: 4 ) asArray = #( 1 2 3 )' ) ).

	( self assert:(
		( #(  ) asGenerator upTo:[ :x | x = 4 ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator upTo:[ :x | x = 4 ] ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator upTo:[ :x | x = 4 ] ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator upTo:[ :x | x = 4 ] ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator upTo:[ :x | x = 4 ] ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 4 5 ) asGenerator upTo:[ :x | x = 4 ] ) asArray = #( 1 2 3 )' ) ).
	
	( self assert:(
		( #(  ) asGenerator upTo: #( 4 5 ) ) asArray = #(  )
		) description:( '( #(  ) asGenerator upTo: #( 4 5 ) ) asArray = #(  )' ) ).

	( self assert:(
		( #( 1 ) asGenerator upTo: #( 4 5 ) ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator upTo: #( 4 5 ) ) asArray = #( 1 )' ) ).

	( self assert:(
		( #( 1 2 3 4 5 ) asGenerator upTo: #( 4 5 ) ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 4 5 ) asGenerator upTo: #( 4 5 ) ) asArray = #( 1 2 3 )' ) ).
! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:39'!
"(| defineMethod-:(" testupToIncludingC "upToIncluding: continueUntilBlk "")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20021211
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20021211
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#upToIncluding: s:self ).""

	^(
		( self next:[ :x | ( continueUntilBlk value:( x ) ) not ] )


	)""return:( 					MT e:#upToIncluding: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a new sequence which is like self being sectioned up into shorter
	sections with a cleaver.  Like chopping up cellery.  continueUntilBlk
	is assumed to be a BlockClosure of one input parameter or any
	monadicValuable( ie: anything which responds to the >>value: message ).

 )-summary
 methodDescriptionDetail-:(

	Suppose self = s = <s1 s2 s3 ... >
		= < s1 s2 s3 ... sN a1 a2 a3 ... aM b1 b2 b3 ... bP ... >
	where let ( continueUntilBlk value: x ) = ( c v:( x ))
	then ( c v:( sN )) = ( c v:( aM )) = ( c v:( bP )) = ... etc = true for all
	{ sN, aM, bP, ... }
	and ( c v:( x )) = false
	for all x in s which are not in this { sN, aM, bP, ... } set.

	Let the sequence returned be-:( r ).

	Then r = < <s1 s2 s3 ... sN> <a1 a2 a3 ... aM> <b1 b2 b3 ... bP> ... >

	where each subsequence is an OrderedCollection OC.  Where OC is
	refilled over and over with different contents.  So if you want individual
	OrderedCollections you have to do-:(
		( ( s upToIncluding:[ :x | ... ] )collect:[ :oc | oc copy ] )
	)
	or something like it.  Or suppose you want the sequence r to be of a single
	Generator reused over and over instead of an OC then do-:(
		( ( s upToIncluding:[ :x | ... ] ) sortIntoChangeOCsToGenerators )
	).
	
	In other words we section up s into OrderedCollections.  We start the
	first OrderedCollection OC and continue stuffing things into it while each
	of them-:( x ) makes ( continueUntilBlk value: x )=false .  As soon as one
	of them makes ( c v:( x ))=true then we stuff it into OC and return OC.
	When the next OC is required then OC is empty out using some kind of
	>>removeAll function.  And refill OC with elements starting with
	a1 where ( c v:( a1 ))=false . etc until we come to ( c v:( aM ))=true
	and then we stuff aM into OC and return OC.  Each subSequence OC
	is returned when the r sequence returned by self-:( this method ) gets
	the >>next message.  ( All Generators return their next element when
	they get the >>next message. )

	self-:( this method ) is a redirection of the KEGGenerator>>next: method
	which may be more self documenting than >>next: .

	continueUntilBlk must be a monadicValuable.  ie: anything that responds
	to the >>value: message .  Usually it will be a BlockClosure of one
	input parameter.

 )-detail
 usage-:(

	See below in the testCases section for simple usage examples.

	Which include how to section up a list of numbers.  You would use your
	own logical test of course, unless you really want to section the numbers
	up according to the modulo 10 being 0.  If you just wanted to make
	sections of 10 out of an interval you would probably do-:(
		( ( 1 to: N )next:( 10 ) )
	)
	instead.  Also it should be noted that the next: method can take all
	sorts of inputs according to the KEGParameter protocal so in general
	when you want to section things up you should probably take a trip
	to KEGGenerator>>next: but be warned that some of the cases have
	lost their documentation when the KEGHelpString stuff quit working
	due to machine dependent pathName errors.  Which were never fixed
	yet.  Partly because we just got pissed off at the whole thing.  At my
	own neglegence of allowing such a like thing to happen.  Which in
	fact amounted to my trying not to have it happen going toes up and
	failing.  Oh well
	fuck it. <---( is the ADD motto.
	just replace the uc with ** if this offends. then, like magic,
	it won't offend you anymore.  actually fuck was a common word in
	the 1600s.  There is a poem where it is used as the name they had
	for vertical hitching posts.  They called it the fucking post and it didn't
	offend them.  They said the f word all the time back then and didn't
	even know it.  So neither do I. )
	So some of the explanations of some of the cases might have to
	be teased out of the next: code still.
	. . . . . . . . . . . . . . . . . . . . . . . . .
	And also an example of how to section up text into sections is shown
	which is actually highly useful just as it is.  And can be used as a template
	for such things.  But here's a shorter one-:(
		(
		(
		( 
		  ( aString linesStrGen )
		) upToIncluding:[ :ln | 'bla' containedIn: ln ]
		) sortIntoChangeOCsToGenerators
		)
			
			""<---( Returns a sequence of reused Generators of lines. )""
	)
	so actually only one single Generator is used over and over for the
	different subSequences <s1 s2 s3 ... sN> <a1 a2 a3 ... aM> etc.  So here we
	see how Generators can save on memory allocations.  But then we just have
	to contend with slow BlockClosure invocations.  Perhaps in Lisp they would
	be faster?  In Corman Lisp perhaps we could just make new bare bones
	versions of BlockClosure that are implemented in assembler to have the
	most minimal invocations which are just glorified gotos.  Which would
	probably make such Generators as fast as any loops.

	Please note the PicoLARC non indentation style of
	parenthesis usage which allows indentations to be removed and replaced
	by simple linearity with each line feeding into the next one.
	Toggle the word wrap off via the-:(
		 RightClick=> <M>( Manipulate )=> <T>( toggle the word wrap )
	)
	manual procedure in order to get the comments out of the way.
	I have been using this PicoLARC style of non indenting
	instead of regular indenting since it was shown to me, ie: it since it
	popped into my head.  And it has been saving me a lot of coding time.
	I can tell you.  It is so much simpler really than indenting.  You can
	easily match up the parenthesis because they are right there in front
	so you just count the leftmost $( and then count the leftmost $) and if the
	numbers match then the parenthesis match.
	So it is easy to match them up just by eyeballing them.  Also You don't
	run out of room to the right, and things just seem to be a whole lot
	easier to read.  So it may blow your head off right when you first
	see it.  And you may well have a fit.  As the dents in your head rupture.
	But if you stay with it long enough to see what is going on you may
	begin to think.  Hey, maybe I will try that.  Except that you may cause
	other people to take fits.  Mayhap you should have your camera ready
	when they come bursting into your space.

	Also please note the convenient way to make Generator test cases.
	Just turn everything into Arrays.  And then match against a litteral
	Array.

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG4-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:(
		( ( ( #(  ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #(  )
		) description:( '( ( ( #(  ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #(  )' ) ).

	( self assert:(
		( ( ( #( 1 ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 ) )
		) description:( '( ( ( #( 1 ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 ) )
		) description:( '( ( ( #( 1 2 ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 3 ) )
		) description:( '( ( ( #( 1 2 3 ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 3 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 4 ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 3 )( 4 ) )
		) description:( '( ( ( #( 1 2 3 4 ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 3 )( 4 ) )' ) ).

	( self assert:(
		( ( ( #( 1 2 3 4 5 ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 3 )( 4 5 ) )
		) description:( '( ( ( #( 1 2 3 4 ) asGenerator ) upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 3 )( 4 5 ) )' ) ).

	( self assert:(
		( ( ( 1 to: 9 ) asGenerator upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) )
		) description:( '( ( ( 1 to: 9 ) asGenerator upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 ) )' ) ).

	( self assert:(
		( ( ( 1 to: 10 ) asGenerator upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 ) )
		) description:( '( ( ( 1 to: 10 ) asGenerator upToIncluding:[ :i | i \\ 3 = 0 ] ) collect:[ :oc | oc asArray ] ) asArray = #( ( 1 2 3 )( 4 5 6 )( 7 8 9 )( 10 ) )' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:40'!
testwhileFalseC "whileFalse: aBlock"

	"Method Version: keg1.  "
	" Copyright Kjell E God 19940505"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 19940505""
	| answer next |
						""MT b:#whileFalse: s:self.""

	answer := self abstractGenerator new
		resetBlock:[ self reset ]
		nextBlock:[ ( next := self next ) == nil ifFalse:[ ( aBlock value: next ) ifFalse:[ next ] ] ] .

						""MT e:#whileFalse: s:self.""
	^answer .

		""Return a generator that keeps returning the next value of self until
		aBlock returns true on the next element of self.  After that it only returns nil .
		In other words self = <s1 s2 s3 ... > then ( self whileFalse: aBlock ) returns
		<s1 s2 s3 s4 ... si >	where [ aBlock value: sj ] == false for j = 1, 2, 3, ... , i  and
		[ aBlock value: si+1 ] == true or si is the last element of self . "

"---------------------Original-Heading-: 				"
		"Method Version: keg1.  "
		"Copyright Kjell E God May  5, 1994"
		"Date of Last Revision: Date today May  5, 1994"

	( self assert:( 
		( #(  ) asGenerator whileFalse:[ :x | x = 4 ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator whileFalse:[ :x | x = 4 ] ) asArray = #(  )' ) ).

	( self assert:( 
		( #( 1 ) asGenerator whileFalse:[ :x | x = 4 ] ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator whileFalse:[ :x | x = 4 ] ) asArray = #( 1 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator whileFalse:[ :x | x = 4 ] ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 ) asGenerator whileFalse:[ :x | x = 4 ] ) asArray = #( 1 2 3 )' ) ).

	( self assert:( 
		( #( 1 2 3 4 5 6 ) asGenerator whileFalse:[ :x | x = 4 ] ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 4 5 6 ) asGenerator whileFalse:[ :x | x = 4 ] ) asArray = #( 1 2 3 )' ) ).

! !

!KEGGeneratorTest methodsFor: 'generatorSectioning' stamp: 'KjellGodo 4/25/2013 17:41'!
testwhileTrueC "whileFalse: aBlock"

	"Method Version: keg1.  "
	" Copyright Kjell E God 19940505"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 19940505""
	| answer next |
						""MT b:#whileFalse: s:self.""

	answer := self abstractGenerator new
		resetBlock:[ self reset ]
		nextBlock:[ ( next := self next ) == nil ifFalse:[ ( aBlock value: next ) ifFalse:[ next ] ] ] .

						""MT e:#whileFalse: s:self.""
	^answer .

		""Return a generator that keeps returning the next value of self until
		aBlock returns true on the next element of self.  After that it only returns nil .
		In other words self = <s1 s2 s3 ... > then ( self whileFalse: aBlock ) returns
		<s1 s2 s3 s4 ... si >	where [ aBlock value: sj ] == false for j = 1, 2, 3, ... , i  and
		[ aBlock value: si+1 ] == true or si is the last element of self . "

"---------------------Original-Heading-: 				"
		"Method Version: keg1.  "
		"Copyright Kjell E God May  5, 1994"
		"Date of Last Revision: Date today May  5, 1994"

	( self assert:( 
		( #(  ) asGenerator whileTrue:[ :x | x < 4 ] ) asArray = #(  )
		) description:( '( #(  ) asGenerator whileTrue:[ :x | x < 4 ] ) asArray = #(  )' ) ).

	( self assert:( 
		( #( 1 ) asGenerator whileTrue:[ :x | x < 4 ] ) asArray = #( 1 )
		) description:( '( #( 1 ) asGenerator whileTrue:[ :x | x < 4 ] ) asArray = #( 1 )' ) ).

	( self assert:( 
		( #( 1 2 3 ) asGenerator whileTrue:[ :x | x < 4 ] ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 ) asGenerator whileTrue:[ :x | x < 4 ] ) asArray = #( 1 2 3 )' ) ).

	( self assert:( 
		( #( 1 2 3 4 5 6 ) asGenerator whileTrue:[ :x | x < 4 ] ) asArray = #( 1 2 3 )
		) description:( '( #( 1 2 3 4 5 6 ) asGenerator whileTrue:[ :x | x < 4 ] ) asArray = #( 1 2 3 )' ) ).

! !

KEGGeneratorTest subclass: #KEGLinkedListGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KEGGeneratorBaseTest'!

!KEGLinkedListGeneratorTest methodsFor: 'initialize-release' stamp: 'KjellGodo 5/1/2013 19:48'!
"(| defineMethod-:(" testAll ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030202
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030202
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#testAll s:self )."

	
	
	"^( self )return:( 				MT e:#testAll s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	testAll the functionality of the KEGLinkedListGenerator.

 )-summary
 methodDescriptionDetail-:(
	detail
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(   PLEASE-NOTE-: This could be a way to reverse sequences but it needs one allocation per sequence element.  Which is not so good."

	( self assert:( 
		( KEGLinkedListGenerator on:( #(  ) inject:( nil )into:[ :link :x | KEGLinkCell new value: x nextLink: link ; yourself ] ) ) asArray = #(  )
		) description:( '( KEGLinkedListGenerator on:( #(  ) inject:( nil )into:[ :link :x | KEGLinkCell new value: x nextLink: link ; yourself ] ) ) asArray = #(  )' ) ).

	( self assert:( 
		( KEGLinkedListGenerator on:( #( 1 ) inject:( nil )into:[ :link :x | KEGLinkCell new value: x nextLink: link ; yourself ] ) ) asArray = #( 1 )
		) description:( '( KEGLinkedListGenerator on:( #( 1 ) inject:( nil )into:[ :link :x | KEGLinkCell new value: x nextLink: link ; yourself ] ) ) asArray = #( 1 )' ) ).

	( self assert:( 
		( KEGLinkedListGenerator on:( #( 1 2 ) inject:( nil )into:[ :link :x | KEGLinkCell new value: x nextLink: link ; yourself ] ) ) asArray = #( 2 1 )
		) description:( '( KEGLinkedListGenerator on:( #( 1 2 ) inject:( nil )into:[ :link :x | KEGLinkCell new value: x nextLink: link ; yourself ] ) ) asArray = #( 2 1 )' ) ).

	( self assert:( 
		( KEGLinkedListGenerator on:( #( 1 2 3 ) inject:( nil )into:[ :link :x | KEGLinkCell new value: x nextLink: link ; yourself ] ) ) asArray = #( 3 2 1 )
		) description:( '( KEGLinkedListGenerator on:( #( 1 2 3 ) inject:( nil )into:[ :link :x | KEGLinkCell new value: x nextLink: link ; yourself ] ) ) asArray = #( 3 2 1 )' ) ).

 " )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGPositionableStreamTest methodsFor: '*KEGGeneratorBaseTest' stamp: 'KjellGodo 5/2/2013 20:25'!
testprevious "previous"

        "Method Version: keg4.  "
        "Copyright Kjell E God Mar 7 1994"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today July 26 1999, Nov 9 1995, Mar 11 1995, Mar 7 1994"
					"( MT b:#previous s:self ).""
	^( 
		( 0 < self position )
			ifTrue: [ ( self pop ).
				    ( self peek ifNil:[ self previous ] ) ]

	)""return:(				MT e:#previous s:self )"

	"Return the nearest previous nonNil element of self and set the
	position to the element previous to that.  If at the beginning of self
	then return nil.             KEG2: added stream == nil stuff.   KEG3: got rid of stream == nil.
	KEG4: got rid of ''stream := self stream .'' and replaced stream with self because of move 
	to Dolphin and the Stream Class instead of the now defunct GeneratorStream Class, also
	cleaned it up using >>pop.

	NOTE: If #next was just recieved then this #previous will return the
	same element as the #next."
	
	( self assert:(
		#(  ) readStream previous = nil
		) description:( '#(  ) readStream previous = nil' ) ).

	( self assert:(
		( #( 1 ) readStream setToEnd ; previous ) = 1
		) description:( '#( 1 ) readStream setToEnd ; previous = 1' ) ).

	( self assert:(
		( #( 1 ) readStream setToEnd ; previous ; previous ) = nil
		) description:( '#( 1 ) readStream setToEnd ; previous ; previous = nil' ) ).

	( self assert:(
		( #( 1 ) readStream setToEnd ; previous ; previous ; next ) = 1
		) description:( '#( 1 ) readStream setToEnd ; previous ; previous ; next = 1' ) ).

	( self assert:(
		( #( 1 ) readStream next ; previous ) = 1
		) description:( '#( 1 ) readStream next ; previous = 1' ) ).

	( self assert:(
		( ( Array p1: 1 p2: nil ) readStream setToEnd ; previous ) = 1
		) description:( '( Array p1: 1 p2: nil ) readStream setToEnd ; previous = 1' ) ).

	( self assert:(
		( ( Array p1: 1 p2: nil ) readStream setToEnd ; previous ; previous ) = nil
		) description:( '( Array p1: 1 p2: nil ) readStream setToEnd ; previous ; previous = nil' ) ).

	
"
--------------------------------------------------------------------------OLD--------------------------------------------------------------->
                    answer := collection at: position .            ""[__]Fast and cheap but narrow.""
                    position := position - 1.
                    answer == nil ifTrue:[ self stream previous ]
                                           ifFalse:[ answer ]
<------------------------------------------------------------------------OLD----------------------------------------------------------------
"! !
